///////////////////////////////////////////////////////////////////////////////
//
//  Class code created by the Xbase++ FormDesigner
//    Creation date: 11.02.2008 Creation time: 16:02:25
//
//  Contents  :
//    This file contains the basic structure for the utilization-level of
//    a form. It may (and should) be modified.
//
///////////////////////////////////////////////////////////////////////////////

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "frdbrtn.ch"


******************************************************************************
* This class is derived from the implementation-level class of the form.
* Instance variables are declared in the _NewForm class.
******************************************************************************
CLASS BankAndAccount FROM _BankAndAccount
   EXPORTED:
     VAR mainWnd
     VAR pensInfo
     VAR recordExists

   EXPORTED:
      METHOD init
      METHOD create
      METHOD GetInvalidXbp
      METHOD OnDoneBtnClicked
ENDCLASS

******************************************************************************
* Initialize form
******************************************************************************
METHOD BankAndAccount:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   LOCAL nPos
   LOCAL onKeyPressed, evalIfDataChanged, replaceNullValue

   ::mainWnd := oOwner
   ::pensInfo := oOwner:possiblePG[2][oOwner:possiblePG[1]]

   * Execute method of the super class
   ::_BankAndAccount:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::index:setInputFocus := ::street:setInputFocus := ::house:setInputFocus := ::building:setInputFocus := ::flat:setInputFocus :=;
   ::bank:setInputFocus := ::desk:setInputFocus := ::account:setInputFocus :=;
                           {|mp1, mp2, obj| obj:XbpSLE:setMarked({1, obj:bufferLength + 1}), obj:setColorBG(INTERFACE_FOCUSCOLOR) }

   ::index:killInputFocus := {|mp1, mp2, obj| obj:setColorBG(XBPSYSCLR_WINDOW),;
                                              Eval({|x| IIf(Empty(x) .OR. Val(x) < 100000 .OR. Val(x) > 199999, obj:setData(""),) }, obj:getData()) }

   ::street:killInputFocus := ::house:killInputFocus := ::building:killInputFocus := ::flat:killInputFocus :=;
                              {|mp1, mp2, obj| obj:setColorBG(XBPSYSCLR_WINDOW),;
                                               obj:setData(Upper(obj:getData())) }

   ::bank:killInputFocus := ::desk:killInputFocus := ::account:killInputFocus := {|mp1, mp2, obj| obj:setColorBG(XBPSYSCLR_WINDOW) }

   onKeyPressed := {|key, xbp, vld, sel| sel := xbp:queryMarked(),;
                                         IIf(xbeK_TAB == key,,;
                                         IIf(xbeK_ENTER == key .OR. sel[1] > xbp:bufferLength,;
                                             PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, xbp),;
                                         IIf(Empty(vld),, Eval(vld, xbp, key)))) }

   ::street:keyBoard := {|key, mp2, obj| Eval(onKeyPressed, key, obj,;
                                              {|sle| ValidateString(sle, {|c| IsDigit(c) .OR. IsAlpha(c) .OR. c $ '-."/' }) }) }

   ::house:keyBoard := {|key, mp2, obj| Eval(onKeyPressed, key, obj,;
                                             {|sle| ValidateString(sle, {|c| IsDigit(c) .OR. IsAlpha(c) .OR. c $ '-"/' }) }) }
   ::building:keyBoard := ::flat:keyBoard :=;
                          {|key, mp2, obj| Eval(onKeyPressed, key, obj,;
                                                {|sle| ValidateString(sle, {|c| IsDigit(c) .OR. IsAlpha(c) }) }) }

   ::bank:keyBoard := ::desk:keyBoard := {|key, mp2, obj| Eval(onKeyPressed, key, obj) }
   ::index:keyBoard :=;
   ::account:keyBoard := {|key, mp2, obj| Eval(onKeyPressed, key, obj, {|sle| ValidateString(sle, {|c| IsDigit(c) }) }) }

   ::btnDone:activate := {|mp1, mp2, obj| ::OnDoneBtnClicked() }
   ::btnExit:activate := {|mp1, mp2, obj| PostAppEvent(xbeP_Close,,, self) }

RETURN self


******************************************************************************
* Request system resources
******************************************************************************
METHOD BankAndAccount:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
    LOCAL oPrinter := XbpPrinter():New(), prnList := oPrinter:list(), cFIO

   * Execute method of the super class
   ::_BankAndAccount:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

    aPos := AppDesktop():currentSize()
    aSize := ::currentSize()
    ::setPos({ (aPos[1] - aSize[1]) / 2, (aPos[2] - aSize[2]) / 2 },.T.)

   nPos := &(::pensInfo[1] + "->(RecNo())")
   &(::pensInfo[1] + "->(DbGoTo(" + AllTrim(Str(::pensInfo[2])) + "))")
   cFIO := &(::pensInfo[1] + "->FAMILY") + &(::pensInfo[1] + "->NAME") + &(::pensInfo[1] + "->NAME2")

   cSeek := "     0" + Str(::pensInfo[5], 6) + Str(::pensInfo[3], 6) + "13" + cFIO
   ::recordExists := info->(DbSeek(cSeek))
   IF ::recordExists
     ::index:setData(IIf(Empty(info->IND), "", Str(info->IND)))
     ::street:setData(info->ADDRESS)
     ::house:setData(info->HOUSE)
     ::building:setData(info->CORPUS)
     ::flat:setData(info->FLAT)
     ::bank:setData(Val(Left(info->FILIAL, 4)))
     ::desk:setData(Val(SubStr(info->FILIAL, 6, 4)))
     ::account:setData(info->NOLIC)
   ELSE
     ::index:setData("")
     ::street:setData("")
     ::house:setData("")
     ::building:setData("")
     ::flat:setData("")
     ::bank:setData(0)
     ::desk:setData(0)
     ::account:setData("")
   ENDIF

   IF ::mainWnd:accessLevel < 1
     ::btnDone:disable()
   ENDIF

   &(::pensInfo[1] + "->(DbGoTo(" + AllTrim(Str(nPos)) + "))")
   PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, self)

RETURN self

METHOD BankAndAccount:GetInvalidXbp()
   LOCAL aResult := {}

   AEval({::bank/*, ::desk*/},;
         {|xbp| IIf(xbp:isEnabled() .AND. Empty(xbp:getData()), AAdd(aResult, xbp),) })
   IIf(::account:isEnabled() .AND. Len(AllTrim(::account:getData())) <> 20, AAdd(aResult, ::account),)

RETURN aResult

METHOD BankAndAccount:OnDoneBtnClicked()
   LOCAL nPos, aInvalid := ::GetInvalidXbp(), lLocked := .F.

   IF !Empty(aInvalid)
     ShowNotification(self, aInvalid[1]:currentPos(), "  ")
     RETURN
   ENDIF

   IF ::recordExists
     lLocked := info->(RLock())
   ELSE
     nPos := &(::pensInfo[1] + "->(RecNo())")
     &(::pensInfo[1] + "->(DbGoTo(" + AllTrim(Str(::pensInfo[2])) + "))")

     lLocked := info->(FLock())

     info->(DbAppend())
     info->PERSONID := 0
     info->PENSID := IIf(::pensInfo[1] <> "civ", 0, civ->ID)
     info->PG := IIf(::pensInfo[1] <> "rpd", 0, rpd->PG)
     info->RELATION := 13
     info->FAMILY := &(::pensInfo[1] + "->FAMILY")
     info->NAME := &(::pensInfo[1] + "->NAME")
     info->NAME2 := &(::pensInfo[1] + "->NAME2")

     &(::pensInfo[1] + "->(DbGoTo(" + AllTrim(Str(nPos)) + "))")
   ENDIF

   IF lLocked
     IF INTERFACE_ALLOWNOTIFICATIONS
       info->IND := Val(::index:getData())
       info->ADDRESS := PadR(::street:GetData(), ::street:bufferLength)
       info->HOUSE := PadR(::house:GetData(), ::house:bufferLength)
       info->CORPUS := PadR(::building:GetData(), ::building:bufferLength)
       info->FLAT := PadR(::flat:GetData(), ::flat:bufferLength)
     ENDIF
     info->FILIAL := PadR(StrTran(Str(::bank:GetData(), 4) + "/" + Str(::desk:GetData(), 4), " ", "0"), 10)
     info->NOLIC := PadR(::account:GetData(), ::account:bufferLength)
     info->DATE := Date()
     info->USER := ::mainWnd:user[1]
     info->(DbUnlock())
   ENDIF

   PostAppEvent(xbeP_Close,,, self)

RETURN

//EOF
/////