///////////////////////////////////////////////////////////////////////////////
//
//  Class code created by the Xbase++ FormDesigner
//    Creation date: 11.02.2008 Creation time: 16:02:25
//
//  Contents  :
//    This file contains the basic structure for the utilization-level of
//    a form. It may (and should) be modified.
//
///////////////////////////////////////////////////////////////////////////////

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "frdbrtn.ch"


******************************************************************************
* This class is derived from the implementation-level class of the form.
* Instance variables are declared in the _NewForm class.
******************************************************************************
CLASS CivPens FROM _CivPens
   EXPORTED:
    //
    VAR mainWnd
    //
//        VAR ranks
        //  
        VAR districts
    //
    VAR statuses
    //
//    VAR articles

   EXPORTED:
      METHOD init
      METHOD create
      METHOD OnAddBtnClicked
      METHOD OnChangeBtnClicked
      METHOD OnRemoveBtnClicked
      METHOD GetInvalidXbp
ENDCLASS

******************************************************************************
* Initialize form
******************************************************************************
METHOD CivPens:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   LOCAL onKeyPressed, onKeyPressedEx, evalIfDataChanged, replaceNullValue

   ::mainWnd := oOwner
   ::ranks := oOwner:ranks
   ::districts := oOwner:districts
   ::statuses := oOwner:statuses
   ::articles := oOwner:articles

   * Execute method of the super class
   ::_CivPens:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::day:setNumLimits(0, 31)
   ::month:setNumLimits(0, 12)
   ::year:setNumLimits(0, Year(Date()))
   ::serviceTimeTotal:setNumLimits(0, 99)
   ::serviceTimeChrono:setNumLimits(0, 99)

   ::family:setInputFocus := ::name:setInputFocus := ::name2:setInputFocus :=;
   ::day:setInputFocus := ::month:setInputFocus := ::year:setInputFocus :=;
   ::serviceTimeTotal:setInputFocus := ::serviceTimeChrono:setInputFocus :=;
                           {|mp1, mp2, obj| obj:XbpSLE:setMarked({1, obj:bufferLength + 1}), obj:setColorBG(INTERFACE_FOCUSCOLOR) }

   ::family:killInputFocus := ::name:killInputFocus := ::name2:killInputFocus :=;
                              {|mp1, mp2, obj| obj:setData(FormatFIO(obj:getData())),;
                                               obj:setColorBG(XBPSYSCLR_WINDOW) }

   ::day:killInputFocus := ::month:killInputFocus := {|mp1, mp2, obj| IIf(obj:getData() < 1, obj:setData(1),), obj:setColorBG(XBPSYSCLR_WINDOW) }
   ::year:killInputFocus := {|mp1, mp2, obj| IIf(obj:getData() < 1900, obj:setData(1900),), obj:setColorBG(XBPSYSCLR_WINDOW) }

   ::serviceTimeTotal:killInputFocus := ::serviceTimeChrono:killInputFocus := {|mp1, mp2, obj| obj:setColorBG(XBPSYSCLR_WINDOW) }

   onKeyPressed := {|key, xbp| IIf(xbeK_ENTER == key, PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, xbp),) }
   onKeyPressedEx := {|key, xbp, tab, vld, sel| sel := xbp:queryMarked(),;
                                                IIf(key $ { xbeK_TAB, xbeK_SH_TAB },,;
                                                IIf(xbeK_ENTER == key .OR. sel[1] > xbp:bufferLength .OR. !Empty(tab),;
                                                    PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, xbp),;
                                                IIf(Empty(vld),, Eval(vld, xbp, key)))) }

   ::family:keyBoard := ::name:keyBoard := ::name2:keyBoard :=;
                        {|key, mp2, obj| Eval(onKeyPressedEx, key, obj, xbeK_SPACE == key,;
                                              {|sle| ValidateString(sle, {|c| IsAlpha(c) .OR. "-" == c }) }) }

   ::day:keyBoard := ::month:keyBoard := ::year:keyBoard :=;
   ::serviceTimeTotal:keyBoard := ::serviceTimeChrono:keyBoard := {|key, mp2, obj| Eval(onKeyPressedEx, key, obj) }

   ::district:keyBoard :=;
   ::status:keyBoard :=;
   ::countWork:keyBoard :=;
   ::rank:keyBoard := ::retirement:keyBoard := {|key, mp2, obj| Eval(onKeyPressed, key, obj) }
//    ::district:itemSelected := ::rank:itemSelected := {|mp1, mp2, obj| ValidateSelection(obj, .T.) }

   ::btnNext:keyBoard := ::btnExit:keyBoard := ::btnAdd:keyBoard :=;
   ::btnPrev:keyBoard := ::btnChange:keyBoard :=;
                {|key, mp2, obj| IIf(xbeK_ENTER == key .OR. xbeK_SPACE == key, PostAppEvent(xbeP_Activate,,, obj),) }

   ::btnAdd:activate := {|mp1, mp2, obj| ::OnAddBtnClicked() }
   ::btnChange:activate := {|mp1, mp2, obj| ::OnChangeBtnClicked() }
   ::btnRemove:activate := {|mp1, mp2, obj| ::OnRemoveBtnClicked() }
   ::btnExit:activate := {|mp1, mp2, obj| /*::OnChangeBtnClicked(), */PostAppEvent(xbeP_Close,,, self) }

RETURN self

******************************************************************************
* Request system resources
******************************************************************************
METHOD CivPens:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
        LOCAL fillComboBox

   * Execute method of the super class
   ::_CivPens:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   aPos := AppDesktop():currentSize()
   aSize := ::currentSize()
   ::setPos({ (aPos[1] - aSize[1]) / 2, (aPos[2] - aSize[2]) / 2 },.T.)

   FillComboBoxFromArray(::districts, ::district)
   FillComboBoxFromArray({ "", ::statuses[2], ::statuses[5] }, ::status)
   FillComboBoxFromArray(::ranks[2], ::rank)
   FillComboBoxFromArray(::articles[1], ::retirement, {|str,i| str + ::articles[2][i] })

   IF ::mainWnd:accessLevel < 1
     ::disabledControls := { ::btnAdd, ::btnChange, ::btnRemove }
   ENDIF

//   ::status:setData({1})
   * Display the form
   ::show()

   PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, self)

RETURN self

METHOD CivPens:GetInvalidXbp()
   LOCAL aResult := {}, aPos, aSize
   LOCAL aSLE := { ::family, ::name, ::name2 }, aCombo := { ::district, ::status, ::rank }

   IF AScan(::statuses, ::status:XbpSLE:getData()) <> 2
     AAdd(aSLE, ::serviceTimeTotal)
     AAdd(aSLE, ::serviceTimeChrono)
     IIf(::ranks[3][AScan(::ranks[2], ::rank:XbpSLE:getData())] < 11 .OR. ::serviceTimeChrono:getData() < 25,;
         AAdd(aCombo, ::retirement),)
   ENDIF

   AEval(aSLE, {|x| IIf(Empty(x:getData()), AAdd(aResult, { x, x:currentPos() }),) })

   AEval(aCombo, {|x| aPos := x:currentPos(), aSize := x:listboxSize(), aPos[2] += aSize[2],;
                      IIf(Empty(x:XbpSLE:getData()), AAdd(aResult, { x, aPos }),) })

RETURN aResult

METHOD CivPens:OnAddBtnClicked()
   LOCAL nID, nPos

   nPos := civ->(RecNo())
   civ->(DbGoTop())

   DO WHILE !civ->(Eof())
     IF civ->STATUS < 0
       ConfirmBox(self, ",    ," + Chr(10) +;
                  "     ",;
                  "", XBPMB_OK, XBPMB_WARNING)
       civ->(DbGoTo(nPos))
       RETURN
     ENDIF
     civ->(DbSkip())
   ENDDO

   civ->(DbGoTo(nPos))

   IF ConfirmBox(self, "  ?" + Chr(10) +;
                 "       .",;
                 "", XBPMB_YESNO, XBPMB_QUESTION) <> XBPMB_RET_YES
     RETURN
   ENDIF

   civ->(OrdSetFocus("cpensid"))
   civ->(DbGoBottom())
   nID := civ->ID + 1

   IF !civ->(FLock())
     RETURN
   ENDIF

   civ->(DbAppend())
   civ->ID := nID
   civ->STATUS := -1
   civ->DATE := Date()
   civ->USER := ::mainWnd:user[1]
   civ->(DbUnlock())

   ::ScatterControls()//Scatter ( ::editControls )

   PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, self)
   PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, self)

RETURN

METHOD CivPens:OnChangeBtnClicked()
   LOCAL aFIO := {}, aInvalid := ::GetInvalidXbp()

   IF !Empty(aInvalid)
     ShowNotification(self, aInvalid[1][2], "  ")
     RETURN
   ENDIF

   IF ConfirmBox(self, "     ?",;
                 "", XBPMB_YESNO, XBPMB_QUESTION) <> XBPMB_RET_YES
     RETURN
   ENDIF

   IF !civ->(RLock())
     RETURN
   ENDIF

   Gather( ::editControls )
   AEval({ ::family, ::name, ::name2 }, {|sle| AAdd(aFIO, PadR(sle:getData(), sle:bufferLength)) })

   civ->FAMILY := aFIO[1]
   civ->NAME := aFIO[2]
   civ->NAME2 := aFIO[3]
   civ->BORN := CtoD(StrTran(Str(::day:getData(), 2) + "." + Str(::month:getData(), 2) + "." + Str(::year:getData(), 4), " ", "0"))
   civ->RN := AScan(::districts, ::district:XbpSLE:getData()) - 1
   civ->STATUS := AScan(::statuses, ::status:XbpSLE:getData())
   civ->VYEAR := Int(::serviceTimeTotal:getData())
   civ->VKAL := Int(::serviceTimeChrono:getData())
   civ->DATE := Date()
   civ->USER := ::mainWnd:user[1]
   civ->(DbUnlock())

RETURN

METHOD CivPens:OnRemoveBtnClicked()

   IF ConfirmBox(self, " ,    ?",;
                 "", XBPMB_YESNO, XBPMB_QUESTION) <> XBPMB_RET_YES
     RETURN
   ENDIF

   IF civ->(FLock())
     civ->(DbDelete())
     civ->(DbUnlock())
     PostAppEvent(xbeP_Activate,,, ::btnNext)
   ENDIF

RETURN


* Include program code for the implementation-level class of the form
//#include "_CIVPENS.PRG"

//EOF
/////