///////////////////////////////////////////////////////////////////////////////
//
//  Class code created by the Xbase++ FormDesigner
//    Creation date: 11.02.2008 Creation time: 16:02:25
//
//  Contents  :
//    This file contains the basic structure for the utilization-level of
//    a form. It may (and should) be modified.
//
///////////////////////////////////////////////////////////////////////////////

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "frdbrtn.ch"

//#define DEFAULT_SERIES        ""
#define PARAM_EXTRA_ORIGINAL        "EXTRA_ORIG"
#define PARAM_VSKTOUR        "VSKTOUR"

#define STATE_SPOILT        2
#define STATE_EXTRA        5


******************************************************************************
* This class is derived from the implementation-level class of the form.
* Instance variables are declared in the _NewForm class.
******************************************************************************
CLASS ExtraDlg FROM _ExtraDlg
   EXPORTED:
    //
    VAR mainWnd
    //
    VAR relations
    //
    VAR states
    //
    VAR users
    //
    VAR blankNumbers
    //
    VAR recepientInfo
    //
    VAR paymentOptions
    //
    VAR paymentInfo
    //
    VAR calcParams
    //
    VAR abu
    //
    VAR bus
    //
    VAR reg
    //
    VAR rec
    //
    VAR params
    //
    VAR updateControls
    //
    VAR disabledControls

   EXPORTED:
      METHOD init
      METHOD create
      METHOD OnExtraBtnClicked
      METHOD OnChangeBtnClicked
      METHOD OnAcknowledgeBtnClicked
      METHOD OnNotificationBtnClicked
      METHOD GetPayments
      METHOD UpdateBrowserData
      METHOD ParseCalcString
      METHOD CheckReference
      METHOD CopyLastSumm
ENDCLASS

******************************************************************************
* Initialize form
******************************************************************************
METHOD ExtraDlg:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   LOCAL onKeyPressed, evalIfDataChanged, replaceNullValue

   ::mainWnd := oOwner
   ::states := { { 0, 1, 2/*, 3, 4*/ }, { "", "", ""/*, " ", ""*/ } }
   ::relations := oOwner:relations
   ::users := oOwner:users
   ::blankNumbers := oOwner:blankNumbers
   ::recepientInfo := oOwner:possiblePG[2][oOwner:possiblePG[1]]
   ::calcParams := {}
   ::rec := oOwner:rec
   ::abu := oOwner:abu
   ::bus := oOwner:bus
   ::reg := oOwner:reg
   ::params := oOwner:params
   ::updateControls := {}
   ::disabledControls := {}
   ::paymentOptions := { 0, {}, {}}

   * Execute method of the super class
   ::_ExtraDlg:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::number:setNumLimits(0, 9999999)

   evalIfDataChanged := {|obj, blk, blk1| IIf(obj:changed, IIf(blk != NIL, Eval(blk),), IIf(blk1 != NIL, Eval(blk1),) ) }

   replaceNullValue := {|obj, val| IIf(obj:XbpSLE:getData() = "", Eval({|obj| obj:setData(val), obj:changed := .T.}, obj),)}

   ::paymentYear:itemSelected := {|mp1, mp2, obj| ::GetPayments() }

   ::payments:itemSelected := {|mp1, mp2, obj| ::UpdateBrowserData() }

   ::browser:setInputFocus := {|mp1, mp2, obj| ::browserSelection:show() }

   ::acknowledged:setInputFocus := ::ackSeries:setInputFocus := ::summCalc:setInputFocus :=;
   ::electronic:setInputFocus :=;
   ::printPensFIO:setInputFocus := ::printNotification :setInputFocus := ;
                                   {|mp1, mp2, obj| obj:setColorBG(INTERFACE_FOCUSCOLOR) }

   ::series:setInputFocus := ::number:setInputFocus := {|mp1, mp2, obj| obj:XbpSLE:setMarked({1, obj:bufferLength + 1}),;
                                                                        obj:setColorBG(INTERFACE_FOCUSCOLOR) }

   ::browser:killInputFocus := {|mp1, mp2, obj| ::browserSelection:hide() }

   ::acknowledged:killInputFocus :=;
   ::electronic:killInputFocus :=;
   ::printPensFIO:killInputFocus := ::printNotification :killInputFocus :=;
                                    {|mp1, mp2, obj| obj:setColorBG(XBPSYSCLR_DIALOGBACKGROUND) }

   ::ackSeries:killInputFocus := {|mp1, mp2, obj| obj:setData(Upper(obj:getData())), obj:setColorBG(XBPSYSCLR_WINDOW) }

   ::summCalc:killInputFocus := {|mp1, mp2, obj| ::ParseCalcString(), obj:setColorBG(XBPSYSCLR_WINDOW) }

   ::series:killInputFocus := {|mp1, mp2, obj| Eval(replaceNullValue, obj, SYS_POR),;
                                               Eval(evalIfDataChanged, obj, {|| IIf(Empty(::number:getData()),, ::CheckReference()) }),;
                                               obj:setColorBG(XBPSYSCLR_WINDOW) }

   ::number:killInputFocus := {|mp1, mp2, obj| Eval(replaceNullValue, obj, 0),;
                                               Eval(evalIfDataChanged, obj, {|| IIf(Empty(::number:getData()),, ::CheckReference()) }),;
                                               obj:setColorBG(XBPSYSCLR_WINDOW) }

   ::browser:itemMarked := {|cell, mp2, obj| mp2 := obj:getData(), IIf(mp2 > 0 .AND. mp2 <= Len(::paymentInfo[1]),;
                                             Eval({|row| ::acknowledged:setData(::paymentInfo[1][row][4]),;
                                             IIf(::paymentInfo[2][row][REGFIELD_USER] < 1000 .OR. ::paymentInfo[2][row][REGFIELD_USER] >= 2000,;
                                             ::acknowledged:disable(), ::acknowledged:enable()),;
                                             IIf(::acknowledged:isEnabled(),, ::btnAcknowledge:disable()) }, mp2),) }

   ::acknowledged:selected := {|chk, mp2, obj| mp2 := ::browser:getData(),;
                                               IIf(mp2 > 0 .AND. mp2 <= Len(::paymentInfo[1]), ::paymentInfo[1][mp2][4] := chk,) }

   ::electronic:selected := {|chk, mp2, obj| AEval({ ::Static111, ::series, ::Static121, ::number, ::Static121_ },;
                                                    IIf(chk, {|obj| obj:hide()}, {|obj| obj:show()})) }

   //   ENTER    
   onKeyPressed := {|key, xbp| IIf(xbeK_ENTER == key, PostAppEvent(xbeP_Keyboard, xbeK_TAB,, xbp),) }

//   ::browser:keyBoard := {|key, mp2, obj| IIf(xbeK_SPACE == key, Eval({||;
//                                          PostAppEvent(xbeP_Selected, !::acknowledged:getData(),, ::acknowledged),;
//                                          ::acknowledged:show() }),) }

   ::paymentYear:keyBoard :=;
   ::payments:keyBoard :=;
   ::acknowledged:keyBoard :=;
   ::series:keyBoard := ::number:keyBoard := {|key, mp2, obj| Eval(onKeyPressed, key, obj) }

   ::summCalc:keyBoard := {|key, mp2, obj| ValidateString(obj, {|c| c $ "1234567890 .,;fcvr'+" },;
                                           { {",", "."}, {";", ""}, {"f", ""}, {"c", ""}, {"v", ""},;
                                             {"r", ""}, {"'", ""}, {"", "."}, {"", "."}, { "+", ::CopyLastSumm() } }),;
                                           Eval(onKeyPressed, key, obj) }

   ::btnExtra:keyBoard := ::btnChange:keyBoard := ::btnExit:keyBoard := ::btnNotification:keyBoard :=;
                {|key, mp2, obj| IIf(xbeK_ENTER == key .OR. xbeK_SPACE == key, PostAppEvent(xbeP_Activate,,, obj),) }

   ::btnExtra:activate := {|mp1, mp2, obj| ::OnExtraBtnClicked(), dbf->(DbUnlock()) }
   ::btnChange:activate := {|mp1, mp2, obj| ::OnChangeBtnClicked(), dbf->(DbUnlock()) }
   ::btnAcknowledge:activate := {|mp1, mp2, obj| ::OnAcknowledgeBtnClicked() }
   ::btnExit:activate := {|mp1, mp2, obj| /*::OnChangeBtnClicked(), */PostAppEvent(xbeP_Close,,, self) }
   ::btnNotification:activate := {|mp1, mp2, obj| ::OnNotificationBtnClicked() }

RETURN self


******************************************************************************
* Request system resources
******************************************************************************
METHOD ExtraDlg:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   LOCAL fillComboBox

   * Execute method of the super class
   ::_ExtraDlg:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   aPos := AppDesktop():currentSize()
   aSize := ::currentSize()
   ::setPos({ (aPos[1] - aSize[1]) / 2, (aPos[2] - aSize[2]) / 2 },.T.)

   FillComboBoxFromListBox(::mainWnd:paymentYear, ::paymentYear)
//   FillComboBoxFromArray(::states[2], ::state)

   ::updateControls := { ::btnExtra, ::btnChange, ::btnAcknowledge, ::btnNotification, ::acknowledged, ::summCalc, ::series, ::number }

   IF ::mainWnd:accessLevel < 1
     ::disabledControls := { ::btnExtra, ::btnChange, ::btnAcknowledge }
   ELSEIF ::mainWnd:accessLevel < 2
     ::disabledControls := { ::btnExtra, ::btnChange }
   ENDIF

   ::paymentYear:setData(::mainWnd:paymentYear:getData())
   ::GetPayments()
   ::series:setData(SYS_POR)

   * Display the form
   ::show()

   PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, self)

RETURN self

METHOD ExtraDlg:OnExtraBtnClicked()
   LOCAL nIndex, nOffset, recordIndex
   LOCAL lActiveRecord := .F., lPensFIO := ::printPensFIO:getData(), lOnPaper := !::electronic:getData()
   LOCAL aRecords, aRecord, aRec, aLocks, cSeek := "", cErrorMessage := "", cBank
   LOCAL dDate := Date(), nSumm := Val(::summResult:getData())
   LOCAL cSer := ::series:getData(), nNum := ::number:getData()
   //LOCAL makeSeek := {|pg, pensid, year| Str(pg, 6) + Str(pensid, 6) + Str(year, 4)/* + "0"*/ }

   IF !IIf(lOnPaper, .T., FrdbGenerateSeriesAndNumber(@cSer, @nNum))
     RETURN
   ENDIF

   aPos := ::btnExtra:currentPos()
   aPos[2] += 21
   IF Empty(nSumm)
     ShowNotification(self, { aPos[1] - 16, aPos[2] }, "  ")
     RETURN
   ELSEIF lOnPaper .AND. (Empty(AllTrim(cSer)) .OR. Empty(nNum))
     ShowNotification(self, { aPos[1] - 144, aPos[2] }, "     ")
     RETURN
   ELSEIF !CheckPrinterStatus(self, ::mainWnd:printers[2][1])
     RETURN
   ENDIF

   aRecords := AClone(::paymentInfo[2])

   aRec := { aRecords[1][REGFIELD_TIPBL], aRecords[1][REGFIELD_S], aRecords[1][REGFIELD_N] }

   AEval(aRecords, {|x| x[REGFIELD_TIPBL] := IIf(lOnPaper, 1, 5), x[REGFIELD_S] := PadR(cSer, 6), x[REGFIELD_N] := nNum, x[REGFIELD_SUMM] := nSumm,;
                        x[REGFIELD_NOTE] := STATE_EXTRA, x[REGFIELD_DATE] := dDate, x[REGFIELD_USER] := ::mainWnd:user[1] })

   aRecord := aRecords[1]

   IF !Empty(aRecord[REGFIELD_PG]) .AND. dbf->(DbSeek(aRecord[REGFIELD_PG]))
     lActiveRecord := Empty(dbf->PREKR)
     IF !dbf->(RLock())
       ConfirmBox(self, " " + SYS_LITERA + "-" + AllTrim(Str(aRecord[REGFIELD_PG])) +;
                        "  /   ." + Chr(10) +;
                        "   .", "", XBPMB_OK, XBPMB_WARNING)
       RETURN
     ENDIF
   ENDIF

   IF ConfirmBox(self, "    " + AllTrim(Str(nSumm)) + " . ?",;
                 "", XBPMB_YESNO, XBPMB_QUESTION, XBPMB_DEFBUTTON2) <> XBPMB_RET_YES
      RETURN
   ENDIF

   cSeek := Str(::mainWnd:user[2], 2) + Str(3, 2) + PadR(aRecord[REGFIELD_S], 6) + Str(aRecord[REGFIELD_N], 10)

   IF lOnPaper .AND. (abu->(DbSeek(cSeek)) .OR. !bus->(DbSeek(cSeek)) .OR. bus->SOST != 1)
     ConfirmBox(self, "       " + Chr(10) +;
                "    ", "", XBPMB_OK, XBPMB_WARNING)
     RETURN
   ENDIF

   aLocks := { { reg->(FLock()), params->(FLock()), rec->(FLock()) },;
               { ::reg, ::params, ::rec },;
               { "farereg.dbf", "payparams.dbf", "base.rec" } }
   IF lOnPaper
     AAdd(aLocks[1], bus->(RLock()))
     AAdd(aLocks[2], ::bus)
     AAdd(aLocks[3], "base.bus")
   ENDIF
   nIndex := AScan(aLocks[1], .F.)
   IF nIndex > 0
     ConfirmBox(self, "     " + aLocks[3][nIndex] + Chr(10) +;
                "   .", "", XBPMB_OK, XBPMB_WARNING)
     AEval(aLocks[2], {|x,i| IIf(aLocks[1][i], (x)->(DbUnlock()),) })
     RETURN
   ENDIF

   AEval(aRecords, {|x| SetRecord(::reg, x, .T., .T.) })
   reg->(DbUnlock())

   IF lActiveRecord
     IF dbf->TP <> 3
       AEval({ { REGFIELD_FAMILY, dbf->FAMILY }, { REGFIELD_NAME, dbf->NAME }, { REGFIELD_NAME2, dbf->NAME2 }, { REGFIELD_DISTRICT, dbf->RN } }, {|x| aRecord[x[1]] := x[2] })
     ELSEIF rpd->(DbSeek(aRecord[REGFIELD_PG]))
       AEval({ { REGFIELD_FAMILY, rpd->GCONAME }, { REGFIELD_NAME, rpd->GNAME }, { REGFIELD_NAME2, rpd->GFNAME }, { REGFIELD_DISTRICT, dbf->RN } }, {|x| aRecord[x[1]] := x[2] })
     ENDIF
   ELSEIF lPensFIO
     IF !Empty(aRecord[REGFIELD_PENSID])
       IF !civ->(DbSeek(aRecord[REGFIELD_PENSID],, "cpensid")) .OR. civ->STATUS <> 5
         cErrorMessage := " ( )     ()."
       ELSEIF !info->(DbSeek("     0" + Str(civ->ID, 6) + "     013" + civ->FAMILY + civ->NAME + civ->NAME2))
         cErrorMessage := "       ."
       ELSE
         AEval({ { REGFIELD_FAMILY, civ->FAMILY }, { REGFIELD_NAME, civ->NAME }, { REGFIELD_NAME2, civ->NAME2 }, { REGFIELD_DISTRICT, civ->RN } }, {|x| aRecord[x[1]] := x[2] })
         aRecord[REGFIELD_BANK] := info->FILIAL
         aRecord[REGFIELD_ACCOUNT] := info->NOLIC
       ENDIF
     ELSEIF !Empty(aRecord[REGFIELD_PG])
       IF !rpd->(DbSeek(aRecord[REGFIELD_PG])) .OR. 1 == rpd->PRICHINA .OR. 3 == rpd->TP
         cErrorMessage := "         ()."
       ELSEIF !info->(DbSeek("     0     0" + Str(rpd->PG, 6) + "13" + rpd->FAMILY + rpd->NAME + rpd->NAME2))
         IF dbf->(DbSeek(rpd->PG)) .AND. Len(dbf->FILIAL) >= 4 .AND. !Empty(dbf->NOLIC)
           AEval({ { REGFIELD_FAMILY, rpd->FAMILY }, { REGFIELD_NAME, rpd->NAME }, { REGFIELD_NAME2, rpd->NAME2 }, { REGFIELD_DISTRICT, rpd->RN } }, {|x| aRecord[x[1]] := x[2] })
           aRecord[REGFIELD_BANK] := dbf->FILIAL
           aRecord[REGFIELD_ACCOUNT] := dbf->NOLIC
         ELSE
           cErrorMessage := "       ."
         ENDIF
       ELSE
         AEval({ { REGFIELD_FAMILY, rpd->FAMILY }, { REGFIELD_NAME, rpd->NAME }, { REGFIELD_NAME2, rpd->NAME2 }, { REGFIELD_DISTRICT, rpd->RN } }, {|x| aRecord[x[1]] := x[2] })
         aRecord[REGFIELD_BANK] := info->FILIAL
         aRecord[REGFIELD_ACCOUNT] := info->NOLIC
       ENDIF
     ENDIF
   ELSEIF !Empty(aRecord[REGFIELD_PG]) .AND. rpd->(DbSeek(aRecord[REGFIELD_PG])) .AND. 3 == rpd->TP
     IF !info->(DbSeek("     0     0" + Str(rpd->PG, 6) + Str(rpd->RODST, 2) + rpd->GCONAME + rpd->GNAME + rpd->GFNAME))
       IF dbf->(DbSeek(rpd->PG)) .AND. Len(dbf->FILIAL) >= 4 .AND. !Empty(dbf->NOLIC)
         AEval({ { REGFIELD_FAMILY, rpd->GCONAME }, { REGFIELD_NAME, rpd->GNAME }, { REGFIELD_NAME2, rpd->GFNAME }, { REGFIELD_DISTRICT, rpd->RN } }, {|x| aRecord[x[1]] := x[2] })
         aRecord[REGFIELD_BANK] := dbf->FILIAL
         aRecord[REGFIELD_ACCOUNT] := dbf->NOLIC
       ELSE
         cErrorMessage := "       ."
       ENDIF
     ELSE
       AEval({ { REGFIELD_FAMILY, rpd->GCONAME }, { REGFIELD_NAME, rpd->GNAME }, { REGFIELD_NAME2, rpd->GFNAME }, { REGFIELD_DISTRICT, rpd->RN } }, {|x| aRecord[x[1]] := x[2] })
       aRecord[REGFIELD_BANK] := info->FILIAL
       aRecord[REGFIELD_ACCOUNT] := info->NOLIC
     ENDIF
   ENDIF

   IF !Empty(cErrorMessage)
     ConfirmBox(self, cErrorMessage, "", XBPMB_OK, XBPMB_WARNING)
     AEval(aLocks[2], {|x,i| IIf(aLocks[1][i], (x)->(DbUnlock()),) }, 2)
     RETURN
   ENDIF

   cSeek := Str(aRecord[REGFIELD_TIPBL], 1) + aRecord[REGFIELD_S] + Str(aRecord[REGFIELD_N], 10)
   IF params->(DbSeek(cSeek))
     DO WHILE Str(params->TIPBL, 1) + params->S + Str(params->N, 10) == cSeek
       IF PARAM_EXTRA_ORIGINAL = params->NAME
         params->VALUE := Str(aRec[REGFIELD_TIPBL], 1) + PadR(aRec[REGFIELD_S], 6) + Str(aRec[REGFIELD_N], 10)
         EXIT
       ENDIF
       params->(DbSkip())
     ENDDO
   ELSE
     AddRecord("params", { { "TIPBL", aRecord[REGFIELD_TIPBL] }, { "S", aRecord[REGFIELD_S] }, { "N", aRecord[REGFIELD_N] }, { "NAME", PARAM_EXTRA_ORIGINAL },;
                           { "TYPE", "C" }, { "SIZE", 16 }, { "VALUE",  Str(aRec[REGFIELD_TIPBL], 1) + PadR(aRec[REGFIELD_S], 6) + Str(aRec[REGFIELD_N], 10) } }, .T.)
//                           { "DATE", aRecord[REGFIELD_DATE] }, { "USER", ::user[1] } }, .T.)
   ENDIF
   params->(DbUnlock())

   AddRecord("rec", { { "PG", aRecord[REGFIELD_PG] }, { "PREKR", IIf(lActiveRecord, 0, 1) }, { "RN", aRecord[REGFIELD_DISTRICT] },;
                      { "DATELIST", CtoD("01.01." + Str(aRecord[REGFIELD_YEAR], 4)) },;
                      { "DATESROK", CtoD("31.12." + Str(aRecord[REGFIELD_YEAR], 4)) },;
                      { "DATEVYSYL", aRecord[REGFIELD_DATE] }, { "PENSIONSUM", aRecord[REGFIELD_SUMM] },;
                      { "TIPBL", aRecord[REGFIELD_TIPBL] }, { "SER", aRecord[REGFIELD_S] },;
                      { "PL", IIf(Empty(aRecord[REGFIELD_N]), "", Str(aRecord[REGFIELD_N], 7)) },;
                      { "KOD", aRecord[REGFIELD_CODE] }, { "CSR", PEV_PARAMS[7] },;
                      { "RAZ", .T. }, /*{ "SYSOP", ::mainWnd:user[1] }, */{ "ISPOLN", ::mainWnd:user[3] },;
                      { "PRIM", 0 } }, .T.)
   //IIf(lActiveRecord,, rec->(DbDelete()))
   rec->(DbUnlock())

   IIf(lActiveRecord,, aRecord[REGFIELD_PG] := 0)

   cBank := GetBank(aRecord[REGFIELD_DISTRICT], aRecord[REGFIELD_BANK], aRecord[REGFIELD_MODE],;
                    ::mainWnd:districts, ::mainWnd:banks, ::mainWnd:banks2districts)
   IF lOnPaper
     AddRecord("bus", { { "RN", 0 }, { "NUSER", ::mainWnd:user[2] }, { "VIDBCO", 3 },;
                        { "SER", aRecord[REGFIELD_S] }, { "NN", aRecord[REGFIELD_N] }, { "SOST", 2 },;
                        { "PG", aRecord[REGFIELD_PG] }, { "FAMILY", aRecord[REGFIELD_FAMILY] },;
                        { "NAME", aRecord[REGFIELD_NAME] }, { "NAME2", aRecord[REGFIELD_NAME2] },;
                        { "SUMMA", aRecord[REGFIELD_SUMM] }, { "KOD", aRecord[REGFIELD_CODE] },;
                        { "DVYSYL", aRecord[REGFIELD_DATE] }, { "RAIN", aRecord[REGFIELD_DISTRICT] + 1 } }, .F.)
     bus->(DbUnlock())

     PrintBlank(self, ::mainWnd:printers[2][1]:devName, ::mainWnd:printers[2][2], ::mainWnd:printers[2][3],;
                { ::mainWnd:printers[2][4], ::mainWnd:printers[2][5] }, aRecord, ::mainWnd:user[3], cBank)
   ENDIF

   IF ::printNotification:getData()
     PrintNotification(self,;
                       ::printers[1][1]:devName, ::printers[1][2], ::printers[1][3], { ::printers[1][4], ::printers[1][5] },;
                       aRecord, ::user[3], cBank, FrdbGetInfo(aRecord))
   ENDIF

   ::GetPayments()

RETURN

METHOD ExtraDlg:OnChangeBtnClicked()
   LOCAL aRecord, aLocks := { {}, {}, {} }, cSeek, nIndex, rel, dDate := Date(), lFound := .F.
   LOCAL makeSeek := {|pg, pensid, year| Str(pg, 6) + Str(pensid, 6) + Str(year, 4)/* + "0"*/ }

   aRecord := ::paymentInfo[2][1]

   IF !Empty(aRecord[REGFIELD_PG]) .AND. dbf->(DbSeek(aRecord[REGFIELD_PG]))
     IF !dbf->(RLock())
       ConfirmBox(self, " " + SYS_LITERA + "-" + AllTrim(Str(aRecord[REGFIELD_PG])) +;
                        "  /   ." + Chr(10) +;
                        "   .", "", XBPMB_OK, XBPMB_WARNING)
       RETURN
     ENDIF
   ENDIF

   IF ConfirmBox(self, " " + AllTrim(aRecord[REGFIELD_S]) + "  " + AllTrim(Str(aRecord[REGFIELD_N])) +;
                 "    " + Chr(10) + "  ?",;
                 "", XBPMB_YESNO, XBPMB_QUESTION, XBPMB_DEFBUTTON2) <> XBPMB_RET_YES
      RETURN
   ENDIF

   cSeek := Eval(makeSeek, aRecord[REGFIELD_PG], aRecord[REGFIELD_PENSID], aRecord[REGFIELD_YEAR])
   IF reg->(DbSeek(cSeek))
     DO WHILE Eval(makeSeek, reg->PG, reg->PENSID, reg->YEAR) == cSeek
       IF reg->TIPBL == 1 .AND. reg->S == aRecord[REGFIELD_S] .AND. reg->N == aRecord[REGFIELD_N] .AND. reg->(RLock())
         reg->NOTE := STATE_SPOILT
         reg->DATE := dDate
         reg->USER := ::mainWnd:user[1]
         reg->(DbUnlock())
       ENDIF
       reg->(DbSkip())
     ENDDO
   ENDIF

   IF aRecord[REGFIELD_TIPBL] != 1
     RETURN
   ENDIF

   SET DELETED OFF
   IF rec->(DbSeek(aRecord[REGFIELD_S] + Str(aRecord[REGFIELD_N], 7))) .AND. 1 == rec->TIPBL .AND. PEV_PARAMS[1] == rec->KOD .AND. 0 == rec->PRIM
//   IF rec->(DbSeek(aRecord[REGFIELD_PG]))
//     DO WHILE aRecord[REGFIELD_PG] == rec->PG
//       IF aRecord[REGFIELD_YEAR] $ { Year(rec->DATESROK), Year(rec->DATELIST) } .AND. Str(aRecord[REGFIELD_N], 7) == rec->PL
         SET DELETED ON
         cSeek := Str(::mainWnd:user[2], 2) + Str(3, 2) + PadR(aRecord[REGFIELD_S], 6) + Str(aRecord[REGFIELD_N], 10)
         AEval({ rec->(RLock()), ::rec, "base.rec" }, {|x,i| AAdd(aLocks[i], x) })
         IF aLocks[1][1]
           IF abu->(DbSeek(cSeek))
             AEval({ abu->(RLock()), ::abu, "base.abu" }, {|x,i| AAdd(aLocks[i], x) })
           ENDIF
           IF (1 == Len(aLocks[1]) .OR. aLocks[1][2]) .AND. bus->(DbSeek(cSeek))
             AEval({ bus->(RLock()), ::bus, "base.bus" }, {|x,i| AAdd(aLocks[i], x) })
           ENDIF
         ENDIF
         nIndex := AScan(aLocks[1], .F.)
         IF nIndex > 0
           ConfirmBox(self, "     " + aLocks[3][nIndex] + Chr(10) +;
                      "   .", "", XBPMB_OK, XBPMB_WARNING)
         ELSE
           rec->PRIM := 2
           AEval({ ::abu, ::bus }, {|x| IIf(x $ aLocks[2], (x)->SOST := 3, ) })
         ENDIF
         AEval(aLocks[2], {|x,i| IIf(aLocks[1][i], (x)->(DbUnlock()),) })
         IF 0 == nIndex
           ::payments:delItem(::paymentOptions[1])
           nIndex := ::paymentOptions[1] - IIf(::paymentOptions[1] < Len(::paymentOptions[2]), 0, 1)
           ::payments:setData(IIf(nIndex > 0, { nIndex }, {}))
           ARemove(::paymentOptions[2], ::paymentOptions[1], 1)
           ARemove(::paymentOptions[3], ::paymentOptions[1], 1)
           ::UpdateBrowserData()
         ENDIF
         lFound := .T.
         //SET DELETED OFF
//         EXIT
//       ENDIF
//       rec->(DbSkip())
//     ENDDO
   ENDIF
   SET DELETED ON

   IF !lFound
     ConfirmBox(self, "      ", "", XBPMB_OK, XBPMB_WARNING)
   ENDIF

   //PostAppEvent(xbeP_Close,,, self)

RETURN

METHOD ExtraDlg:OnAcknowledgeBtnClicked()
   LOCAL i, aRecord, aRec, aProcessed := {}, aToChange := {}, aToDelete := {}
   LOCAL cSeek, nRecNo, rel, dDate := Date(), cSer := AllTrim(::ackSeries:getData())
   LOCAL makeSeek := {|pg, pensid, year| Str(pg, 6) + Str(pensid, 6) + Str(year, 4)/* + "0"*/ }

   aRecord := ::paymentInfo[2][1]

   IF Empty(cSer)
     ShowNotification(self, ::ackSeriesLabel:currentPos(), "  ")
     RETURN
   ENDIF

   IF ConfirmBox(self, "   ?",;
                 "", XBPMB_YESNO, XBPMB_QUESTION, XBPMB_DEFBUTTON2) <> XBPMB_RET_YES
      RETURN
   ENDIF

   cSeek := Eval(makeSeek, aRecord[REGFIELD_PG], aRecord[REGFIELD_PENSID], aRecord[REGFIELD_YEAR])
   IF reg->(DbSeek(cSeek)) .AND. reg->(FLock())
     DO WHILE Eval(makeSeek, reg->PG, reg->PENSID, reg->YEAR) == cSeek
       nRecNo := reg->(RecNo())
       IF !(nRecNo $ aToChange) .AND. reg->TIPBL == aRecord[REGFIELD_TIPBL] .AND. reg->S == aRecord[REGFIELD_S] .AND. reg->N == aRecord[REGFIELD_N]
         FOR i := 1 TO Len(::paymentInfo[1])
           aRec := ::paymentInfo[2][i]
           IF !(i $ aProcessed) .AND. aRec[REGFIELD_USER] >= 1000 .AND. aRec[REGFIELD_USER] < 2000 .AND.;
              ((!Empty(aRec[REGFIELD_PERSONID]) .AND. aRec[REGFIELD_PERSONID] == reg->PERSONID) .OR.;
              (aRec[REGFIELD_RELATION] == reg->RELATION .AND. aRec[REGFIELD_FAMILY] == reg->FAMILY .AND.;
              aRec[REGFIELD_NAME] == reg->NAME .AND. aRec[REGFIELD_NAME2] == reg->NAME2))
             IIf(::paymentInfo[1][i][4],, AAdd(aToDelete, nRecNo))
             AAdd(aToChange, nRecNo)
             AAdd(aProcessed, i)
             EXIT
           ENDIF
         NEXT
       ENDIF
       reg->(DbSkip())
     ENDDO
     IF Len(aToChange) == Len(aToDelete) .AND. ConfirmBox(self, "      . ?",;
                   "", XBPMB_YESNO, XBPMB_QUESTION, XBPMB_DEFBUTTON2) <> XBPMB_RET_YES
        aToChange := aToDelete := {}
     ENDIF
     AEval(aToChange, {|x| reg->(DbGoTo(x)), reg->S := PadR(cSer, 6), reg->DATE := dDate, reg->USER := 2000 + ::mainWnd:user[1] })
     AEval(aToDelete, {|x| reg->(DbGoTo(x)), reg->(DbDelete()) })
     reg->(DbUnlock())
   ENDIF

   //::UpdateBrowserData()
   ::GetPayments()

RETURN

METHOD ExtraDlg:OnNotificationBtnClicked()
   //LOCAL nIndex, nOffset, recordIndex
   //LOCAL lActiveRecord := .F., lPensFIO := ::printPensFIO:getData()
   //LOCAL aRecord, aRec, aLocks, cSeek := "", cErrorMessage := ""
   //LOCAL dDate := Date(), nSumm := Val(::summResult:getData()), cSer := ::series:getData(), nNum := ::number:getData()
   //LOCAL makeSeek := {|pg, pensid, year| Str(pg, 6) + Str(pensid, 6) + Str(year, 4)/* + "0"*/ }

   LOCAL aRecord := ::paymentInfo[2][1]

   PrintNotification(self, ::mainWnd:printers[1][1]:devName, ::mainWnd:printers[1][2], ::mainWnd:printers[1][3],;
                     { ::mainWnd:printers[1][4], ::mainWnd:printers[1][5] }, aRecord, ::mainWnd:user[3],;
                     GetBank(aRecord[REGFIELD_DISTRICT], aRecord[REGFIELD_BANK], aRecord[REGFIELD_MODE],;
                             ::mainWnd:districts, ::mainWnd:banks, ::mainWnd:banks2districts),;
                     FrdbGetInfo(aRecord))

RETURN

METHOD ExtraDlg:GetPayments()
   LOCAL nYear := Val(::paymentYear:XbpSLE:getData())
   LOCAL makeSeek := {|pg, pensid, year| Str(pg, 6) + Str(pensid, 6) + Str(year, 4)/* + "0"*/ }
   LOCAL cSeek := Eval(makeSeek, ::recepientInfo[3], ::recepientInfo[5], nYear), cSeek1, nIndex, lFound, cSN, aInfo, cPL
   LOCAL makeSN := {|lPaper, cS, cN, cID| IIf(lPaper,;
                                          ".: " + AllTrim(cS) + "  " + AllTrim(cN),;
                                          "." + cID) }

   ::paymentOptions := { 0, {}, {} }

   IF reg->(DbSeek(cSeek))
     DO WHILE Eval(makeSeek, reg->PG, reg->PENSID, reg->YEAR) == cSeek
       SET DELETED OFF

       lFound := 1 == reg->TIPBL .AND. rec->(DbSeek(reg->S + Str(reg->N, 7))) .AND. 1 == rec->TIPBL .AND.;
                 PEV_PARAMS[1] == rec->KOD .AND. 0 == rec->PRIM
       cSN := Eval(makeSN, 1 == reg->TIPBL, reg->S, Str(reg->N), " (" + DtoC(reg->DATE) + ")")
       IF AScan(::paymentOptions[3], cSN) == 0
         aInfo := { reg->S, reg->N, reg->YEAR, reg->SUMM, reg->NOTE, reg->DATE, reg->USER, .F., "", lFound, reg->TIPBL }
         SET DELETED ON
         FrdbCheckPayParams(reg->TIPBL, reg->S, reg->N,;
                            { PARAM_EXTRA_ORIGINAL, PARAM_VSKTOUR },;
                            { {|| aInfo[9] := " (  " + Eval(makeSN, Left(params->VALUE, 1) == "1",;
                                                                    SubStr(params->VALUE, 2, 6), SubStr(params->VALUE, 8),;
                                                                    "") + ")" },;
                              {|| IIf(".T." = params->VALUE, aInfo[8] := .T.,) } })
                                                                   /*IIf(Left(params->VALUE, 1) == "1",;
                                                                   ".: " + AllTrim(SubStr(params->VALUE, 2, 6)) + "  " + AllTrim(SubStr(params->VALUE, 8)),;
                                                                   ".") + ")" },;*/
         SET DELETED OFF
         AAdd(::paymentOptions[2], aInfo)
         AAdd(::paymentOptions[3], cSN)
       ENDIF

       SET DELETED ON
       reg->(DbSkip())
     ENDDO
   ENDIF

   ::payments:clear()
   AEval(::paymentOptions[3], {|x,i| ::payments:addItem(IIf(::paymentOptions[2][i][5] $ { 0, STATE_EXTRA },;
                                                        IIf(::paymentOptions[2][i][10], "", "? "), "[] ") +;
                                                        x + ::paymentOptions[2][i][9]) })

   IF !Empty(::paymentOptions[2])
     ::paymentOptions[1] := 1
     ::payments:setData({ 1 })
   ENDIF

   ::UpdateBrowserData()
   //HideCreepingLine()

RETURN

METHOD ExtraDlg:UpdateBrowserData()
   LOCAL aInfo, aRecord, cSeek, nIndex, nUser, aExtra, oPDS
   LOCAL makeSeek := {|pg, pensid, year| Str(pg, 6) + Str(pensid, 6) + Str(year, 4)/* + "0"*/ }

   ::paymentInfo := { {}, {} }

   ::summ:setData("")
   ::date:setData("")
   ::user:setData("")
   ::extraCount:setData("")
   ::extraSumm:setData("")
   ::vskTour:setData(.F.)
   //::state:setData({ 1 })
   ::ackSeries:setData("")
   ::ackSeries:disable()

   ::paymentOptions[1] := 0
   AEval(::payments:getData(), {|sel| ::paymentOptions[1] := sel })

   IF ::paymentOptions[1] > 0
     aInfo := ::paymentOptions[2][::paymentOptions[1]]
     cSeek := Eval(makeSeek, ::recepientInfo[3], ::recepientInfo[5], aInfo[3])

     IF reg->(DbSeek(cSeek))
       DO WHILE Eval(makeSeek, reg->PG, reg->PENSID, aInfo[3]) == cSeek
         IF aInfo[11] == reg->TIPBL .AND. aInfo[1] == reg->S .AND. aInfo[2] == reg->N
           AAdd(::paymentInfo[1], { ::relations[reg->RELATION + 1], MakeFIO(::reg), reg->BIRTH,;
                                    reg->USER < 1000 .OR. reg->USER >= 2000 })
           AAdd(::paymentInfo[2], Array(Len(g_aRegDbStruct)))
           AEval(::paymentInfo[2][Len(::paymentInfo[2])], {|x,i| x := reg->(FieldGet(i)) },,, .T.)
         ENDIF
         reg->(DbSkip())
       ENDDO
     ENDIF

     ::summ:setData(AllTrim(Str(aInfo[4])))
     ::date:setData(DtoC(aInfo[6]))
     nUser := IIf(aInfo[7] >= 2000, aInfo[7] - 2000, aInfo[7])
     nIndex := AScan(::users[1], nUser)
     ::user:setData(AllTrim(Str(nUser)) + IIf(nIndex > 0, "-" + ::users[3][nIndex], ""))
     ::vskTour:setData(aInfo[8])

     //nIndex := IIf(STATE_EXTRA == aInfo[5], 1, AScan(::states[1], aInfo[5]))
     //IIf(nIndex > 0, ::state:setData({ nIndex }),)

     aExtra := { 0, 0 }
     AEval(::paymentOptions[2], {|x| IIf(STATE_EXTRA == x[5], aExtra := { aExtra[1] + 1, aExtra[2] + x[4] }, ) })
     IF 0 == aInfo[5]// .AND. aExtra[1] > 0
       ::extraCount:setData(AllTrim(Str(aExtra[1])))
       ::extraSumm:setData(AllTrim(Str(aExtra[2])))
     ENDIF

     IF aInfo[11] = 1 .AND. aInfo[1] = "/"
       ::ackSeries:setData("")
       ::ackSeries:enable()
     ELSE
       ::ackSeries:setData(AllTrim(aInfo[1]))
     ENDIF
   ENDIF

   IF Empty(::paymentInfo[1])
     AEval(::updateControls, {|x| x:disable() })
     ::browser:hide()
//     oPDS := ::emptyBrowser
   ELSE
     AEval(::updateControls, {|x| x:enable() })
     AEval(::disabledControls, {|x| x:disable() })

     IIf(aInfo[10] .AND. 1 == aInfo[11],, ::btnChange:disable())
     IIf(aInfo[5] $ { 0, STATE_EXTRA },, AEval({::btnExtra, ::btnNotification}, {|x| x:disable() }))

     ::browser:setDataLink(DacPagedDataStore():new(::paymentInfo[1], { 1, 2, 3 }))
     ::browser:setHeader({ "", "", ".." })
     AEval({ 80, 310, 80 }, {|x,i| ::browser:setColWidth(x, i)})
     ::browser:dataLink:goFirst()
     ::browser:refreshAll()
     ::browser:show()

     PostAppEvent(xbeBRW_ItemMarked, { 1, 1 }, NIL, ::browser)
   ENDIF

RETURN

METHOD ExtraDlg:ParseCalcString()
   LOCAL cLine := AllTrim(::summCalc:getData()) + " "
   LOCAL nIndex := 0, cItem, nSumm := 0, nSummTotal := 0, charPos

   ::calcParams := {}

   DO WHILE !Empty(cLine)
     nIndex := At(" ", cLine)
     IF nIndex <= 1
       EXIT
     ENDIF
     cItem := StrTran(Left(cLine, nIndex - 1), ",", ".")
     FOR charPos := 2 TO Len(cItem)
       IF !(SubStr(cItem, charPos, 1) $ "0123456789.")
         cItem := ""
         EXIT
       ENDIF
     NEXT
     IF Len(cItem) < 2 .OR. !(cItem[1] $ "") .OR. At(".", cItem) <> RAt(".", cItem)
       EXIT
     ENDIF
     nSumm := Val(SubStr(cItem, 2))
     AAdd(::calcParams, { cItem[1], nSumm })
     nSummTotal += nSumm
     cLine := LTrim(SubStr(cLine, nIndex))
   ENDDO

   cLine := ""
   AEval(::calcParams, {|x| cLine += x[1] + AllTrim(Str(x[2], 9, 2)) + " " })
   ::summCalc:setData(cLine)
   ::summResult:setData(AllTrim(Str(nSummTotal, 12, 2)))

RETURN

METHOD ExtraDlg:CheckReference()
   LOCAL cSer := PadR(AllTrim(::series:getData()), 6), nNum := ::number:getData()
   LOCAL aPos, lFound := .F.

   AEval(::blankNumbers, {|x| IIf(cSer == x[1] .AND. nNum >= x[2] .AND. nNum <= x[3], lFound := .T.,) })
   IF lFound
     RETURN
   ENDIF

   aPos := ::series:currentPos()
   ShowNotification(self, { aPos[1], aPos[2] + 60 }, "    " + Chr(10) +;
                    "      ")

   ::series:setData(SYS_POR)
   ::number:setData(0)
RETURN

METHOD ExtraDlg:CopyLastSumm()
   LOCAL cLine, aMarked := ::summCalc:queryMarked()

   cLine := RTrim(Left(::summCalc:getData(), aMarked[1] - 2))

RETURN LTrim(SubStr(cLine, Max(1, RAt(" ", cLine))))


* Include program code for the implementation-level class of the form

//EOF
/////