///////////////////////////////////////////////////////////////////////////////
//
//  Class code created by the Xbase++ FormDesigner
//    Creation date: 24.12.2007 Creation time: 10:56:24
//
//  Contents  :
//    This file contains the basic structure for the utilization-level of
//    a form. It may (and should) be modified.
//
///////////////////////////////////////////////////////////////////////////////

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "XBPDEV.CH"
#include "frdbrtn.CH"

#define BASE_PATH        ".\"

//#define DEFAULT_SERIES        ""
#define PARAM_VSKTOUR        "VSKTOUR"
#define PARAM_DONTCHECK        "DONTCHECK"

STATIC g_nCmdLineUser := 0

******************************************************************************
* This class is derived from the implementation-level class of the form.
* Instance variables are declared in the _FareRegForm class.
******************************************************************************
CLASS FareRegForm FROM _FareRegForm
   EXPORTED:
     //
     VAR computer
         //  ,    999  ADMIN
         VAR user
         //   0 -    
         VAR accessLevel
         //            
     VAR browser
     //
     VAR printers
        //  
        VAR ranks
        //  
        VAR districts
        //   
        VAR banks
        //    -    
        VAR banks2districts
        //    
        VAR relations
    //
    VAR users
    //
    VAR statuses
    //
    VAR paymentNotes
    //
    VAR articles
    //
    VAR fairRetirement
    //
    VAR dismissalCauses
    //
    VAR categories
    //
    VAR possiblePG
    //
    VAR relatives
    //
    VAR blankNumbers
    //
    VAR calcParams
    //
    VAR rights
    //
    VAR buf
    //
    VAR reg
    //
    VAR dbf
    //
    VAR rec
    //
    VAR abu
    //
    VAR bus
    //
    VAR params
    //
    VAR field2xbp

   EXPORTED:
     METHOD init
         METHOD InitAccessLevel
         METHOD InitArrays
         METHOD InitWorkAreas
         METHOD InitChildren
         METHOD InitConditions
     METHOD create
     METHOD CreateBrowser
     METHOD UpdatePGFromFIOBtn
     METHOD OnPGFromFIOBtnClicked
     METHOD CheckBoxesToBuffer
         METHOD OnDoneBtnClicked
         METHOD OnExtraBtnClicked
         METHOD ClearInputFields
         METHOD CheckReference
         METHOD FindPG
         METHOD FindPerson
     METHOD GetRelatives
     METHOD UpdateRelatives
         METHOD ParseCalcString
         METHOD MakeRecord
         METHOD TakeRecord
     METHOD EditCivPens
     METHOD EditRelatives
     METHOD EditAccount
     METHOD SaveConfig
     METHOD CopyLastSumm
ENDCLASS

******************************************************************************
* Initialize form
******************************************************************************
METHOD FareRegForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   LOCAL oSplash

   * Execute method of the super class
   ::_FareRegForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::XbpDialog:title := " "
   ::XbpDialog:border := XBPDLG_DLGBORDER
   ::XbpDialog:maxButton := .F.

   //     
   ShowStatusMessage("    : ")
   ::InitAccessLevel()
   ShowStatusMessage(AllTrim(Str(::user[1])) + "-" + ::user[3] + " (" + Str(::accessLevel, 1) + ")",, 43)
   ShowStatusMessage("[Done]", .T., 70)
   //    
   ShowStatusMessage("   ")
   ::InitArrays()
   ShowStatusMessage("[Done]", .T., 70)
   //      
   ShowStatusMessage("     :")
   ::InitWorkAreas()
   //    
   ShowStatusMessage("  ")
   ::InitChildren()
   ShowStatusMessage("[Done]", .T., 70)
   //  
   ShowStatusMessage(" ")
   ::InitConditions()
   ShowStatusMessage("[Done]", .T., 70)

RETURN self

METHOD FareRegForm:InitAccessLevel()
   LOCAL nHandle
   LOCAL cUser := IIf(Empty(g_nCmdLineUser),;
                      GetEnv(SYS_ENVUSERNAME1),;
                      StrTran("user" + Str(g_nCmdLineUser, 2), " ", "0"))

   IIf(Empty(cUser), cUser := GetEnv(SYS_ENVUSERNAME2),)

   ::user := { 0, 0, "" }

   IF !Empty(cUser)
//     ::user[1] := IIf("admin" == Lower(cUser), 999, Val(StrTran(Lower(cUser), "user")))
     ::user[1] := IIf("admin" == Lower(cUser), 999, Val(Right(cUser,2)))

         USE (PATH_GLOSSARY + "GLOS_G.DBF") ALIAS glos NEW READONLY SHARED

         IF 999 == ::user[1]
           ::accessLevel := 9
           ::user[3] := ""
         ELSEIF DbLocate({|| NOMER = ::user[1] })
           ::accessLevel := PUTEVKI
       ::user[3] := AllTrim(FIO)
         ELSE
           ::user[3] := " "
         ENDIF

         ::XbpDialog:title := "  - " + ::user[3]

         CLOSE glos

         USE (PATH_DBFBLANK + "BASE.USR") ALIAS glos NEW READONLY SHARED

     IF DbLocate({|| USER = ::user[1] })
       ::user[2] := NN
     ENDIF

         CLOSE glos
   ENDIF

   IF NIL = ::accessLevel .OR. ::accessLevel < 1
     ConfirmBox(self, "      ." + Chr(10) +;
                "        .",;
                "", XBPMB_OK, XBPMB_WARNING)
     ::accessLevel := 0
   ENDIF

RETURN

METHOD FareRegForm:InitArrays()
   LOCAL prnStruct := {;
                        { "COMPUTER", "C", 32, 0 },;
                        { "PRN_ID", "N", 2, 0 },;
                        { "PRN_NAME", "C", 64, 0 },;
                        { "PRN_ORIENT", "N", 1, 0 },;
                        { "PRN_FORM", "N", 3, 0 },;
                        { "PRN_X", "N", 4, 0 },;
                        { "PRN_Y", "N", 4, 0 },;
                        { "PRN_W", "N", 4, 0 },;
                        { "PRN_H", "N", 4, 0 };
                      }
   LOCAL aPrinters := {}, prnIndex, nIndex, cTemp

   ::ranks := { {}, {}, {} }
   ::districts := {}
   ::banks := {}
   ::banks2districts := { {}, {} }
   ::users := { {}, {}, {} }
   ::relations := {}
   ::articles := { {}, {} }
   ::fairRetirement := {}

   ::statuses := { " ", "  ", " ()", "   ()", SYS_LITERA + "  " }//" ", "", " ", "" }

   ::paymentNotes := { "", "-" }

   ::dismissalCauses := {}

   ::categories := { " ", "()", "", "  ", "  ", "", "  " }

   ::blankNumbers := {}

   ::calcParams := {}

   ::rights := { .F., .F. }

   ::field2xbp := {;
                    { "RN", "RANG", "FAMILY", "NAME", "NAME2", "VYEAR", "VKAL", "WRK", "STUWOL" },;
                    { ::district, ::rank, ::family, ::name, ::name2, ::serviceTimeTotal, ::serviceTimeChrono, ::countWork, ::retirement},;
                    { {|x| ::districts[x + 1] },;
                      {|x| ::ranks[2][AScan(::ranks[3], x)]},;
                      {|x| AllTrimEx(x) },;
                      {|x| AllTrimEx(x) },;
                      {|x| AllTrimEx(x) },;
                      {|x| Str(x, 2)},;
                      {|x| Str(x, 2)},;
                      {|x| IIf(1 == x, .T., .F.) },;
                      {|x| x + " " + ::articles[2][AScan(::articles[1], x)] };
                    },;
                    { {|obj| AScan(::districts, obj:getData()) - 1 },;
                      {|obj| ::ranks[3][AScan(::ranks[2], obj:getData())]},;
                      ,,,;
                      {|obj| Val(obj:getData())},;
                      {|obj| Val(obj:getData())},;
                      {|obj| IIf(obj:GetData(), 1, 0) },;
                      {|obj| IIf(Empty(obj:getData()),, Left(obj:getData(), 5)) };
                    };
                  }

   USE (PATH_DBFBLANK + "BASE.POD") ALIAS pod NEW READONLY SHARED
   SET FILTER TO NUSER = ::user[2] .AND. VIDBCO = 3
   GO TOP

   DO WHILE !Eof()
     AAdd(::blankNumbers, { SER, NBLANK, QBLANK })
     SKIP
   ENDDO

   CLOSE pod

   IF !FExists(PATH_GLOSSARY + "PRINTERS.DBF")
     DbCreate(PATH_GLOSSARY + "PRINTERS.DBF", prnStruct)
   ELSE
     USE (PATH_GLOSSARY + "PRINTERS.DBF") ALIAS glos NEW READONLY SHARED

     ::computer := PadR(GetEnv("COMPUTERNAME"), 32)
     ::printers := { { NIL, XBPPRN_FORM_A4, XBPPRN_ORIENT_PORTRAIT, 0, 0, 0, 0 },;
                     { NIL, XBPPRN_FORM_A4, XBPPRN_ORIENT_PORTRAIT, 0, 0, 0, 0 } }

     FOR prnIndex := 1 TO Len(::printers)
       IF DbLocate({|| COMPUTER == ::computer .AND. PRN_ID $ {1, 2} .AND. PRN_ID == prnIndex })
         ::printers[PRN_ID] := { XbpPrinter():New():Create(AllTrim(PRN_NAME)), PRN_ORIENT, PRN_FORM, PRN_X, PRN_Y, PRN_W, PRN_H }
       ENDIF
     NEXT

     IF NIL == ::printers[1][1] .AND. NIL == ::printers[2][1]
       ::printers[1][1] := ::printers[2][1] := XbpPrinter():New():Create()
     ELSEIF NIL == ::printers[1][1] .AND. ::printers[2][1] <> NIL
       ::printers[2] := ::printers[1]
     ELSEIF NIL == ::printers[2][1] .AND. ::printers[1][1] <> NIL
       ::printers[1] := ::printers[2]
     ENDIF

     CLOSE glos
   ENDIF

   USE (PATH_GLOSSARY + "GLOS_B_N.DBF") ALIAS glos NEW READONLY SHARED

   DO WHILE !Eof()
     AAdd(::ranks[1], SH_RANG)
     AAdd(::ranks[2], DBRANG)
     AAdd(::ranks[3], KOD)
     SKIP
   ENDDO

   CLOSE glos

   USE (PATH_GLOSSARY + "GLOS_C.DBF") ALIAS glos NEW READONLY SHARED

   ASize(::districts, LastRec())
   ASize(::banks, LastRec())
   DO WHILE !Eof()
     IF !Empty(NAME)
       ::districts[RN + 1] := AllTrim(NAME)
       ::banks[RN + 1] := Left(BANK, At(" ", BANK)) + " " + AllTrim(OSB)
       cTemp := Left(OSB, 4)
       nIndex := AScan(::banks2districts[1], cTemp)
       IF nIndex > 0
         AAdd(::banks2districts[2][nIndex], RN + 1)
       ELSE
         AAdd(::banks2districts[1], cTemp)
         AAdd(::banks2districts[2], { RN + 1 })
       ENDIF
     ENDIF
         SKIP
   ENDDO

   CLOSE glos

   USE (PATH_GLOSSARY + "GLOS_G.DBF") ALIAS glos NEW READONLY SHARED

   DO WHILE !Eof()
     AAdd(::users[1], NOMER)
     AAdd(::users[2], 0)
     AAdd(::users[3], FIO)
         SKIP
   ENDDO

   CLOSE glos

   USE (PATH_DBFBLANK + "BASE.USR") ALIAS glos NEW READONLY SHARED

   DO WHILE !Eof()
     nIndex := AScan(::users[1], USER)
     IIf(nIndex > 0, ::users[2][nIndex] := NN,)
         SKIP
   ENDDO

   CLOSE glos

   USE (PATH_GLOSSARY + "PEV.DBF") ALIAS glos NEW READONLY SHARED

   DO WHILE !Eof()
     IIf(KOD != PEV_PARAMS[1],, AEval(PEV_PARAMS, {|x,i| x := FieldGet(i) }, 2,, .T.))
     SKIP
   ENDDO

   CLOSE glos

   USE (PATH_GLOSSARY + "STUWOL.DBF") ALIAS glos NEW READONLY SHARED

   DO WHILE !Eof()
     AAdd(::articles[1], IIf(Empty(KOD), "", KOD))
         AAdd(::articles[2], AllTrimEx(NAME))
     IIf(NGR $ { 1, 2, 3, 4 }, AAdd(::fairRetirement, AllTrim(KOD)),)
         SKIP
   ENDDO

   CLOSE glos

   USE (PATH_GLOSSARY + "PRPREK.DBF") ALIAS glos NEW READONLY SHARED

   ASize(::dismissalCauses, LastRec())
   DO WHILE !Eof()
     AAdd(::statuses, AllTrimEx(NAME))
     ::dismissalCauses[KOD + 1] := Len(::statuses)
     SKIP
   ENDDO

   CLOSE glos

   USE (PATH_GLOSSARY + "RELATION.DBF") ALIAS glos NEW READONLY SHARED

   ASize(::relations, LastRec())
   DO WHILE !Eof()
     ::relations[ID + 1] := AllTrimEx(STRING)
         SKIP
   ENDDO

   CLOSE glos

   ::possiblePG := { 0, {} }
   ::relatives := { { 0, 0, .F., {|| .F.}} }

RETURN

METHOD FareRegForm:InitWorkAreas()
   LOCAL cUserID := AllTrim(Str(::user[1], 3)), lNewBase := .F.

   DbCreate(PATH_TMP + "FRTMP" + cUserID + ".DBF", g_aBufDbStruct)
   USE (PATH_TMP + "FRTMP" + cUserID + ".DBF") ALIAS buf NEW EXCLUSIVE
   OrdCreateEx(PATH_TMP + "FRTMP" + cUserID + ".NTX", "(RELATION)",, .T.)
   SET INDEX TO (PATH_TMP + "FRTMP" + cUserID + ".NTX")
   ::buf := Select()

   IF !FExists(PATH_DBF + "FAREREG.DBF")
     DbCreate(PATH_DBF + "FAREREG.DBF", g_aRegDbStruct)
     lNewBase := .T.
   ENDIF
   USE (PATH_DBF + "FAREREG.DBF") ALIAS reg NEW SHARED
   OrdCreateEx(PATH_DBF + "FREGFAM.NTX", "(Str(PG, 6) + Str(PENSID, 6) + Str(YEAR, 4))",, lNewBase)
   SET INDEX TO (PATH_DBF + "FREGFAM.NTX")
   ::reg := Select()

   lNewBase := .F.
   IF !FExists(PATH_DBF + "PERSONS.DBF")
     DbCreate(PATH_DBF + "PERSONS.DBF", g_aPersDbStruct)
     lNewBase := .T.
   ENDIF
   USE (PATH_DBF + "PERSONS.DBF") ALIAS pers NEW SHARED
   OrdCreateEx(PATH_DBF + "PERSID.NTX", "(ID)", "persid", lNewBase)
   OrdCreateEx(PATH_DBF + "PERSPI.NTX", "(PENSID)", "perspi", lNewBase)
   OrdCreateEx(PATH_DBF + "PERSPG.NTX", "(PG)", "perspg", lNewBase)
   OrdCreateEx(PATH_DBF + "PERSFIO.NTX", "(FAMILY + NAME + NAME2)", "persfio", lNewBase)
   SET INDEX TO (PATH_DBF + "PERSID.NTX"), (PATH_DBF + "PERSPI.NTX"), (PATH_DBF + "PERSPG.NTX"), (PATH_DBF + "PERSFIO.NTX")

   lNewBase := .F.
   IF !FExists(PATH_DBF + "CIVPENS.DBF")
     DbCreate(PATH_DBF + "CIVPENS.DBF", g_aCivDbStruct)
     lNewBase := .T.
   ENDIF
   USE (PATH_DBF + "CIVPENS.DBF") ALIAS civ NEW SHARED
   OrdCreateEx(PATH_DBF + "CPENSID.NTX", "(ID)", "cpensid", lNewBase)
   OrdCreateEx(PATH_DBF + "CPENSFIO.NTX", "(FAMILY + NAME + NAME2)", "cpensfio", lNewBase)
   SET INDEX TO (PATH_DBF + "CPENSID.NTX"), (PATH_DBF + "CPENSFIO.NTX")

   lNewBase := .F.
   IF !FExists(PATH_DBF + "CIVINFO.DBF")
     DbCreate(PATH_DBF + "CIVINFO.DBF", g_aInfoDbStruct)
     lNewBase := .T.
   ENDIF
   USE (PATH_DBF + "CIVINFO.DBF") ALIAS info NEW SHARED
   OrdCreateEx(PATH_DBF + "CIVINFO.NTX", "(Str(PERSONID, 6) + Str(PENSID, 6) + Str(PG, 6) + Str(RELATION, 2) + FAMILY + NAME + NAME2)",, lNewBase)
   SET INDEX TO (PATH_DBF + "CIVINFO.NTX")

   lNewBase := .F.
   IF !FExists(PATH_DBF + "PAYPARAM.DBF")
     DbCreate(PATH_DBF + "PAYPARAM.DBF", g_aParamsDbStruct)
     lNewBase := .T.
   ENDIF
   USE (PATH_DBF + "PAYPARAM.DBF") ALIAS params NEW SHARED
   OrdCreateEx(PATH_DBF + "PAYPARAM.NTX", "(Str(TIPBL, 1) + S + Str(N, 10))",, lNewBase)
   SET INDEX TO (PATH_DBF + "PAYPARAM.NTX")
   ::params := Select()

   lNewBase := .F.
   IF !FExists(PATH_DBF + "GUIDSTRG.DBF")
     DbCreate(PATH_DBF + "GUIDSTRG.DBF", g_aGUIDStrgDbStruct)
     lNewBase := .T.
   ENDIF
   USE (PATH_DBF + "GUIDSTRG.DBF") ALIAS id NEW SHARED
   OrdCreateEx(PATH_DBF + "GUIDSTRG.NTX", "(NAME)",, lNewBase)
   SET INDEX TO (PATH_DBF + "GUIDSTRG.NTX")
   IF lNewBase .AND. id->(FLock())
     id->(DbAppend())
     id->ID := 1
     id->NAME := "ELREGISTRYPAYMENT"
     id->VALUE := 1
   ENDIF

   USE (PATH_DBF + "BASE.DBF") ALIAS dbf NEW SHARED
   OrdCreateEx(PATH_DBF + "BASE.XG", "(PG)")
   SET INDEX TO (PATH_DBF + "BASE.XG")
   ::dbf := Select()

   USE (PATH_DBF + "BASE.RPD") ALIAS rpd NEW SHARED
   OrdCreateEx(PATH_DBF + "BASE.XRP", "(PG)")
   SET INDEX TO (PATH_DBF + "BASE.XRP")

   USE (PATH_DBF + "BASE.RFM") ALIAS rfm NEW SHARED
   OrdCreateEx(PATH_DBF + "BASE.RFF", "(FAMILY)")
   SET INDEX TO (PATH_DBF + "BASE.RFF")

   USE (PATH_DBF + "BASE.DEP") ALIAS dep NEW SHARED
   OrdCreateEx(PATH_DBF + "BASE.XD1", "(PG)")
   SET INDEX TO (PATH_DBF + "BASE.XD1")

   USE (PATH_DBF + "BASE.REC") ALIAS rec NEW SHARED
   OrdCreateEx(PATH_DBF + "BASE.RL", "(SER+PL)")
   OrdCreateEx(PATH_DBF + "BASE.RG", "(PG)")
   SET INDEX TO (PATH_DBF + "BASE.RL"), (PATH_DBF + "BASE.RG")
   ::rec := Select()

   USE (PATH_DBFBLANK + "BASE.ABU") ALIAS abu NEW SHARED
   OrdCreateEx(PATH_DBFBLANK + "BASE.XAU", "(Str(NUSER, 2) + Str(VIDBCO, 2) + SER + Str(NN, 10))")
   SET INDEX TO (PATH_DBFBLANK + "BASE.XAU")
   ::abu := Select()

   USE (PATH_DBFBLANK + "BASE.BUS") ALIAS bus NEW SHARED
   OrdCreateEx(PATH_DBFBLANK + "BASE.XBS", "(Str(NUSER, 2) + Str(VIDBCO, 2) + SER + Str(NN, 10))")
   SET INDEX TO (PATH_DBFBLANK + "BASE.XBS")
   ::bus := Select()

RETURN

METHOD FareRegForm:InitChildren()
        LOCAL onKeyPressed, onKeyPressedEx, evalIfDataChanged, replaceNullValue

        ::browser := XbpBrowse():new(::XbpDialog:drawingArea,, { 16, 152 }, { 552, 92 })
        ::browser:setColorBG(XBPSYSCLR_ENTRYFIELD)

        //    
        ::PG:setNumLimits(0, 999999)
        ::number:setNumLimits(0, 9999999)

        ::PG:setInputFocus :=;
        ::family:setInputFocus := ::name:setInputFocus := ::name2:setInputFocus :=;
        ::series:setInputFocus := ::number:setInputFocus :=;
                           {|mp1, mp2, obj| obj:XbpSLE:setMarked({1, obj:bufferLength + 1}), obj:setColorBG(INTERFACE_FOCUSCOLOR) }

    ::right1:setInputFocus :=;
    ::electronic:setInputFocus :=;
    ::pensioner:setInputFocus := ::spouse:setInputFocus := ::children:setInputFocus := ::all:setInputFocus :=;
    ::vskTour:setInputFocus :=;
    ::printPensFIO:setInputFocus :=;
    ::printCalc:setInputFocus :=;
    ::printNotification:setInputFocus := {|mp1, mp2, obj| obj:setColorBG(INTERFACE_FOCUSCOLOR) }

    ::browser:setInputFocus :=;
    ::summCalc:setInputFocus := {|mp1, mp2, obj| obj:setColorBG(INTERFACE_FOCUSCOLOR) }

        evalIfDataChanged := {|obj, blk, blk1| IIf(obj:changed, IIf(blk != NIL, Eval(blk),), IIf(blk1 != NIL, Eval(blk1),) ) }

    replaceNullValue := {|obj, val| IIf(obj:XbpSLE:getData() = "", Eval({|obj| obj:setData(val), obj:changed := .T.}, obj),)}

        ::series:killInputFocus := {|mp1, mp2, obj| Eval(replaceNullValue, obj, SYS_POR),;
                                                Eval(evalIfDataChanged, obj, {|| IIf(Empty(::number:getData()),, ::CheckReference()) }),;
                                                obj:setColorBG(XBPSYSCLR_WINDOW) }

    ::number:killInputFocus := {|mp1, mp2, obj| Eval(replaceNullValue, obj, 0),;
                                                Eval(evalIfDataChanged, obj, {|| IIf(Empty(::number:getData()),, ::CheckReference()) }),;
                                                obj:setColorBG(XBPSYSCLR_WINDOW) }

        ::PG:killInputFocus := {|mp1, mp2, obj| Eval(evalIfDataChanged, obj, {|| ::FindPG(), ::FindPerson() }), obj:setColorBG(XBPSYSCLR_WINDOW) }

        ::family:killInputFocus := ::name:killInputFocus := ::name2:killInputFocus :=;
                                                                {|mp1, mp2, obj| mp1 := obj:changed,;
                                                                             obj:setData(FormatFIO(obj:getData())),;
                                                 IIf(mp1, ::UpdatePGFromFIOBtn(),),;
                                                 obj:setColorBG(XBPSYSCLR_WINDOW) }

    ::browser:killInputFocus := {|mp1, mp2, obj| obj:setColorBG(XBPSYSCLR_WINDOW) }

    ::right1:killInputFocus :=;
    ::electronic:killInputFocus :=;
    ::pensioner:killInputFocus := ::spouse:killInputFocus := ::children:killInputFocus := ::all:killInputFocus :=;
    ::vskTour:killInputFocus :=;
    ::printPensFIO:killInputFocus :=;
    ::printCalc:killInputFocus :=;
    ::printNotification:killInputFocus := {|mp1, mp2, obj| obj:setColorBG(XBPSYSCLR_DIALOGBACKGROUND) }

    ::summCalc:killInputFocus := {|mp1, mp2, obj| ::ParseCalcString(), obj:setColorBG(XBPSYSCLR_WINDOW) }

    ::right1:selected := {|chk, mp2, obj| IIf(chk, ::label4:show(), ::label4:hide()), ::UpdateRelatives() }

    ::paymentYear:itemSelected := {|mp1, mp2, obj| ::UpdateRelatives() }

    ::electronic:selected := {|chk, mp2, obj| AEval({ ::Static111, ::series, ::Static121, ::number, ::Static13 },;
                                                    IIf(chk, {|obj| obj:hide()}, {|obj| obj:show()})) }

    ::spouse:selected := ::children:selected := {|chk, mp2, obj| ::CheckBoxesToBuffer(obj, chk) }

    ::all:selected := {|chk, mp2, obj| IIf(::pensioner:isEnabled(), ::pensioner:setData(chk),),;
                                       ::spouse:setData(chk), ::children:setData(chk),;
                                       PostAppEvent(xbeP_Selected, chk,, ::spouse),;
                                       PostAppEvent(xbeP_Selected, chk,, ::children) }

        //   ENTER    
        onKeyPressed := {|key, xbp| IIf(xbeK_ENTER == key, PostAppEvent(xbeP_Keyboard, xbeK_TAB,, xbp),) }
    onKeyPressedEx := {|key, xbp, tab, vld, sel| sel := xbp:queryMarked(),;
                                                 IIf(key $ { xbeK_TAB, xbeK_SH_TAB },,;
                                                 IIf(xbeK_ENTER == key .OR. sel[1] > xbp:bufferLength .OR. !Empty(tab),;
                                                     PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, xbp),;
                                                 IIf(Empty(vld),, Eval(vld, xbp, key)))) }

    ::family:keyBoard := ::name:keyBoard := ::name2:keyBoard :=;
                         {|key, mp2, obj| Eval(onKeyPressedEx, key, obj, xbeK_SPACE == key,;
                                               {|sle| ValidateString(sle, {|c| IsAlpha(c) .OR. "-" == c }) }) }

    ::summCalc:keyBoard := {|key, mp2, obj| ValidateString(obj, {|c| c $ "1234567890 .,;fcvr'+" },;
                                            { {",", "."}, {";", ""}, {"f", ""}, {"c", ""}, {"v", ""},;
                                              {"r", ""}, {"'", ""}, {"", "."}, {"", "."}, { "+", ::CopyLastSumm() } }),;
                                            Eval(onKeyPressed, key, obj) }

        ::PG:keyBoard :=;
        ::status:keyBoard :=;
        ::paymentYear:keyBoard :=;
        ::series:keyBoard := ::number:keyBoard :=;
    ::pensioner:keyBoard := ::spouse:keyBoard := ::children:keyBoard := ::all:keyBoard := ::vskTour:keyBoard :=;
    ::printPensFIO:keyBoard :=;
    ::printCalc:keyBoard :=;
                                          {|key, mp2, obj| Eval(onKeyPressed, key, obj) }

        //   
    ::btnPGFromFIO:keyBoard :=;
    ::btnCivPensEdit:keyBoard := ::btnRelativesEdit:keyBoard := ::btnAccountEdit:keyBoard :=;
        ::btnDone:keyBoard := ::btnExit:keyBoard := ::btnExtra:keyBoard := ::btnPrinter:keyBoard :=;
                {|key, mp2, obj| IIf(xbeK_ENTER == key .OR. xbeK_SPACE == key, PostAppEvent(xbeP_Activate,,, obj),) }

    ::btnPGFromFIO:activate := {|mp1, mp2, obj| ::OnPGFromFIOBtnClicked() }
        ::btnDone:activate := {|mp1, mp2, obj| ::OnDoneBtnClicked(), dbf->(DbUnlock()) }
        ::btnExit:activate := {|mp1, mp2, obj| IIf(ConfirmBox(self, "     ?",;
                                           "", XBPMB_YESNO, XBPMB_QUESTION) == XBPMB_RET_YES,;
                                           PostAppEvent(xbeP_Quit,,, self),) }
    ::btnExtra:activate := {|mp1, mp2, obj| ::OnExtraBtnClicked() }
        ::btnPrinter:activate := {|mp1, mp2, obj| PrinterConfig():New(, self):Create(, self):showModal() }

    ::btnCivPensEdit:activate := {|mp1, mp2, obj| ::EditCivPens() }
    ::btnRelativesEdit:activate := {|mp1, mp2, obj| ::EditRelatives() }
    ::btnAccountEdit:activate := {|mp1, mp2, obj| ::EditAccount() }

RETURN

METHOD FareRegForm:InitConditions()
   LOCAL cPensCondition := CONDITIONS_ALLOWPENS, cRelativesCondition := CONDITIONS_ALLOWRELATIVES

   cPensCondition := StrTran(cPensCondition, "RANG", "fRank")
   cPensCondition := StrTran(cPensCondition, "STATUS", "aInfo[4]")
   cPensCondition := StrTran(cPensCondition, "VYEAR", "nTotal")
   cPensCondition := StrTran(cPensCondition, "VKAL", "nChrono")
   cPensCondition := StrTran(cPensCondition, "FAIRSOLDIER", "lFairSoldier")
   cPensCondition := StrTran(cPensCondition, "BASE", "aInfo[1]")

   cRelativesCondition := StrTran(cRelativesCondition, "RANG", "fRank")
   cRelativesCondition := StrTran(cRelativesCondition, "STATUS", "aInfo[4]")
   cRelativesCondition := StrTran(cRelativesCondition, "VYEAR", "nTotal")
   cRelativesCondition := StrTran(cRelativesCondition, "VKAL", "nChrono")
   cRelativesCondition := StrTran(cRelativesCondition, "FAIRSOLDIER", "lFairSoldier")
   cRelativesCondition := StrTran(cRelativesCondition, "BASE", "aInfo[1]")

   CONDITIONS_ALLOWPENS := "{|aInfo, fRank, nTotal, nChrono, lFairSoldier|" + cPensCondition + "}"
   CONDITIONS_ALLOWRELATIVES := "{|aInfo, fRank, nTotal, nChrono, lFairSoldier|" + cRelativesCondition + "}"

RETURN

******************************************************************************
* Request system resources
******************************************************************************
METHOD FareRegForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
        LOCAL fillComboBox, nYear := Year(Date())

   ShowStatusMessage("   ")
   ShowStatusMessage("[Done]", .T., 70)

   * Execute method of the super class
   ::_FareRegForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible, {|| ::CreateBrowser() } )

    aPos := AppDesktop():currentSize()
    aSize := ::currentSize()
    ::setPos({ (aPos[1] - aSize[1]) / 2, (aPos[2] - aSize[2]) / 2 },.T.)

        //   
        fillComboBox := {|array, combo, fmt| AEval(array, {|str| combo:addItem(IIf(Empty(str), "",;
                                        IIf(fmt != NIL, Eval(fmt, str), str))) }) }

        //   
        Eval(fillComboBox, { nYear - 3, nYear - 2, nYear - 1, nYear }, ::paymentYear, {|x| AllTrim(Str(x, 4))})
    ::paymentYear:SetData({ 4 })

    ::series:setData(SYS_POR);

    IF ::accessLevel < 2
      ::btnDone:disable()
    ENDIF

        //     
//        ::CreateBrowser()

   * Display the form
   ::ClearInputFields()
   ::show()

        SetAppFocus(::PG)
//::editControls
RETURN self

METHOD FareRegForm:CreateBrowser()

        LOCAL aColumns := {;
                { "", {|x| IIf(NIL == x, IIf(buf->(Bof()),, ASelect(::relations, buf->RELATION + 1)),) }, 4 },;
                { "", {|x| IIf(NIL == x, MakeFIO(::buf),) }, 20 },;
                { ". .", {|x| IIf(NIL == x, IIf(buf->(Bof()),, buf->BIRTH),) }, 5 },;
                { "", {|x| IIf(NIL == x, IIf(buf->PAID, IIf(buf->FOUND,"", "? ") + ".", IIf(buf->PAY, "", "")),) }, 5 },;
                { ".", {|x| IIf(NIL == x, IIf(Empty(buf->NOTE), "", ::paymentNotes[buf->NOTE + 1]),) }, 5 };
        }
//                { "", {|x| IIf(NIL == x, IIf(buf->(Bof()),, ASelect(::relations, buf->RELATION + 1) + " " +;
//                                                               MakeFIO(::buf)),) }, 23 },;

    ::browser:tabStop := .T.
    ::browser:hScroll := ::browser:vScroll := .F.
        ::browser:create()
        ::browser:cursorMode := XBPBRW_CURSOR_ROW

        ::browser:skipBlock     := {|n| buf->(DbSkipper(n)) }
        ::browser:goTopBlock    := {| | buf->(DbGoTop()) }
        ::browser:goBottomBlock := {| | buf->(DbGoBottom()) }

        ::browser:phyPosBlock   := {| | buf->(RecNo()) }

        ::browser:posBlock      := {| | buf->(DbPosition()) }
        ::browser:goPosBlock    := {|n| buf->(DbGoPosition(n)) }
        ::browser:lastPosBlock  := {| | 100 }
        ::browser:firstPosBlock := {| | 0 }

        ::browser:itemSelected := {|mp1, mp2, obj| IIf(buf->(Bof()) .OR. buf->PAID,, buf->PAY := Empty(buf->PAY)),;
                                               ::browser:refreshCurrent() }

        ::browser:keyBoard := {|key, mp2, obj| IIf(key $ { xbeK_ENTER, xbeK_SPACE }, Eval({|o, n| PostAppEvent(xbeBRW_ItemSelected,,, obj),;
                                           IIf(n, PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, obj),)}, obj, key == xbeK_ENTER),) }

        AEval(aColumns, {|x, i| ::browser:addColumn(x[2], x[3], x[1]) })

        ::browser:show()

RETURN

METHOD FareRegForm:UpdatePGFromFIOBtn()
   LOCAL aFIO := { ::family:getData(), ::name:getData(), ::name2:getData() }
   LOCAL cSeek := "", lNotFound
   LOCAL aTemp := {}

   ::possiblePG := { 0, {}}
   ::btnPGFromFIO:hide()

   IF Empty(aFIO[1]) .OR. Empty(aFIO[2]) .OR. Empty(aFIO[3])
     RETURN
   ENDIF

   AEval({20, 15, 15}, {|x, i| cSeek += PadR(aFIO[i], x)})

   IF rfm->(DbSeek(cSeek))
     DO WHILE cSeek == rfm->FAMILY
       lNotFound := .T.
       AEval(::possiblePG[2], {|x| IIf(lNotFound .AND. x[3] == rfm->PG, lNotFound := .F.,) })
       IIf(lNotFound, ::FindPG(rfm->PG, .T., .T., .T., .T.),)
       rfm->(DbSkip())
     ENDDO
     ::possiblePG[1] := 0
     PostAppEvent(xbeP_Activate, NIL, NIL, ::btnPGFromFIO)
   ENDIF

   civ->(OrdSetFocus("cpensfio"))
   IF civ->(DbSeek(cSeek))
     DO WHILE civ->FAMILY + civ->NAME + civ->NAME2 == cSeek
       AAdd(::possiblePG[2], {"civ", civ->(RecNo()), 0, civ->STATUS, civ->ID })
       civ->(DbSkip())
     ENDDO
   ENDIF

   pers->(OrdSetFocus("persfio"))
   IF pers->(DbSeek(cSeek))
     DO WHILE pers->FAMILY + pers->NAME + pers->NAME2 == cSeek
       IF !Empty(pers->PENSID) .AND. civ->(DbSeek(pers->PENSID,, "cpensid"))
         AAdd(::possiblePG[2], {"civ", civ->(RecNo()), 0, civ->STATUS, civ->ID })
       ELSE
         ::FindPG(pers->PG, .T., .T.)
       ENDIF
       pers->(DbSkip())
     ENDDO
   ENDIF

   IF Empty(::possiblePG[2])
     ::possiblePG[1] := 0
     ::PG:setData(0)
   ELSE
     ::possiblePG[1] := 1
     ::PG:setData(::possiblePG[2][1][3])
//     IF Len(::possiblePG[2]) > 1
//       ::btnPGFromFIO:show()
//     ENDIF
   ENDIF

   ::FindPerson()

RETURN

METHOD FareRegForm:OnPGFromFIOBtnClicked()
   IF Empty(::possiblePG[2])
     RETURN
   ENDIF

   ::possiblePG[1] := (::possiblePG[1] % Len(::possiblePG[2])) + 1
   ::PG:setData(::possiblePG[2][::possiblePG[1]][3])

   ::FindPerson()

RETURN

METHOD FareRegForm:CheckBoxesToBuffer(checkBox, state)

   buf->(DbGoTop())
   DO WHILE !buf->(Eof())
     IF buf->PAID
     ELSEIF buf->RELATION $ {0, 9}
       IF checkBox == ::spouse .AND. ::spouse:isEnabled()
         buf->PAY := ::spouse:getData()
       ENDIF
     ELSEIF buf->RELATION $ {1, 2, 14, 15}
       IF checkBox == ::children
         buf->PAY := ::children:getData()
       ENDIF
     ENDIF
     buf->(DbSkip())
   ENDDO
   buf->(DbGoTop())

   ::browser:refreshAll()

RETURN

METHOD FareRegForm:OnDoneBtnClicked()
   LOCAL oPrinter, oPS, aSize, aPos
   LOCAL nIndex, nOffset, recordIndex
   LOCAL aNotesLines := {}, aInfoLines := {}
   LOCAL aRecords := ::MakeRecord(), aRecord, aRec, aLocks, lFound, cSeek := "", cFIO := "", cBank
   LOCAL lActiveRecord := .F., lSPK := .F., lOnPaper, lPensFIO := ::printPensFIO:getData()
   LOCAL lVskTour := ::vskTour:getData(), lDontCheckRight := ::right1:getData()
   LOCAL makeSeek := {|pg, pensid, year| Str(pg, 6) + Str(pensid, 6) + Str(year, 4) + "0" }

   aPos := ::btnDone:currentPos()
   IF Empty(aRecords) .OR. !CheckPrinterStatus(self, ::printers[1][1]) .OR. !CheckPrinterStatus(self, ::printers[2][1])
     RETURN
   ENDIF

   aRecord := aRecords[1]
   lOnPaper := aRecord[REGFIELD_TIPBL] == 1

   IF !Empty(aRecord[REGFIELD_PG]) .AND. dbf->(DbSeek(aRecord[REGFIELD_PG]))
     lActiveRecord := Empty(dbf->PREKR)
     lSPK := 3 == dbf->TP
     IF !dbf->(RLock())
       ConfirmBox(self, " " + SYS_LITERA + "-" + AllTrim(Str(aRecord[REGFIELD_PG])) +;
                        "  /   ." + Chr(10) +;
                        "   .", "", XBPMB_OK, XBPMB_WARNING)
       RETURN
     ENDIF
   ENDIF

   IF ::right1:getData() .AND.;
      ConfirmBox(self, "     ." + Chr(10) +;
                 "          ?",;
                 "", XBPMB_YESNO, XBPMB_QUESTION, XBPMB_DEFBUTTON2) <> XBPMB_RET_YES
     RETURN
   ENDIF

   cSeek := Str(::user[2], 2) + Str(3, 2) + PadR(aRecord[REGFIELD_S], 6) + Str(aRecord[REGFIELD_N], 10)
   IF lOnPaper .AND. (abu->(DbSeek(cSeek)) .OR. !bus->(DbSeek(cSeek)) .OR. bus->SOST != 1)
     ConfirmBox(self, "       " + Chr(10) +;
                "    ", "", XBPMB_OK, XBPMB_WARNING)
     RETURN
   ENDIF

   IF ::printCalc:getData()
     aNotesLines := {}
     AAdd(aNotesLines, ::districts[aRecord[REGFIELD_DISTRICT] + 1] + " -")
     IIf(lActiveRecord,, AAdd(aNotesLines, IIf(2 == aRecord[REGFIELD_STATUS], "  ",;
                                           IIf(Empty(aRecord[REGFIELD_PG]), SYS_LITERA + "  ", ""))))
     IIf(lVskTour, AAdd(aNotesLines, "-"),)

     aInfoLines := {}
     AAdd(aInfoLines, IIf(Empty(aRecord[REGFIELD_PG]), "", "    " + SYS_LITERA + "-" + AllTrim(Str(aRecord[REGFIELD_PG])) +;
                      IIf(lActiveRecord, " ", " () ")) + " " + Str(aRecord[REGFIELD_YEAR], 4) + " ." +;
                      IIf(lVskTour, " (-)", ""))
     AAdd(aInfoLines, "")
     AAdd(aInfoLines, "     :")
     AAdd(aInfoLines, "  (/): " + ::serviceTimeTotal:getData() + "/" + ::serviceTimeChrono:getData())
     AAdd(aInfoLines, " : " + ::rank:getData())
     AAdd(aInfoLines, " : " + IIf(2 == aRecord[REGFIELD_STATUS], "  ", ::retirement:getData()))

     IIf(REPORT_INCLUDEFIO .OR. REPORT_INCLUDEFAMILY, AAdd(aInfoLines, ""),)
     IF REPORT_INCLUDEFIO
       IF lSPK
         IIf(rpd->(DbSeek(aRecord[REGFIELD_PG])), cFIO := ::relations[rpd->RODST + 1] + " " + MergeFIO(rpd->GCONAME, rpd->GNAME, rpd->GFNAME, "-"),)
       ELSEIF !lPensFIO .AND. ::possiblePG[2][::possiblePG[1]][1] <> "dbf" .AND. Len(aRecords) > 1
         cFIO := ::relations[aRecords[2][REGFIELD_RELATION] + 1] + " " + MergeFIO(aRecords[2][REGFIELD_FAMILY], aRecords[2][REGFIELD_NAME], aRecords[2][REGFIELD_NAME2], "-")
       ELSE
         cFIO := MergeFIO(aRecord[REGFIELD_FAMILY], aRecord[REGFIELD_NAME], aRecord[REGFIELD_NAME2], "-")
       ENDIF
       AAdd(aInfoLines, ": " + cFIO)
     ENDIF
     IF REPORT_INCLUDEFAMILY
       AAdd(aInfoLines, "     :")
       AEval(aRecords, {|x| IIf(x[REGFIELD_CODE] <> 0, AAdd(aInfoLines, IIf(x[REGFIELD_RELATION] <> 13, ::relations[x[REGFIELD_RELATION] + 1] + " ", "") +;
                                                             MergeFIO(x[REGFIELD_FAMILY], x[REGFIELD_NAME], x[REGFIELD_NAME2], "-") +;
                                                             IIf(Empty(x[REGFIELD_BIRTH]), "", " " + DtoC(x[REGFIELD_BIRTH]) + " .") +;
                                                             IIf(x[REGFIELD_RELATION] <> 13, " - " + ::categories[x[REGFIELD_STATUS] + 1], "")),) })
     ENDIF

//   PrintBlank(self, ::printers[2][1], ::printers[2][2], ::printers[2][3], { ::printers[2][4], ::printers[2][5] }, aRecord, ::user[3], ::banks)
     PrintCalc(self, ::printers[1][1]:devName, ::printers[1][2], ::printers[1][3], { ::printers[1][4], ::printers[1][5] },;
               aRecord, ::calcParams, aNotesLines, aInfoLines, ::user[3])

     IF ConfirmBox(self, "   ..." + Chr(10) + Chr(10) +;
                   "     " + Chr(10) +;
                   "  " + IIf(lOnPaper, "   ?", ""),;
                   "", XBPMB_YESNO, XBPMB_QUESTION, XBPMB_DEFBUTTON2) <> XBPMB_RET_YES
        RETURN
     ENDIF
   ENDIF

   cSeek := Eval(makeSeek, aRecord[REGFIELD_PG], aRecord[REGFIELD_PENSID], aRecord[REGFIELD_YEAR])

   IF reg->(DbSeek(cSeek))
     DO WHILE Eval(makeSeek, reg->PG, reg->PENSID, reg->YEAR) == cSeek
       IF 0 == reg->NOTE
         FOR recordIndex := 1 TO Len(aRecords)
           aRec := aRecords[recordIndex]
           IF Empty(aRec[REGFIELD_CODE])
             LOOP
           ENDIF
           lFound := .T.
           AEval({ { reg->RELATION, REGFIELD_RELATION }, { reg->FAMILY, REGFIELD_FAMILY }, { reg->NAME, REGFIELD_NAME }, { reg->NAME2, REGFIELD_NAME2 } },;
                 {|x| IIf(lFound .AND. x[1] <> aRec[x[2]], lFound := .F.,) })
           IF lFound
             ConfirmBox(self, "    ." + Chr(10) +;
                              "      .",;
                              "", XBPMB_OK, XBPMB_WARNING)
             ::UpdateRelatives()
             RETURN
           ENDIF
         NEXT
       ENDIF
       reg->(DbSkip())
     ENDDO
   ENDIF

   aLocks := { { reg->(FLock()), params->(FLock()), rec->(FLock()) },;
               { ::reg, ::params, ::rec },;
               { "farereg.dbf", "payparams.dbf", "base.rec" } }
   IF lOnPaper
     AAdd(aLocks[1], bus->(RLock()))
     AAdd(aLocks[2], ::bus)
     AAdd(aLocks[3], "base.bus")
   ENDIF
   nIndex := AScan(aLocks[1], .F.)
   IF nIndex > 0
     ConfirmBox(self, "     " + aLocks[3][nIndex] + Chr(10) +;
                "   .", "", XBPMB_OK, XBPMB_WARNING)
     AEval(aLocks[2], {|x,i| IIf(aLocks[1][i], (x)->(DbUnlock()),) })
     RETURN
   ENDIF

   AEval(aRecords, {|x| IIf(x[REGFIELD_CODE] <> 0, SetRecord(::reg, x, .T., .T.),) })
   reg->(DbUnlock())

   aRecord := aRecords[1]
   IIf(Empty(aRecord[REGFIELD_CODE]), aRecord[REGFIELD_CODE] := aRecords[2][REGFIELD_CODE],)
   aRec := ::possiblePG[2][::possiblePG[1]]
   IF lSPK
     IIf(rpd->(DbSeek(aRecord[REGFIELD_PG])), AEval({ { REGFIELD_FAMILY, rpd->GCONAME }, { REGFIELD_NAME, rpd->GNAME }, { REGFIELD_NAME2, rpd->GFNAME } },;
                                                    {|x| aRecord[x[1]] := x[2] }),)
   ELSEIF !lPensFIO .AND. aRec[1] <> "dbf" .AND. Len(aRecords) > 1
     AEval({ REGFIELD_FAMILY, REGFIELD_NAME, REGFIELD_NAME2, REGFIELD_BANK, REGFIELD_ACCOUNT }, {|x| aRecord[x] := aRecords[2][x] })
   ENDIF

   cSeek := Str(aRecord[REGFIELD_TIPBL], 1) + aRecord[REGFIELD_S] + Str(aRecord[REGFIELD_N], 10)
   IF params->(DbSeek(cSeek))
     DO WHILE Str(params->TIPBL, 1) + params->S + Str(params->N, 10) == cSeek
       IF PARAM_VSKTOUR == params->NAME
         params->VALUE := IIf(lVskTour, ".T.", ".F.")
         lVskTour := .F.
       ELSEIF PARAM_DONTCHECK == params->NAME
         params->VALUE := IIf(lDontCheckRight, ".T.", ".F.")
         lDontCheckRight := .F.
       ENDIF
       params->(DbSkip())
     ENDDO
   ENDIF
   IF lVskTour
     AddRecord("params", { { "TIPBL", aRecord[REGFIELD_TIPBL] }, { "S", aRecord[REGFIELD_S] }, { "N", aRecord[REGFIELD_N] },;
                           { "NAME", PARAM_VSKTOUR }, { "TYPE", "L" }, { "SIZE", 1.0 }, { "VALUE",  ".T." } }, .T.)
   ENDIF
   IF lDontCheckRight
     AddRecord("params", { { "TIPBL", aRecord[REGFIELD_TIPBL] }, {"S", aRecord[REGFIELD_S] }, { "N", aRecord[REGFIELD_N] },;
                           { "NAME", PARAM_DONTCHECK }, { "TYPE", "L" }, { "SIZE", 1.0 }, { "VALUE",  ".T." } }, .T.)
   ENDIF
   params->(DbUnlock())

   AddRecord("rec", { { "PG", aRecord[REGFIELD_PG] }, { "PREKR", IIf(lActiveRecord, 0, 1) },;
                      { "RN", aRecord[REGFIELD_DISTRICT] },;
                      { "DATELIST", CtoD("01.01." + Str(aRecord[REGFIELD_YEAR], 4)) },;
                      { "DATESROK", CtoD("31.12." + Str(aRecord[REGFIELD_YEAR], 4)) },;
                      { "DATEVYSYL", aRecord[REGFIELD_DATE] }, { "PENSIONSUM", aRecord[REGFIELD_SUMM] },;
                      { "TIPBL", aRecord[REGFIELD_TIPBL] }, { "SER", aRecord[REGFIELD_S] },;
                      { "PL", IIf(Empty(aRecord[REGFIELD_N]), "", Str(aRecord[REGFIELD_N], 7)) },;
                      { "KOD", aRecord[REGFIELD_CODE] }, { "CSR", PEV_PARAMS[7] },;
                      { "RAZ", .T. }, /*{ "SYSOP", ::user[1] }, */{ "ISPOLN", ::user[3] },;
                      { "PRIM", 0 } }, .T.)
   //IIf(lActiveRecord,, rec->(DbDelete()))
   rec->(DbUnlock())

   IIf(lActiveRecord,, aRecord[REGFIELD_PG] := 0)

   cBank := GetBank(aRecord[REGFIELD_DISTRICT], aRecord[REGFIELD_BANK], aRecord[REGFIELD_MODE],;
                    ::districts, ::banks, ::banks2districts)
   IF lOnPaper
     AddRecord("bus", { { "RN", 0 }, { "NUSER", ::user[2] }, { "VIDBCO", 3 },;
                        { "SER", aRecord[REGFIELD_S] }, { "NN", aRecord[REGFIELD_N] }, { "SOST", 2 },;
                        { "PG", aRecord[REGFIELD_PG] }, { "FAMILY", aRecord[REGFIELD_FAMILY] },;
                        { "NAME", aRecord[REGFIELD_NAME] }, { "NAME2", aRecord[REGFIELD_NAME2] },;
                        { "SUMMA", aRecord[REGFIELD_SUMM] }, { "KOD", aRecord[REGFIELD_CODE] },;
                        { "DVYSYL", aRecord[REGFIELD_DATE] }, { "RAIN", aRecord[REGFIELD_DISTRICT] + 1 } }, .F.)
     bus->(DbUnlock())

     PrintBlank(self,;
                ::printers[2][1]:devName, ::printers[2][2], ::printers[2][3], { ::printers[2][4], ::printers[2][5] },;
                aRecord, ::user[3], cBank)
   ENDIF

   IF ::printNotification:getData()
     PrintNotification(self,;
                       ::printers[1][1]:devName, ::printers[1][2], ::printers[1][3], { ::printers[1][4], ::printers[1][5] },;
                       aRecord, ::user[3], cBank, FrdbGetInfo(aRecord))
   ENDIF

   ::UpdateRelatives()
   ::number:setData(0)
   ::printCalc:setData(INTERFACE_ALLOWCALCULATIONS)
   ::printNotification:setData(INTERFACE_ALLOWNOTIFICATIONS)
   ::electronic:setData(INTERFACE_ALLOWELECTRONIC)

   SetAppFocus(::PG)

RETURN

METHOD FareRegForm:OnExtraBtnClicked()
   LOCAL oEditor

   IF Empty(::possiblePG[2])
     RETURN
   ENDIF

   oEditor := ExtraDlg():New(, self):Create(, self)

   ::XbpDialog:hide()
   //ShowCreepingLine(", ,    ... ")
   oEditor:showModal()

   ::XbpDialog:show()
   ::UpdateRelatives()

   SetAppFocus(::paymentYear)

RETURN

METHOD FareRegForm:ClearInputFields(clearPensInfo)
   LOCAL dDate := Date()

   ::warning1:hide()
   ::warning2:hide()
   ::label2:hide()

   IF !Empty(clearPensInfo)
     ::district:setData("")
     ::status:setData("")

     ::serviceTimeTotal:setData("")
     ::serviceTimeChrono:setData("")
     ::countWork:setData(.F.)
     ::label1:setColorFG(GRA_CLR_BLACK)
     ::rank:setData("")
     ::retirement:setData("")
     ::right1:setData(.F.)
     ::label4:hide()
     ::printPensFIO:setData(.F.)

     buf->(DbZap())

     ::paymentYear:SetData({ 4 })

     ::browser:refreshAll()
     ::browser:forceStable()
   ENDIF

   IIf(Len(::possiblePG[2]) > 1, ::btnPGFromFIO:show(), ::btnPGFromFIO:hide())

   ::pensioner:enable()
   ::pensioner:setData(.F.)
   ::pensioner:tooltipText := ""
   ::spouse:enable()
   ::spouse:setData(.F.)
   ::children:setData(.F.)
   ::all:setData(.F.)
   ::vskTour:setData(.F.)
   ::summCalc:setData("")
   ::summ:setData("")

    ::curDate:setData(DtoC(dDate))

//        SetAppFocus(::PG)

RETURN

METHOD FareRegForm:CheckReference()
   LOCAL cSer := PadR(AllTrim(::series:getData()), 6), nNum := ::number:getData()
   LOCAL aPos, lFound := .F.

   AEval(::blankNumbers, {|x| IIf(cSer == x[1] .AND. nNum >= x[2] .AND. nNum <= x[3], lFound := .T.,) })
   IF lFound
     RETURN
   ENDIF

   aPos := ::series:currentPos()
   ShowNotification(self, { aPos[1], aPos[2] + 60 }, "    " + Chr(10) +;
                    "      ")

   ::series:setData(SYS_POR)
   ::number:setData(0)
RETURN

METHOD FareRegForm:FindPG(nPG, lDontSetXbpData, lAppend, lIgnoreLinks)
   LOCAL nPG1, nDlgResult

   DEFAULT nPG TO ::PG:getData()
   DEFAULT lDontSetXbpData TO .F.
   DEFAULT lAppend TO .F.

   IIf(lAppend,, ::possiblePG := { 0, {} })

   IF Empty(nPG)
     IIf(lDontSetXbpData,, ::PG:setData(0))
     RETURN .F.
   ENDIF

   IIf(lDontSetXbpData,, ::PG:setData(nPG))

   IF !rpd->(DbSeek(nPG))
         ShowNotification(self, ::PG:currentPos(), SYS_LITERA + "    ")
     RETURN ::FindPG(0, lDontSetXbpData, lAppend)
   ELSEIF dbf->(DbSeek(nPG))
     IF Empty(dbf->PREKR)
       AAdd(::possiblePG[2], { "dbf", dbf->(RecNo()), nPG, IIf(dbf->TP <> 3, 1, IIf(1 == dbf->MANOWAR, 4, 3)), 0 })
     ELSEIF 0 == rpd->PRICHINA
       AAdd(::possiblePG[2], { "rpd", rpd->(RecNo()), nPG, IIf(rpd->TP <> 3, 1, 3), 0 })
     ELSEIF 3 == rpd->TP
       AAdd(::possiblePG[2], { "rpd", rpd->(RecNo()), nPG, 3, 0 })
     ELSE
       AAdd(::possiblePG[2], { "rpd", rpd->(RecNo()), nPG, ::dismissalCauses[rpd->PRICHINA + 1], 0 })
     ENDIF
   //     
   ELSEIF Empty(lIgnoreLinks) .AND. !Empty(rpd->WOZPG)
     nPG1 := rpd->WOZPG
     nDlgResult := ConfirmBox(self,;
                              " " + SYS_LITERA + "-" + AllTrim(Str(nPG, 6)) + "    " +;
                              SYS_LITERA + "-" + AllTrim(Str(nPG1, 6)) + "." + Chr(10) + "?",;
                              "",;
                              XBPMB_YESNOCANCEL,;
                              XBPMB_QUESTION)
     RETURN IIf(XBPMB_RET_NO == nDlgResult, ::FindPG(nPG, lDontSetXbpData, lAppend, .T.),;
            ::FindPG(IIf(XBPMB_RET_YES == nDlgResult, nPG1, 0), lDontSetXbpData, lAppend))
   //     
   ELSEIF Empty(lIgnoreLinks) .AND. !Empty(rpd->WSHPG)
     nPG1 := rpd->WSHPG
     nDlgResult := ConfirmBox(self,;
                              " " + SYS_LITERA + "-" + AllTrim(Str(nPG, 6)) + "     " +;
                              SYS_LITERA + "-" + AllTrim(Str(nPG1, 6)) + "." + Chr(10) + "?",;
                              "",;
                              XBPMB_YESNOCANCEL,;
                              XBPMB_QUESTION)
     RETURN IIf(XBPMB_RET_NO == nDlgResult, ::FindPG(nPG, lDontSetXbpData, lAppend, .T.),;
            ::FindPG(IIf(XBPMB_RET_YES == nDlgResult, nPG1, 0), lDontSetXbpData, lAppend))
   ELSEIF 0 == rpd->PRICHINA
     AAdd(::possiblePG[2], { "rpd", rpd->(RecNo()), nPG, IIf(rpd->TP <> 3, 1, 3), 0 })
   ELSEIF 3 == rpd->TP
     AAdd(::possiblePG[2], { "rpd", rpd->(RecNo()), nPG, 3, 0 })
   ELSE
     AAdd(::possiblePG[2], { "rpd", rpd->(RecNo()), nPG, ::dismissalCauses[rpd->PRICHINA + 1], 0 })
   ENDIF

   ::possiblePG[1] := 1

RETURN .T.

METHOD FareRegForm:FindPerson()
   LOCAL aRecord := {}, nPos
   LOCAL nPG := 0, aInfo, nStatus, cStatus, fRank, lEnsign, lOfficer, lSeniorOfficer, nTotal, nChrono, lFairSoldier
   LOCAL aFIO := { ::family, ::name, ::name2 }
   LOCAL enableSLE := {|sle| sle:setData(""), sle:enable() }

   ::rights := { .F., .F. }

   ::ClearInputFields(.T.)
   IF Empty(::possiblePG[2])
     AEval(aFIO, enableSLE)
     RETURN
   ENDIF

   aInfo := ::possiblePG[2][::possiblePG[1]]
   nPG := aInfo[3]

   AEval(aFIO, {|x| IIf(Empty(nPG), Eval(enableSLE, x), x:disable() )})
   IF !Empty(nPG)
     SetAppFocus(::paymentYear)
   ENDIF

   //     
   AEval(::field2xbp[1], {|x| SetXbpData(::field2xbp, aInfo[1], aInfo[2], x, aRecord) })
   cStatus := ::statuses[aInfo[4]]
   IF "rpd" == aInfo[1]
     ::label1:setColorFG(GRA_CLR_RED)
     nPos := civ->(RecNo())
     rpd->(DbGoTo(aInfo[2]))
     cStatus := "[" + IIf(Empty(rpd->AKT),"] ", "/] ") + cStatus
     rpd->(DbGoTo(nPos))
   ENDIF
   ::status:setData(cStatus)

   // 
   fRank := IIf(Empty(aRecord[2]), 0, aRecord[2])
   //  
   nTotal := IIf(Empty(aRecord[6]), 0, aRecord[6])
   //  
   nChrono := IIf(Empty(aRecord[7]), 0, aRecord[7])
   //   ?
   lFairSoldier := IIf(Empty(aRecord[9]), .F., Trim(aRecord[9]) $ ::fairRetirement)
   //    ?
   ::rights[1] := Eval(&CONDITIONS_ALLOWPENS, aInfo, fRank, nTotal, nChrono, lFairSoldier)
                  /*(lSeniorOfficer .AND. (aInfo[4] $ { 2, 4 } .OR. nChrono >= 20)) .OR.;
                  (lEnsign .AND. nTotal >= 20 .AND. lFairSoldier) .OR.;
                  (lOfficer .AND. (nChrono >= 25 .OR. (nTotal >= 20 .AND. lFairSoldier)))*/
   //      (   )?
   ::rights[2] := Eval(&CONDITIONS_ALLOWRELATIVES, aInfo, fRank, nTotal, nChrono, lFairSoldier)
                  /*"dbf" == aInfo[1] .OR.;
                  /*!(aInfo[4] $ { 2, 3, 4, 7 }) .OR.*/;
                  /*(lSeniorOfficer .AND. (aInfo[4] $ { 2, 4 } .OR. nChrono >= 20))*/

   IIf(::rights[1] .AND. ::rights[2], ::right1:disable(), ::right1:enable())

   ::GetRelatives(nPG, aInfo[5])
   ::UpdateRelatives(.T.)

RETURN

METHOD FareRegForm:GetRelatives(nPG, nPensID)
   LOCAL nPersonType := 0, lFound := .F.
   LOCAL dDate := Date(), cDate := DtoC(dDate), aDate := {}

   ::relatives := { { nPG, nPensID, .F., {|| .F.} } }

   IF Empty(nPG)
     civ->(OrdSetFocus("cpensid"))
     IF civ->(DbSeek(nPensID)) .AND. civ->STATUS >= 0
       pers->(OrdSetFocus("perspi"))
       pers->(DbSeek(nPensID))
       DO WHILE pers->PENSID == nPensID
         AAdd(::relatives, {pers->ID, pers->PENSID, 0, pers->RELATION, pers->FAMILY, pers->NAME, pers->NAME2, pers->BIRTH, /*IIf(::rights[2], */pers->STATUS/*, 0)*/ })
         pers->(DbSkip())
       ENDDO
       ::relatives[1][3] := civ->STATUS $ { 2 }
     ENDIF

     ::relatives[1][4] := {|| buf->PERSONID == reg->PERSONID }
   ELSEIF rpd->(DbSeek(nPG))
     AAdd(aDate, CtoD(Left(cDate, 6) + Str(Year(dDate) - 18, 4)))
     AAdd(aDate, CtoD(Left(cDate, 6) + Str(Year(dDate) - 23, 4)))
     AAdd(aDate, CtoD(Left(cDate, 6) + Str(Year(dDate) - 5, 4)))

     pers->(OrdSetFocus("perspg"))
     IF pers->(DbSeek(nPG))
       DO WHILE pers->PG == nPG
         lFound := .F.
         AEval(::relatives, {|x| IIf(!lFound .AND. x[4] == pers->RELATION .AND. x[5] == pers->FAMILY .AND.;
                                 x[6] == pers->NAME .AND. x[7] == pers->NAME2, lFound := .T.,) }, 2)
         IIf(lFound,, AAdd(::relatives, {pers->ID, 0, nPG, pers->RELATION,;
                           pers->FAMILY, pers->NAME, pers->NAME2, pers->BIRTH, /*IIf(::rights[2], */pers->STATUS/*,)*/ }))
         pers->(DbSkip())
       ENDDO
     ENDIF

     IF dep->(DbSeek(nPG))
       DO WHILE dep->PG == nPG
         /* */
         nPersonType := 0
         IF /*()*/dep->A $ { 0, 9 }
           nPersonType := 1
         ELSEIF /**/1 == dep->SNI
           nPersonType := 2
         ELSEIF /**/dep->A $ { 1, 2, 14, 15 }
           /*  */
           nPersonType := 3
           IF /*  */dep->I $ { 4, 5, 6, 7 }
             nPersonType := 4
           ELSEIF /**/dep->E > aDate[1]
             nPersonType := 5
           ELSEIF /*  */dep->E > aDate[2] .AND. dep->F <> NIL .AND.;
                  (/*  */(dep->G == NIL .AND. dep->F > aDate[3]) .OR.;
                  /*  */(dep->G <> NIL .AND. dep->G > dDate))
             nPersonType := 6
           ENDIF
         ENDIF
         lFound := .F.
         AEval(::relatives, {|x| IIf(!lFound .AND. x[4] == dep->A .AND. x[5] == dep->B .AND.;
                                 x[6] == dep->C .AND. x[7] == dep->D, lFound := .T.,) }, 2)
         IIf(lFound,, AAdd(::relatives, {0, 0, nPG, dep->A, dep->B, dep->C, dep->D, dep->E, /*IIf(::rights[2], */nPersonType/*, 0)*/ }))
         dep->(DbSkip())
       ENDDO
     ENDIF

     DO WHILE rpd->PG == nPG
       IIf(3 == rpd->TP, ::relatives[1][3] := .T.,)
       IF Empty(rpd->GCONAME)
         IIf(1 == rpd->PRICHINA, ::relatives[1][3] := .T.,)
       ELSE
         lFound := .F.
         AEval(::relatives, {|x| IIf(!lFound .AND. x[4] == rpd->RODST .AND. x[5] == rpd->GCONAME .AND.;
                                 x[6] == rpd->GNAME .AND. x[7] == rpd->GFNAME, lFound := .T.,) }, 2)
         nPersonType := IIf (rpd->RODST $ { 0, 9 }/* .AND. ::rights[2]*/, 1, 0)
         IIf(lFound,, AAdd(::relatives, {0, 0, nPG, rpd->RODST, rpd->GCONAME, rpd->GNAME, rpd->GFNAME, NIL, nPersonType }))
       ENDIF
       rpd->(DbSkip())
     ENDDO

     ::relatives[1][4] := {|| buf->RELATION == reg->RELATION .AND. buf->FAMILY == reg->FAMILY .AND.;
                              buf->NAME == reg->NAME .AND. buf->NAME2 == reg->NAME2 }
   ENDIF

RETURN

METHOD FareRegForm:UpdateRelatives(lDontClear/*nPG, aInfo*/)
   LOCAL nYear := Val(::paymentYear:XbpSLE:getData()), lCheckRight := !::right1:getData()
   LOCAL cSeek := "", bLocate := {|| .F. }, nPG, PensID := 0, lDead := .F., lFound
   LOCAL makeSeek := {|pg, pensid, year| Str(pg, 6) + Str(pensid, 6) + Str(year, 4)/* + "0"*/ }
   LOCAL nIndex, aRel, aDate := {}, nPersonType

   IIf(Empty(lDontClear), ::ClearInputFields(),)

   nPG := ::relatives[1][1]
   nPensID := ::relatives[1][2]
   lDead := ::relatives[1][3]
   bLocate := ::relatives[1][4]

   IIf(lDead, ::pensioner:disable(),)

   AAdd(aDate, StoD(Str(nYear - 18, 4) + "0101"))
   AAdd(aDate, StoD(Str(nYear - 23, 4) + "0101"))
   AAdd(aDate, StoD(Str(nYear - 5, 4) + "0101"))
   AAdd(aDate, StoD(Str(nYear, 4) + "0101"))

   buf->(DbZap())
   FOR nIndex := 2 TO Len(::relatives)
     aRel := ::relatives[nIndex]
     IF Empty(aRel[1]) .AND. !Empty(aRel[3]) .AND. aRel[9] $ { 3, 5, 6 }
       IF dep->(DbSeek(nPG))
         DO WHILE dep->PG == nPG
           IF dep->A == aRel[4] .AND. dep->B == aRel[5] .AND. dep->C == aRel[6] .AND. dep->D == aRel[7] .AND. dep->E == aRel[8]
             /*  */
             nPersonType := 3
             IF /**/dep->E > aDate[1]
               nPersonType := 5
             ELSEIF /*  */dep->E > aDate[2] .AND. dep->F <> NIL .AND.;
                    (/*  */(dep->G == NIL .AND. dep->F > aDate[3]) .OR.;
                    /*  */(dep->G <> NIL .AND. dep->G > aDate[4]))
               nPersonType := 6
             ENDIF
           ENDIF
           ::relatives[nIndex][9] := nPersonType
           dep->(DbSkip())
         ENDDO
       ENDIF
     ENDIF

     buf->(DbAppend())
     AEval(aRel, {|x, i| IIf(Empty(x),, buf->(FieldPut(i, x)))})
     IIf(buf->STATUS $ { -1, 0, 3 }, buf->(DbDelete()),)
   NEXT
   buf->(DbPack())

   IF !::right1:getData()
     IF !::rights[2]
       buf->(DbZap())
     ENDIF

     IF !::rights[1]
       buf->(DbZap())
       ::pensioner:disable()
       ::browser:refreshAll()
       ::browser:forceStable()
       RETURN
     ENDIF
   ENDIF

   cSeek := Eval(makeSeek, nPG, nPensID, nYear)

   IF reg->(DbSeek(cSeek))
     DO WHILE Eval(makeSeek, reg->PG, reg->PENSID, reg->YEAR) == cSeek
       IF 0 == reg->NOTE
         IF reg->USER $ { 1000, 1001, 1002, 1003, 1004, 1005 }
           ::warning1:show()
           IF reg->USER $ { 1001, 1003, 1005 }
             ::warning2:show()
           ENDIF
         ENDIF
         lFound := .F.
         SET DELETED OFF
         IF 1 == reg->TIPBL .AND. rec->(DbSeek(reg->S + Str(reg->N, 7))) .AND. 1 == rec->TIPBL .AND.;
            PEV_PARAMS[1] == rec->KOD .AND. 0 == rec->PRIM
               IF 13 == reg->RELATION
                 lFound := .T.
               ELSEIF buf->(DbLocate(bLocate))
                 buf->FOUND := .T.
               ENDIF
         ENDIF

         SET DELETED ON
         IF 13 == reg->RELATION
           ::pensioner:setData(.T.)
           ::pensioner:disable()
           IIf(lFound,, ::label2:show())
           FrdbCheckPayParams(reg->TIPBL, reg->S, reg->N, { PARAM_VSKTOUR }, { {|| ::pensioner:tooltipText := "-" } })
         ELSEIF buf->(DbLocate(bLocate)) .AND. Empty(buf->PAID)
           IF buf->RELATION $ {0, 9}
             ::spouse:setData(.T.)
             ::spouse:disable()
           ENDIF
           buf->PAID := .T.
           FrdbCheckPayParams(reg->TIPBL, reg->S, reg->N, { PARAM_VSKTOUR }, { {|| buf->NOTE := 1 } })
         ENDIF
       ENDIF
       reg->(DbSkip())
     ENDDO
   ENDIF

   buf->(DbGoTop())

   ::browser:refreshAll()
   ::browser:forceStable()

RETURN

METHOD FareRegForm:ParseCalcString()
   LOCAL cLine := AllTrim(::summCalc:getData()) + " "
   LOCAL nIndex := 0, cItem, nSumm := 0, nSummTotal := 0, charPos

   ::calcParams := {}

   DO WHILE !Empty(cLine)
     nIndex := At(" ", cLine)
     IF nIndex <= 1
       EXIT
     ENDIF
     cItem := StrTran(Left(cLine, nIndex - 1), ",", ".")
     FOR charPos := 2 TO Len(cItem)
       IF !(SubStr(cItem, charPos, 1) $ "0123456789.")
         cItem := ""
         EXIT
       ENDIF
     NEXT
     IF Len(cItem) < 2 .OR. !(cItem[1] $ "") .OR. At(".", cItem) <> RAt(".", cItem)
       EXIT
     ENDIF
     nSumm := Val(SubStr(cItem, 2))
     AAdd(::calcParams, { cItem[1], nSumm })
     nSummTotal += nSumm
     cLine := LTrim(SubStr(cLine, nIndex))
   ENDDO

   cLine := ""
   AEval(::calcParams, {|x| cLine += x[1] + AllTrim(Str(x[2], 9, 2)) + " " })
   ::summCalc:setData(cLine)
   ::summ:setData(AllTrim(Str(nSummTotal, 12, 2)))

RETURN

METHOD FareRegForm:MakeRecord()

   LOCAL aResult := {}, aRecord := {}, aRec := {}, cSeek, nCount := 1, aPos, nCur
   LOCAL lActiveRecord, lPensFIO := ::printPensFIO:getData(), lOnPaper := !::electronic:getData()
   LOCAL nYear := Val(::paymentYear:XbpSLE:getData())
   LOCAL cSeries := ::series:getData(), nNumber := ::number:getData(), cSumm := ::summ:getData()
   LOCAL nSumm := IIf(Empty(cSumm), 0, Val(cSumm))
   LOCAL getXbpData := {|xbp, i| IIf(Empty(xbp:getData()),, aRecord[i] := xbp:getData()) }
   LOCAL aBanks := {}, aAccounts := {}

   IF !IIf(lOnPaper, .T., FrdbGenerateSeriesAndNumber(@cSeries, @nNumber))
     RETURN {}
   ENDIF

   ASize(aRecord, Len(g_aRegDbStruct))
   AEval({ {REGFIELD_TIPBL, IIf(lOnPaper, 1, 5)}, {REGFIELD_S, cSeries}, {REGFIELD_N, nNumber}, {REGFIELD_YEAR, nYear}, {REGFIELD_SUMM, nSumm} }, {|x| aRecord[x[1]] := x[2] })

   aPos := ::btnDone:currentPos()
   aPos[2] += 21
   IF Empty(::possiblePG[2])
     ShowNotification(self, { aPos[1] - 40, aPos[2] }, "  ")
     RETURN {}
   ELSEIF lOnPaper .AND. (Empty(aRecord[REGFIELD_S]) .OR. Empty(aRecord[REGFIELD_N]))
     ShowNotification(self, { aPos[1] - 144, aPos[2] }, "     ")
     RETURN {}
   ELSEIF Empty(aRecord[REGFIELD_SUMM])
     ShowNotification(self, { aPos[1] - 16, aPos[2] }, "  ")
     RETURN {}
   ELSEIF Empty(::district:getData())
     ShowNotification(self, { aPos[1] - 16, aPos[2] }, " ")
     RETURN {}
   ENDIF

   aRec := ::possiblePG[2][::possiblePG[1]]
   lActiveRecord := "dbf" == aRec[1]
   IF lActiveRecord .AND. 3 == dbf->TP .AND.;
      (!rpd->(DbSeek(aRec[3])) .OR. Empty(rpd->GCONAME) .OR. Empty(rpd->GNAME) .OR. Empty(rpd->GFNAME))
     ShowNotification(self, { aPos[1] - 128, aPos[2] }, "    ")
     RETURN {}
   ENDIF

   AEval({ {REGFIELD_PERSONID, 0}, {REGFIELD_PENSID, aRec[5]}, {REGFIELD_PG, aRec[3]}, {REGFIELD_RELATION, 13}, {REGFIELD_STATUS, aRec[4]}, {REGFIELD_MODE, IIf(lActiveRecord, 1, 0) },;
           {REGFIELD_CODE, PEV_PARAMS[1]}, {REGFIELD_BANK, ""}, {REGFIELD_ACCOUNT, ""}, {REGFIELD_NOTE, 0}, {REGFIELD_USER, ::user[1]} },;
         {|x| aRecord[x[1]] := x[2] })

   &(aRec[1] + "->(DbGoTo(" + AllTrim(Str(aRec[2])) + "))")
   AEval({ {REGFIELD_FAMILY, "FAMILY"}, {REGFIELD_NAME, "NAME"}, {REGFIELD_NAME2, "NAME2"}, {REGFIELD_BIRTH, "BORN"}, {REGFIELD_DISTRICT, "RN"} },;
         {|x, i| aRecord[x[1]] := &(aRec[1] + "->" + x[2]) })

   aRecord[REGFIELD_DATE] := CtoD(::curDate:getData())

   IF !::pensioner:isEnabled() .OR. !::pensioner:getData()
     aRecord[REGFIELD_CODE] := 0
     nCount--
   ENDIF

   IF lActiveRecord
     aRecord[REGFIELD_BANK] := dbf->FILIAL
     aRecord[REGFIELD_ACCOUNT] := dbf->NOLIC
     AAdd(aBanks, aRecord[REGFIELD_BANK])
     AAdd(aAccounts, aRecord[REGFIELD_ACCOUNT])
   ELSE
     cSeek := Str(aRecord[REGFIELD_PERSONID], 6) + Str(aRecord[REGFIELD_PENSID], 6) + Str(aRecord[REGFIELD_PG], 6) + Str(aRecord[REGFIELD_RELATION], 2) +;
              aRecord[REGFIELD_FAMILY] + aRecord[REGFIELD_NAME] + aRecord[REGFIELD_NAME2]
     IF info->(DbSeek(cSeek))
       aRecord[REGFIELD_BANK] := info->FILIAL
       aRecord[REGFIELD_ACCOUNT] := info->NOLIC
     ELSEIF !Empty(aRec[3]) .AND. dbf->(DbSeek(aRec[3])) .AND. Len(dbf->FILIAL) >= 4 .AND. !Empty(dbf->NOLIC)
       aRecord[REGFIELD_BANK] := dbf->FILIAL
       aRecord[REGFIELD_ACCOUNT] := dbf->NOLIC
     ENDIF
     IIf(Empty(aRecord[REGFIELD_BANK]),, AAdd(aBanks, aRecord[REGFIELD_BANK]))
     IIf(Empty(aRecord[REGFIELD_ACCOUNT]),, AAdd(aAccounts, aRecord[REGFIELD_ACCOUNT]))
   ENDIF

   AAdd(aResult, {})
   AEval(aRecord, {|x| AAdd(aResult[1], x)})

   aRecord[REGFIELD_STATUS] := 0
   aRecord[REGFIELD_CODE] := PEV_PARAMS[1]
   IF !lActiveRecord .AND. !lPensFIO
      aRecord[REGFIELD_BANK] := ""
      aRecord[REGFIELD_ACCOUNT] := ""
   ENDIF

   buf->(DbGoTop())
   DO WHILE !buf->(Eof())
     IF buf->PAY
       AEval({ {REGFIELD_PERSONID, "PERSONID"}, {REGFIELD_PENSID, "PENSID"}, {REGFIELD_PG, "PG"}, {REGFIELD_RELATION, "RELATION"},;
               {REGFIELD_FAMILY, "FAMILY"}, {REGFIELD_NAME, "NAME"}, {REGFIELD_NAME2, "NAME2"},;
               {REGFIELD_BIRTH, "BIRTH"}, {REGFIELD_STATUS, "STATUS"} },;
             {|x, i| aRecord[x[1]] := &("buf->" + x[2]) })

       IF !lActiveRecord .AND. !lPensFIO
         cSeek := Str(aRecord[REGFIELD_PERSONID], 6) + Str(aRecord[REGFIELD_PENSID], 6) + Str(aRecord[REGFIELD_PG], 6) + Str(aRecord[REGFIELD_RELATION], 2) +;
                  aRecord[REGFIELD_FAMILY] + aRecord[REGFIELD_NAME] + aRecord[REGFIELD_NAME2]
         IF info->(DbSeek(cSeek))
           aRecord[REGFIELD_BANK] := aResult[1][REGFIELD_BANK] := info->FILIAL
           aRecord[REGFIELD_ACCOUNT] := aResult[1][REGFIELD_ACCOUNT] := info->NOLIC
         ELSEIF !Empty(aRecord[REGFIELD_PG]) .AND. dbf->(DbSeek(aRecord[REGFIELD_PG])) .AND. Len(dbf->FILIAL) >= 4 .AND. !Empty(dbf->NOLIC)
           aRecord[REGFIELD_BANK] := aResult[1][REGFIELD_BANK] := dbf->FILIAL
           aRecord[REGFIELD_ACCOUNT] := aResult[1][REGFIELD_ACCOUNT] := dbf->NOLIC
         ENDIF
         IIf(Empty(aRecord[REGFIELD_BANK]) .OR. AScan(aBanks, aRecord[REGFIELD_BANK]) > 0,, AAdd(aBanks, aRecord[REGFIELD_BANK]))
         IIf(Empty(aRecord[REGFIELD_ACCOUNT]) .OR. AScan(aAccounts, aRecord[REGFIELD_ACCOUNT]) > 0,, AAdd(aAccounts, aRecord[REGFIELD_ACCOUNT]))
       ENDIF
       nCount++
       AAdd(aResult, {})
       nCur := Len(aResult)
       AEval(aRecord, {|x| AAdd(aResult[nCur], x)})
     ENDIF
     buf->(DbSkip())
   ENDDO
   buf->(DbGoTop())

   IF nCount < 1
     ShowNotification(self, { aPos[1] - 112, aPos[2] }, "   ")
     RETURN {}
   ELSEIF Empty(aBanks) .OR. Empty(aAccounts)
     ShowNotification(self, { aPos[1] - 144, aPos[2] }, "     ")
     RETURN {}
   ELSEIF Len(aBanks) > 1 .OR. Len(aAccounts) > 1
     ShowNotification(self, { aPos[1] - 128, aPos[2] }, "     ")
     RETURN {}
   ENDIF

RETURN aResult

METHOD FareRegForm:TakeRecord()

        LOCAL cDate, nCount := 0, nPos, nS, nN, nPG, nTemp
        LOCAL setXbpData := {|xbp, f, default| xbp:setData(IIf(Empty(f), default, f)) }

RETURN

METHOD FareRegForm:EditCivPens()
   LOCAL oEditor, nPos, nIndex

   IIf(Empty(::possiblePG[2]) .OR. ::possiblePG[2][::possiblePG[1]][1] <> "civ", civ->(DbGoBottom()),;
       civ->(DbGoto(::possiblePG[2][::possiblePG[1]][2])))

   oEditor := CivPens():New(, self):Create(, self)
   oEditor:ScatterControls()//Scatter( oEditor:editControls )

   ::XbpDialog:hide()
   oEditor:showModal()
   nPos := civ->(RecNo())
   IF nPos > 0 .AND. nPos <= civ->(LastRec()) .AND. civ->STATUS >= 0
     ::possiblePG := { 1, { {"civ", nPos, 0, civ->STATUS, civ->ID } } }
//     AEval({ ::family, ::name, ::name2 }, {|x| x:setData("")})
/*
     nIndex := 0
     AEval(::possiblePG[2], {|x,i| IIf(nIndex < 1 .AND. x[5] > 0 .AND. x[5] == civ->ID, nIndex := i,) })
     IF nIndex < 1
       AAdd(::possiblePG[2], {"civ", nPos, 0, civ->STATUS, civ->ID })
       nIndex := Len(::possiblePG[2])
     ENDIF
     ::possiblePG[1] := IIf(nIndex > 1, nIndex - 1, Len(::possiblePG[2]))
*/
     PostAppEvent(xbeP_Activate, NIL, NIL, ::btnPGFromFIO)
   ENDIF
   ::XbpDialog:show()

   SetAppFocus(::paymentYear)

RETURN

METHOD FareRegForm:EditRelatives()
   LOCAL oEditor, aInfo

//   IF Len(::relatives) < 2
//     RETURN
//   ENDIF
   IF Empty(::possiblePG[2])
     RETURN
   ENDIF

   aInfo := ::possiblePG[2][::possiblePG[1]]
//   ::GetRelatives(aInfo[3], aInfo)

   buf->(DbZap())
   AEval(::relatives, {|rel| buf->(DbAppend()), AEval(rel, {|x, i| IIf(Empty(x),, buf->(FieldPut(i, x)))}) }, 2)
   buf->(DbGoTop())

   oEditor := Persons():New(, self):Create(, self)
   Scatter( oEditor:editControls )

   ::XbpDialog:hide()
   oEditor:showModal()
   ::XbpDialog:show()

   ::GetRelatives(aInfo[3], aInfo[5])
   ::UpdateRelatives()

   SetAppFocus(::paymentYear)

RETURN

METHOD FareRegForm:EditAccount()
   LOCAL oEditor

   IF Empty(::possiblePG[2]) .OR.;
      !((::possiblePG[2][::possiblePG[1]][1] == "civ" .AND. ::possiblePG[2][::possiblePG[1]][4] == 5) .OR.;
      (::possiblePG[2][::possiblePG[1]][1] == "rpd" .AND. !(::possiblePG[2][::possiblePG[1]][4] $ { 3, 7})))
//     (::possiblePG[2][::possiblePG[1]][1] == "civ" .AND. ::possiblePG[2][::possiblePG[1]][4] <> 5) .OR.;
//     (::possiblePG[2][::possiblePG[1]][1] <> "civ" .AND.;
//     (::possiblePG[2][::possiblePG[1]][1] <> "rpd" .OR. ::possiblePG[2][::possiblePG[1]][4] $ { 3, 7}))
     RETURN
   ENDIF

   oEditor := BankAndAccount():New(, self):Create(, self)
//   Scatter( oEditor:editControls )

   ::XbpDialog:hide()
   oEditor:showModal()
   ::XbpDialog:show()

   SetAppFocus(::paymentYear)

RETURN

METHOD FareRegForm:SaveConfig()
   LOCAL aPrinter := {}, prnIndex, lFound

   USE (PATH_GLOSSARY + "PRINTERS.DBF") ALIAS prn NEW SHARED

   FOR prnIndex := 1 TO Len(::printers)
     aPrinter := ::printers[prnIndex]
     IF prn->(DbLocate({|| prn->COMPUTER == ::computer .AND. prn->PRN_ID == prnIndex }))
       IF prn->(RLock())
         prn->PRN_NAME := aPrinter[1]:devName
         prn->PRN_ORIENT := aPrinter[2]
         prn->PRN_FORM := aPrinter[3]
         prn->PRN_X := aPrinter[4]
         prn->PRN_Y := aPrinter[5]
         prn->PRN_W := aPrinter[6]
         prn->PRN_H := aPrinter[7]
         prn->(DbUnlock())
       ENDIF
     ELSEIF prn->(FLock())
       prn->(DbAppend())
       prn->COMPUTER := ::computer
       prn->PRN_ID := prnIndex
       prn->PRN_NAME := aPrinter[1]:devName
       prn->PRN_ORIENT := aPrinter[2]
       prn->PRN_FORM := aPrinter[3]
       prn->PRN_X := aPrinter[4]
       prn->PRN_Y := aPrinter[5]
       prn->PRN_W := aPrinter[6]
       prn->PRN_H := aPrinter[7]
       prn->(DbUnlock())
     ENDIF
   NEXT

   CLOSE prn

RETURN

METHOD FareRegForm:CopyLastSumm()
   LOCAL cLine, aMarked := ::summCalc:queryMarked()

   cLine := RTrim(Left(::summCalc:getData(), aMarked[1] - 2))

RETURN LTrim(SubStr(cLine, Max(1, RAt(" ", cLine))))

/* Overloaded AppSys which does nothing
 */
PROCEDURE AppSys

RETURN

******************************************************************************
* Main procedure to test a form
******************************************************************************
PROCEDURE Main(cUser)
   LOCAL nEvent, oXbp, mp1, mp2, oWnd, oConsole, aPos, aSize, oSplash
   PUBLIC SYS_LITERA, SYS_POR, SYS_ENVUSERNAME1, SYS_ENVUSERNAME2
   PUBLIC STR_VK, STR_CENTR, STR_S1, STR_S2, STR_OUTGOINGNUMBER
   PUBLIC PATH_DBF, PATH_DBFBLANK, PATH_GLOSSARY, PATH_TMP
   PUBLIC LIST_STR1, LIST_STR2, LIST_STR3, LIST_STR10, LIST_STR11
   PUBLIC REPORT_INCLUDEFIO, REPORT_INCLUDEFAMILY
   PUBLIC INTERFACE_SHOWINITDETAILS, INTERFACE_ALLOWUPDATEAUTODATA, INTERFACE_SKIPSER, INTERFACE_FOCUSCOLOR,;
          INTERFACE_ALLOWCALCULATIONS, INTERFACE_ALLOWNOTIFICATIONS, INTERFACE_ALLOWELECTRONIC
   PUBLIC CONDITIONS_ALLOWPENS, CONDITIONS_ALLOWRELATIVES

   PUBLIC PEV_PARAMS

   SET COLLATION TO SYSTEM
   SET DATE TO GERMAN
   SET DELETED ON
   SET EXACT ON
   SET SMARTFILTER ON
   SET CHARSET TO OEM

   IF !GetConfig("FareReg.cfg", .T.)
     RETURN
   ENDIF

   FrdbInitStructures()

   PEV_PARAMS := { 29.0, "   ", "   -. .", "", 17, 472, "5142202" }

   REPORT_INCLUDEFIO := !Empty(REPORT_INCLUDEFIO)
   REPORT_INCLUDEFAMILY := !Empty(REPORT_INCLUDEFAMILY)
   INTERFACE_SHOWINITDETAILS := !Empty(INTERFACE_SHOWINITDETAILS)
   INTERFACE_ALLOWUPDATEAUTODATA := !Empty(INTERFACE_ALLOWUPDATEAUTODATA)
   INTERFACE_SKIPSER := !Empty(INTERFACE_SKIPSER)
   INTERFACE_ALLOWCALCULATIONS := !Empty(INTERFACE_ALLOWCALCULATIONS)
   INTERFACE_ALLOWNOTIFICATIONS := !Empty(INTERFACE_ALLOWNOTIFICATIONS)
   INTERFACE_ALLOWELECTRONIC := !Empty(INTERFACE_ALLOWELECTRONIC)
/*
   SET DEVICE TO PRINTER
   SET PRINTER ON
   SET CONSOLE OFF
   SET PRINTER TO ("FareReg.log")
*/
   IF !INTERFACE_SHOWINITDETAILS
     oSplash := ShowCreepingLine(", ,   ... ")
   ENDIF

   oConsole := XbpCrt():New():Create(,,,,, "...", .F.)
   oConsole:sysMenu := .F.
   oConsole:configure()
   oConsole:setFontCompoundName("14.Terminal")
   aPos := AppDesktop():currentSize()
   aSize := oConsole:currentSize()
   oConsole:setPos({ (aPos[1] - aSize[1]) / 2, (aPos[2] - aSize[2]) / 2 }, .T.)
   IIf(!INTERFACE_SHOWINITDETAILS, oConsole:show(),)
   SetAppWindow(oConsole)

   ShowStatusMessage("    FareReg.cfg")
   ShowStatusMessage("[Done]", .T., 70)

   g_nCmdLineUser := IIf(Empty(cUser), 0, Val(Right(cUser, 2)))

   INTERFACE_FOCUSCOLOR := Eval({|rgb| GraMakeRGBColor(IIf(Empty(rgb) .OR. ValType(rgb) <> "A" .OR. Len(rgb) <> 3,;
                                                       { 192, 255, 96 }, rgb)) }, INTERFACE_FOCUSCOLOR)

   oWnd := FareRegForm():New():Create()

   oConsole:hide()
   HideCreepingLine()
   SetAppWindow(oWnd)

   nEvent := xbe_None
   WHILE nEvent != xbeP_Close
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         oWnd:SaveConfig()
         QUIT   // AppQuit()
      ENDIF
   ENDDO
   oWnd:SaveConfig()

RETURN

* Include program code for the implementation-level class of the form
//#include "_FAREREG.PRG"

//EOF
/////