//////////////////////////////////////////////////////////////////////
//
//  Copyright:
//        Your Copyright goes here., (c) 2000. All rights reserved.
//
//  Contents:
//        This is a standard console mode exe.
//
//////////////////////////////////////////////////////////////////////

#include "Common.ch"

/* This is our main procedure
 */
PROCEDURE Main(nYearFrom)
   LOCAL cSeek1, cSeek2, nCount, lFound, aValues, aRelatives, aRel, nIndex, aRFIO, dbPos
   LOCAL nPG, nYear, nSumm, dDate, nPensID, nPersID, lNewBase := .F., lDeleted, aPayments, nPayment
   LOCAL nID, nProgress, nTotal, rel, rfioCase, nLineCounter := 1

   /* we use the ansi charset by default */
   SET CHARSET TO OEM
   SET COLLATION TO SYSTEM
   SET DATE TO GERMAN
   SET DELETED OFF
   SET EXACT ON

   FrdbInitStructures()

   nYearFrom := IIf(Empty(nYearFrom), Year(Date()) - 4, Val(nYearFrom))

   USE "DBF\BASE.REC" ALIAS rec NEW SHARED
   IF !FExists("DBF\BASE1.REC")
     COPY TO "DBF\BASE1.REC" FOR TIPBL = 1 .AND. KOD = 29.0 .AND. PRIM = 0 .AND.;
                                 (Year(DATESROK) > nYearFrom .OR. Year(DATELIST) > nYearFrom)
     lNewBase := .T.
   ENDIF
   CLOSE

   USE "DBF\BASE1.REC" ALIAS rec NEW SHARED
   IF lNewBase .OR. !Fexists("DBF\BASE1.NTX")
     INDEX ON (Str(PG, 6) + Str(Year(DATESROK), 4)) TO "DBF\BASE1.NTX"
   ENDIF
   SET INDEX TO "DBF\BASE1.NTX"

   USE "DBF\BASE.DBF" ALIAS dbf NEW SHARED
   SET INDEX TO "DBF\BASE.XG"

   USE "DBF\BASE.RPD" ALIAS rpd NEW SHARED
   SET INDEX TO "DBF\BASE.XRP"

   USE "DBF\BASE.RPD" ALIAS rpd1 NEW SHARED
   IF !Fexists("DBF\RPDRFIO.NTX")
     INDEX ON (Str(RODST, 2) + GCONAME + GNAME + GFNAME) TO "DBF\RPDRFIO.NTX"
   ENDIF
   SET INDEX TO "DBF\RPDRFIO.NTX"

   USE "DBF\BASE.BPD" ALIAS bpd NEW SHARED
   IF !Fexists("DBF\BPDFIO.NTX")
     INDEX ON (FAMILY + NAME + NAME2) TO "DBF\BPDFIO.NTX"
   ENDIF
   SET INDEX TO "DBF\BPDFIO.NTX"

   USE "DBF\BASE.DEP" ALIAS dep NEW SHARED
   SET INDEX TO "DBF\BASE.XD1"

   lNewBase := .F.
   USE "DBFBLANK\BASE.ABU" ALIAS abu NEW SHARED
   IF !FExists("DBFBLANK\BASE1.ABU")
     COPY TO "DBFBLANK\BASE1.ABU" FOR (SER = "" .OR. SER = "") .AND. SOST = 2
     lNewBase := .T.
   ENDIF
   CLOSE
   USE "DBFBLANK\BASE1.ABU" ALIAS abu NEW SHARED
   IF lNewBase .OR. !Fexists("DBFBLANK\BASEABU.NTX")
     INDEX ON SER + Str(NN, 7) TO "DBFBLANK\BASEABU.NTX"
   ENDIF
   SET INDEX TO "DBFBLANK\BASEABU.NTX"

   lNewBase := .F.
   USE "DBFBLANK\BASE.BUS" ALIAS bus NEW SHARED
   IF !FExists("DBFBLANK\BASE1.BUS")
     COPY TO "DBFBLANK\BASE1.BUS" FOR (SER = "" .OR. SER = "") .AND. SOST = 2
     lNewBase := .T.
   ENDIF
   CLOSE
   USE "DBFBLANK\BASE1.BUS" ALIAS bus NEW SHARED
   IF lNewBase .OR. !Fexists("DBFBLANK\BASEBUS.NTX")
     INDEX ON SER + Str(NN, 7) TO "DBFBLANK\BASEBUS.NTX"
   ENDIF
   SET INDEX TO "DBFBLANK\BASEBUS.NTX"

   DbCreate(("DBF\FROMREC.DBF"), { { "PG", "N", 6, 0 }, { "PENSID", "N", 6, 0 }, { "YEAR", "N", 4, 0 } })
   USE "DBF\FROMREC.DBF" ALIAS arc NEW SHARED

   DbCreate(("DBF\NOTFOUND.DBF"), { { "PG", "N", 6, 0 }, { "SER", "C", 6, 0 }, { "PL", "C", 7, 0 }, { "DELETED", "L", 1, 0 }  })
   USE "DBF\NOTFOUND.DBF" ALIAS notfound NEW SHARED

   DbCreate(("DBF\FAREREG.DBF"), g_aRegDbStruct)
   USE "DBF\FAREREG.DBF" ALIAS reg NEW SHARED
   INDEX ON Str(PG, 6) + Str(YEAR, 4) TO "DBF\FREGPE.NTX"
   SET INDEX TO "DBF\FREGPE.NTX"

   DbCreate(("DBF\CIVPENS.DBF"), g_aCivDbStruct)
   USE "DBF\CIVPENS.DBF" ALIAS civ NEW SHARED

   DbCreate(("DBF\PERSONS.DBF"), g_aPersDbStruct)
   USE "DBF\PERSONS.DBF" ALIAS pers NEW SHARED

   nID := 1
   nTotal := rec->(LastRec())
   nProgress := 0
   nPensID := 1
   nPersID := 1

   SET DEVICE TO PRINTER
   SET PRINTER ON
   SET CONSOLE OFF

   SET PRINTER TO ("report.lst")

   DO WHILE !rec->(Eof())
     ShowStatusMessage("Collecting data: " + Str(++nProgress, 5) + "/" + AllTrim(Str(nTotal)), nProgress >= nTotal)
     nPG := rec->PG

     IF Empty(nPG)
       nYear := IIf(Empty(rec->DATESROK), Year(rec->DATELIST), Year(rec->DATESROK))
       lFound := .T.
       cSeek1 := rec->SER + rec->PL
       aValues := { "", 0, "", "", "", rec->KOD, rec->DATEVYSYL, rec->PENSIONSUM, IIf(rec->(Deleted()), 1001, 1000), 0 }
       IF abu->(DbSeek(cSeek1))
         AEval({ abu->SER, abu->NN, abu->FAMILY, abu->NAME, abu->NAME2 }, {|x, i| aValues[i] := x })
       ELSEIF bus->(DbSeek(cSeek1))
         AEval({ bus->SER, bus->NN, bus->FAMILY, abu->NAME, bus->NAME2 }, {|x, i| aValues[i] := x })
/*
       cSeek1 := PadR("", 6) + rec->PL
       cSeek2 := PadR("", 6) + rec->PL
       aValues := { "", 0, "", "", "", rec->KOD, rec->DATEVYSYL, rec->PENSIONSUM, IIf(rec->(Deleted()), 1001, 1000), 0 }
       IF abu->(DbSeek(cSeek1)) .OR. abu->(DbSeek(cSeek2))
         AEval({ abu->SER, abu->NN, abu->FAMILY, abu->NAME, abu->NAME2 }, {|x, i| aValues[i] := x })
       ELSEIF bus->(DbSeek(cSeek1)) .OR. bus->(DbSeek(cSeek2))
         AEval({ bus->SER, bus->NN, bus->FAMILY, abu->NAME, bus->NAME2 }, {|x, i| aValues[i] := x })
*/
       ELSE
         notfound->(DbAppend())
         notfound->PG := 0
         notfound->SER := rec->SER
         notfound->PL := rec->PL
         notfound->DELETED := rec->(Deleted())
         lFound := .F.
         ? Str(nLineCounter++, 6) + Str(0, 7) + Space(4) + rec->SER + "" + rec->PL + " " +;
           PadC("!  !", 50) + "   base.abu  base.bus"
       ENDIF
       IF lFound
         aRFIO := { {}, {} }
         FOR rel:=0 TO 17
           cSeek1 := Str(rel, 2) + aValues[3] + aValues[4] + aValues[5]
           IF rpd1->(DbSeek(cSeek1))
             DO WHILE Str(rpd1->RODST, 2) + rpd1->GCONAME + rpd1->GNAME + rpd1->GFNAME = cSeek1
               IF Empty(rpd1->WOZPG) .AND. Empty(rpd1->WSHPG)
                 AAdd(aRFIO[1], rel)
                 AAdd(aRFIO[2], { rpd1->FAMILY, rpd1->NAME, rpd1->NAME2, rpd1->PRICHINA + 6, rpd1->PG, rpd1->BORN, rpd1->TP })
               ENDIF
               rpd1->(DbSkip())
             ENDDO
           ENDIF
         NEXT
         IF Empty(aRFIO[1])
           civ->(DbAppend())
           civ->ID := civ->(LastRec())
           civ->FAMILY := ""
           civ->NAME := ""
           civ->NAME2 := ""
           civ->STATUS := 2
           civ->RN := rec->RN
//           civ->ISDEAD := .T.
           civ->DATE := Date()
           civ->USER := aValues[9]
           nPensID := civ->ID
           aRFIO := { { 0 }, { { "", "", "", 2, 0, NIL, 0 } }}
           IF bpd->(DbSeek(aValues[3] + aValues[4] + aValues[5]))
             civ->FAMILY := aValues[3]
             civ->NAME := aValues[4]
             civ->NAME2 := aValues[5]
             civ->ZVAN := bpd->ZV
             civ->USER := 1007
             aRFIO[1][1] := 99
             AEval({ civ->FAMILY, civ->NAME, civ->NAME2 }, {|x, i| aRFIO[2][1][i] := x })
           ENDIF
         ELSE
           nPensID := 0
           IIf(Len(aRFIO[1]) > 1, aValues[9] := IIf(1000 == aValues[9], 1002, 1003),)
         ENDIF
         FOR rfioCase:=1 TO Len(aRFIO[1])
           nPG := aRFIO[2][rfioCase][5]
           aRelatives := GetRelatives(nPG)
           FOR rel:=0 TO 17
             IF 13 == rel .AND. 3 == aRFIO[2][rfioCase][7]
               LOOP
             ENDIF
             aRel := GetRelative(aRelatives, rel, {})
             reg->(DbAppend())
             reg->S := aValues[1]
             reg->N := aValues[2]
             reg->PERSONID := 0
             reg->PENSID := nPensID
             reg->PG := nPG
             reg->RELATION := rel
             reg->FAMILY := ""
             reg->NAME := ""
             reg->NAME2 := ""
             reg->STATUS := 0
             reg->YEAR := nYear
             reg->MODE := 0
             reg->CODE := aValues[6]
             reg->SUMM := aValues[8]
             reg->DISTRICT := rec->RN
             reg->BANK := ""
             reg->ACCOUNT := ""
             reg->NOTE := 0
             reg->DATE := aValues[7]
             reg->USER := aValues[9]
             IF !Empty(aRel)
               reg->FAMILY := aRel[2]
               reg->NAME := aRel[3]
               reg->NAME2 := aRel[4]
               IIf(Empty(aRel[5]),, reg->BIRTH := aRel[5])
             ENDIF
             IF 13 == rel
               reg->FAMILY := aRFIO[2][rfioCase][1]
               reg->NAME := aRFIO[2][rfioCase][2]
               reg->NAME2 := aRFIO[2][rfioCase][3]
               IIf(Empty(aRFIO[2][rfioCase][6]),, reg->BIRTH := aRFIO[2][rfioCase][6])
               reg->STATUS := aRFIO[2][rfioCase][4]
             ELSEIF aRFIO[1][rfioCase] == rel
               reg->FAMILY := aValues[3]
               reg->NAME := aValues[4]
               reg->NAME2 := aValues[5]
               IF Empty(aRel)
                 pers->(DbAppend())
                 pers->ID := pers->(LastRec())
                 pers->PG := nPG
                 pers->PENSID := nPensID
                 pers->RELATION := rel
                 pers->FAMILY := aValues[3]
                 pers->NAME := aValues[4]
                 pers->NAME2 := aValues[5]
                 pers->STATUS := IIf(rel $ {0, 9}, 1, 0)
                 pers->DATE := Date()
                 pers->USER := aValues[9]
                 reg->PERSONID := pers->ID
               ENDIF
             ENDIF
             ? Str(nLineCounter++, 6) + Str(IIf(Empty(nPG), 0, nPG), 7) + " " + Str(reg->RELATION, 2) + " " +;
               reg->S + "" + Str(reg->N, 7) + " " + reg->FAMILY + reg->NAME + reg->NAME2 +;
               "   base.abu  base.bus " + IIf( reg->USER $ { 1001, 1003 }, " ", "")
           NEXT
           arc->(DbAppend())
           arc->PG := nPG
           arc->PENSID := nPensID
           arc->YEAR := nYear
         NEXT
       ENDIF
       rec->(DbSkip())
     ELSE
       DO WHILE rec->PG == nPG
         nYear := IIf(Empty(rec->DATESROK), Year(rec->DATELIST), Year(rec->DATESROK))
         aPayments := { 0, {} }
         DO WHILE rec->PG == nPG .AND. (Year(rec->DATESROK) == nYear .OR. Year(rec->DATELIST) == nYear)
           AAdd(aPayments[2], { rec->SER, Val(rec->PL), rec->KOD, rec->PENSIONSUM, rec->DATEVYSYL, IIf(rec->(Deleted()), 1005, 1004), "", "", 0 })
           rec->(DbSkip())
         ENDDO
         IF !rpd->(DbSeek(nPG))
           FOR nPayment := 1 TO Len(aPayments[2])
             notfound->(DbAppend())
             notfound->PG := nPG
             notfound->SER := aPayments[2][nPayment][1]
             notfound->PL := aPayments[2][nPayment][2]
             notfound->DELETED := aPayments[2][nPayment][6] == 1005
             ? Str(nLineCounter++, 6) + Str(IIf(Empty(nPG), 0, nPG), 7) + Space(4) +;
               aPayments[2][nPayment][1] + "" + aPayments[2][nPayment][2] + " " +;
               PadC("!  !", 50) + "   base.rpd"
           NEXT
         ELSE
           IF dbf->(DbSeek(nPG))
             AEval(aPayments[2], {|x,i| x[7] := dbf->FILIAL, x[8] := dbf->NOLIC, x[9] := 1 })
           ENDIF
           aRelatives := GetRelatives(nPG)
           FOR rel:=0 TO 17
             IF 13 == rel .AND. 3 == rpd->TP
               LOOP
             ENDIF
             aRel := GetRelative(aRelatives, rel, {})
             aPayments[1] := Min(aPayments[1] + 1, Len(aPayments[2]))
             aValues := aPayments[2][aPayments[1]]
             reg->(DbAppend())
             reg->S := IIf(Empty(aValues[1]), "/", aValues[1])
             reg->N := aValues[2]
             reg->PERSONID := 0
             reg->PENSID := 0
             reg->PG := nPG
             reg->RELATION := rel
             reg->FAMILY := ""
             reg->NAME := ""
             reg->NAME2 := ""
             reg->STATUS := 0
             reg->YEAR := nYear
             reg->MODE := aValues[9]
             reg->CODE := aValues[3]
             reg->SUMM := aValues[4]
             reg->DISTRICT := rpd->RN
             reg->BANK := aValues[7]
             reg->ACCOUNT := aValues[8]
             reg->NOTE := 0
             reg->DATE := aValues[5]
             reg->USER := aValues[6]
             IF !Empty(aRel)
               reg->FAMILY := aRel[2]
               reg->NAME := aRel[3]
               reg->NAME2 := aRel[4]
               IIf(Empty(aRel[5]),, reg->BIRTH := aRel[5])
             ENDIF
             IF 13 == rel
               reg->FAMILY := rpd->FAMILY
               reg->NAME := rpd->NAME
               reg->NAME2 := rpd->NAME2
               reg->BIRTH := rpd->BORN
               reg->STATUS := IIf(0 = rpd->PRICHINA, 1, rpd->PRICHINA + 6)
             ENDIF
             ? Str(nLineCounter++, 6) + Str(IIf(Empty(nPG), 0, nPG), 7) + " " + Str(reg->RELATION, 2) + " " +;
               reg->S + "" + Str(reg->N, 7) + " " + reg->FAMILY + reg->NAME + reg->NAME2 +;
               "   base.rpd  base.dbf " + IIf( reg->USER == 1005, " ", "")
           NEXT

           arc->(DbAppend())
           arc->PG := nPG
           arc->PENSID := 0
           arc->YEAR := nYear
         ENDIF
       ENDDO
     ENDIF
   ENDDO

   SET CONSOLE ON
   SET PRINTER OFF
   SET DEVICE TO SCREEN
/*
   SELECT civ

   INDEX ON (ID) TAG cpensid TO "DBF\CPENSID.NTX"
   INDEX ON (FAMILY + NAME + NAME2) TAG cpensfio TO "DBF\CPENSFIO.NTX"

   SELECT pers

   INDEX ON (PG) TAG perspg TO "DBF\PERSPG.NTX"
   INDEX ON (PENSID) TAG perspi TO "DBF\PERSPI.NTX"
   INDEX ON (ID) TAG persid TO "DBF\PERSID.NTX"
   INDEX ON (FAMILY + NAME + NAME2) TAG persfio TO "DBF\PERSFIO.NTX"

   SELECT reg

   INDEX ON (Str(PG, 6) + Str(PENSID, 6) + Str(YEAR, 4)) TAG fregfam TO "DBF\FREGFAM.NTX"
*/
   SELECT arc
   INDEX ON (Str(PG, 6) + Str(PENSID, 6)) TO "DBF\FROMREC.NTX"
//   INDEX ON /* + Str(YEAR, 4)*/ TO "DBF\FROMRECI.NTX"
//   INDEX ON Str(PG, 6)/* + Str(YEAR, 4)*/ TO "DBF\FROMREC.NTX"

RETURN