///////////////////////////////////////////////////////////////////////////////
//
//  Class code created by the Xbase++ FormDesigner
//    Creation date: 11.02.2008 Creation time: 16:02:25
//
//  Contents  :
//    This file contains the basic structure for the utilization-level of
//    a form. It may (and should) be modified.
//
///////////////////////////////////////////////////////////////////////////////

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "frdbrtn.ch"


******************************************************************************
* This class is derived from the implementation-level class of the form.
* Instance variables are declared in the _NewForm class.
******************************************************************************
CLASS Persons FROM _Persons
   EXPORTED:
    //
    VAR mainWnd
    //
//    VAR relations
    //
    VAR pers
    //
        VAR banks
    //
    VAR pensInfo
    //
    VAR xbpLists
    //
    VAR disabledControls

   EXPORTED:
      METHOD init
      METHOD create
      METHOD OnAddBtnClicked
      METHOD OnChangeBtnClicked
      METHOD OnRemoveBtnClicked
      METHOD GetInvalidXbp
      METHOD SetEditableControls
ENDCLASS

******************************************************************************
* Initialize form
******************************************************************************
METHOD Persons:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   LOCAL onKeyPressed, onKeyPressedEx, evalIfDataChanged, replaceNullValue

   ::mainWnd := oOwner
   ::relations := oOwner:relations
   ::banks := oOwner:banks
   ::categories := oOwner:categories
   ::pensInfo := oOwner:relatives[1]
   ::disabledControls := {}

   * Execute method of the super class
   ::_Persons:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::day:setNumLimits(0, 31)
   ::month:setNumLimits(0, 12)
   ::year:setNumLimits(0, Year(Date()))
   ::bank:setNumLimits(0, 9999)
   ::desk:setNumLimits(0, 9999)

   ::family:setInputFocus := ::name:setInputFocus := ::name2:setInputFocus :=;
   ::day:setInputFocus := ::month:setInputFocus := ::year:setInputFocus :=;
   ::index:setInputFocus := ::street:setInputFocus := ::house:setInputFocus := ::building:setInputFocus := ::flat:setInputFocus :=;
   ::bank:setInputFocus := ::desk:setInputFocus := ::account:setInputFocus :=;
                           {|mp1, mp2, obj| obj:XbpSLE:setMarked({1, obj:bufferLength + 1}), obj:setColorBG(INTERFACE_FOCUSCOLOR) }

   ::family:killInputFocus := ::name:killInputFocus := ::name2:killInputFocus :=;
                              {|mp1, mp2, obj| obj:setData(FormatFIO(obj:getData())),;
                                               obj:setColorBG(XBPSYSCLR_WINDOW) }

   ::day:killInputFocus := ::month:killInputFocus := {|mp1, mp2, obj| IIf(obj:getData() < 1, obj:setData(1),), obj:setColorBG(XBPSYSCLR_WINDOW) }
   ::year:killInputFocus := {|mp1, mp2, obj| IIf(obj:getData() < 1900, obj:setData(1900),), obj:setColorBG(XBPSYSCLR_WINDOW) }

   ::index:killInputFocus := {|mp1, mp2, obj| obj:setColorBG(XBPSYSCLR_WINDOW),;
                                              Eval({|x| IIf(Empty(x) .OR. Val(x) < 100000 .OR. Val(x) > 199999, obj:setData(""),) }, obj:getData()) }

   ::street:killInputFocus := ::house:killInputFocus := ::building:killInputFocus := ::flat:killInputFocus :=;
                              {|mp1, mp2, obj| obj:setColorBG(XBPSYSCLR_WINDOW),;
                                               obj:setData(Upper(obj:getData())) }

   ::bank:killInputFocus := ::desk:killInputFocus := ::account:killInputFocus := {|mp1, mp2, obj| obj:setColorBG(XBPSYSCLR_WINDOW) }

   onKeyPressed := {|key, xbp| IIf(xbeK_ENTER == key, PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, xbp),) }
   onKeyPressedEx := {|key, xbp, tab, vld, sel| sel := xbp:queryMarked(),;
                                                IIf(key $ { xbeK_TAB, xbeK_SH_TAB },,;
                                                IIf(xbeK_ENTER == key .OR. sel[1] > xbp:bufferLength .OR. !Empty(tab),;
                                                    PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, xbp),;
                                                IIf(Empty(vld),, Eval(vld, xbp, key)))) }

   ::family:keyBoard := ::name:keyBoard := ::name2:keyBoard :=;
                        {|key, mp2, obj| Eval(onKeyPressedEx, key, obj, xbeK_SPACE == key,;
                                              {|sle| ValidateString(sle, {|c| IsAlpha(c) .OR. "-" == c }) }) }

   ::relation:keyBoard :=;
   ::status:keyBoard := {|key, mp2, obj| Eval(onKeyPressed, key, obj) }

   ::street:keyBoard := {|key, mp2, obj| Eval(onKeyPressedEx, key, obj,,;
                                              {|sle| ValidateString(sle, {|c| IsDigit(c) .OR. IsAlpha(c) .OR. c $ '-."/' }) }) }

   ::house:keyBoard := {|key, mp2, obj| Eval(onKeyPressedEx, key, obj, xbeK_SPACE == key,;
                                             {|sle| ValidateString(sle, {|c| IsDigit(c) .OR. IsAlpha(c) .OR. c $ '-"/' }) }) }

   ::building:keyBoard := ::flat:keyBoard :=;
                          {|key, mp2, obj| Eval(onKeyPressedEx, key, obj, xbeK_SPACE == key,;
                                                {|sle| ValidateString(sle, {|c| IsDigit(c) .OR. IsAlpha(c) }) }) }

   ::day:keyBoard := ::month:keyBoard := ::year:keyBoard :=;
   ::bank:keyBoard := ::desk:keyBoard := {|key, mp2, obj| Eval(onKeyPressedEx, key, obj) }

   ::index:keyBoard :=;
   ::account:keyBoard := {|key, mp2, obj| Eval(onKeyPressedEx, key, obj,, {|sle| ValidateString(sle, {|c| IsDigit(c) }) }) }

//   ::relation:itemSelected := /*::bank:itemSelected :=*/ {|mp1, mp2, obj| ValidateSelection(obj, .T.) }

   ::btnNext:keyBoard := ::btnExit:keyBoard := ::btnAdd:keyBoard :=;
   ::btnPrev:keyBoard := ::btnChange:keyBoard :=;
                {|key, mp2, obj| IIf(xbeK_ENTER == key .OR. xbeK_SPACE == key, PostAppEvent(xbeP_Activate,,, obj),) }

   ::btnNext:activate := {|| buf->(DbSkip(1)), IIf(buf->(Eof()),buf->(DbSkip(-1)),),;
                             Scatter ( ::editControls ), ::SetEditableControls() }
   ::btnPrev:activate := {|| buf->(DbSkip(-1)), /*IIf(buf->(Bof()),buf->(DbSkip(1)),), */;
                             Scatter ( ::editControls ), ::SetEditableControls() }

   ::btnAdd:activate := {|mp1, mp2, obj| ::OnAddBtnClicked() }
   ::btnChange:activate := {|mp1, mp2, obj| ::OnChangeBtnClicked() }
   ::btnRemove:activate := {|mp1, mp2, obj| ::OnRemoveBtnClicked() }
   ::btnExit:activate := {|mp1, mp2, obj| /*::OnChangeBtnClicked(), */PostAppEvent(xbeP_Close,,, self) }

RETURN self


******************************************************************************
* Request system resources
******************************************************************************
METHOD Persons:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
        LOCAL fillComboBox

   * Execute method of the super class
   ::_Persons:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   aPos := AppDesktop():currentSize()
   aSize := ::currentSize()
   ::setPos({ (aPos[1] - aSize[1]) / 2, (aPos[2] - aSize[2]) / 2 },.T.)

   FillComboBoxFromArray(::relations, ::relation)
   FillComboBoxFromArray(::categories, ::status)

   IF ::mainWnd:accessLevel < 1
     ::disabledControls := { ::btnAdd, ::btnChange, ::btnRemove }
   ENDIF

   ::SetEditableControls()
   * Display the form
   ::show()

   PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, self)

RETURN self

METHOD Persons:GetInvalidXbp()
   LOCAL aResult := {}, aPos, aSize

   AEval({::family, ::name, ::name2, ::day, ::month, ::year, ::bank },;
         {|x| IIf(x:isEnabled() .AND. Empty(x:getData()), AAdd(aResult, { x, x:currentPos() }),) })

   Eval({|x| aPos := x:currentPos(), aSize := x:listboxSize(), aPos[2] += aSize[2],;
             IIf(x:isEnabled() .AND. Empty(x:XbpSLE:getData()), AAdd(aResult, { x, aPos }),) }, ::relation)

   Eval({|x| IIf(x:isEnabled() .AND. Len(AllTrim(x:getData())) <> 20, AAdd(aResult, { x, x:currentPos()}),) }, ::account)

RETURN aResult

METHOD Persons:SetEditableControls()
   LOCAL aButtons := { ::btnChange, ::btnRemove }
   LOCAL aConditions := {}

   IF 0 == buf->(LastRec())
     AEval(::editControls, {|xbp| xbp:hide() })
     AEval({ ::btnChange, ::btnRemove, ::btnPrev, ::btnNext }, {|x| x:disable() })
     AEval(::disabledControls, {|x| x:disable() })
     PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, self)
     RETURN
   ENDIF

   AEval({ ::btnChange, ::btnRemove, ::btnPrev, ::btnNext }, {|x| x:enable() })

   AAdd(aConditions, !Empty(buf->PERSONID) .AND. pers->(DbSeek(buf->PERSONID,, "persid")))
   AAdd(aConditions, !Empty(buf->PG) .AND. dbf->(DbSeek(buf->PG)))

   AEval(::editControls, {|xbp,i| xbp:show(),;
                                  IIf(aConditions[1], IIf(i > 8 .AND. aConditions[2], xbp:disable(), xbp:enable()),;
                                  IIf(aConditions[2], xbp:disable(),;
                                  IIf(i > 8, xbp:enable(), xbp:disable()))) })

   IF !Empty(buf->PERSONID) .OR. Empty(buf->PG)
     AEval(aButtons, {|btn| btn:enable() })
   ELSEIF dbf->(DbSeek(buf->PG))
     AEval(aButtons, {|btn| btn:disable() })
   ELSE
     ::btnChange:enable()
     ::btnRemove:disable()
   ENDIF

   IF !INTERFACE_ALLOWUPDATEAUTODATA .AND. aConditions[1] .AND. pers->USER >= 1000
     AEval(::editControls, {|xbp| xbp:disable() })
     AEval(aButtons, {|xbp| xbp:disable() })
   ENDIF

   AEval(::disabledControls, {|x| x:disable() })

RETURN

METHOD Persons:OnAddBtnClicked()
   LOCAL nID, nPos

   nPos := buf->(RecNo())
   buf->(DbGoTop())

   DO WHILE !buf->(Eof())
     IF buf->STATUS < 0
       ConfirmBox(self, ",    ," + Chr(10) +;
                  "     ",;
                  "", XBPMB_OK, XBPMB_WARNING)
       buf->(DbGoTo(nPos))
       RETURN
     ENDIF
     buf->(DbSkip())
   ENDDO

   buf->(DbGoTo(nPos))

   IF ConfirmBox(self, "  ?" + Chr(10) +;
                 "       .",;
                 "", XBPMB_YESNO, XBPMB_QUESTION) <> XBPMB_RET_YES
     RETURN
   ENDIF

   pers->(OrdSetFocus("persid"))
   pers->(DbGoBottom())
   nID := pers->ID + 1

   IF !pers->(FLock())
     RETURN
   ENDIF

   pers->(DbAppend())
   pers->ID := nID
   pers->PG := ::pensInfo[1]
   pers->PENSID := ::pensInfo[2]
   pers->STATUS := -1
   pers->DATE := Date()
   pers->USER := ::mainWnd:user[1]

//   nPos := pers->(RecNo())

   pers->(DbUnlock())

   buf->(DbAppend())
   AEval({1, 2, 3, 9}, {|x| buf->(FieldPut(x, pers->(FieldGet(x)))) })

   Scatter ( ::editControls )
   ::SetEditableControls()

   PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, self)
   PostAppEvent(xbeP_Keyboard, xbeK_TAB, NIL, self)

RETURN

METHOD Persons:OnChangeBtnClicked()
   LOCAL cSeek, nPos, aRec := {}, lLocked := .F., aInvalid := ::GetInvalidXbp(), lContinue

   IF !Empty(aInvalid)
     ShowNotification(self, aInvalid[1][2], "  ")
     RETURN
   ENDIF

   IF ConfirmBox(self, "     ?",;
                 "", XBPMB_YESNO, XBPMB_QUESTION) <> XBPMB_RET_YES
     RETURN
   ENDIF

   AEval({ buf->PERSONID, ::pensInfo[2], ::pensInfo[1],,,,,,, Date(), ::mainWnd:user[1] }, {|x| AAdd(aRec, x) })
   cSeek := Str(buf->PERSONID, 6) + Str(buf->PENSID, 6) + Str(buf->PG, 6) +;
            Str(buf->RELATION, 2) + buf->FAMILY + buf->NAME + buf->NAME2

   IF !Empty(buf->PERSONID)
     IF !pers->(DbSeek(buf->PERSONID,, "persid"))
       RETURN
     ENDIF

     AEval(::relation:getData(), {|sel| aRec[4] := sel - 1 })
     AEval({ { ::family, 5 }, { ::name, 6 }, { ::name2, 7 } }, {|x| aRec[x[2]] := PadR(x[1]:getData(), x[1]:bufferLength) })
     aRec[8] := CtoD(StrTran(Str(::day:getData(), 2) + "." + Str(::month:getData(), 2) + "." + Str(::year:getData(), 4), " ", "0"))
     AEval(::status:getData(), {|sel| aRec[9] := sel - 1 })

     nPos := buf->(RecNo())
     buf->(DbGoTop())
     cFIO := aRec[5] + aRec[6] + aRec[7]

     DO WHILE !buf->(Eof())
       IF nPos <> buf->(RecNo()) .AND. aRec[4] == buf->RELATION .AND. cFIO == buf->FAMILY + buf->NAME + buf->NAME2
         IF ConfirmBox(self, "      ." + Chr(10) +;
                       " ,       ?",;
                       "", XBPMB_YESNO, XBPMB_QUESTION, XBPMB_DEFBUTTON2) <> XBPMB_RET_YES
           RETURN
         ENDIF
         EXIT
       ENDIF
       buf->(DbSkip())
     ENDDO

     buf->(DbGoTo(nPos))

     IF !pers->(RLock())
       RETURN
     ENDIF

     AEval(aRec, {|x,i| pers->(FieldPut(i, x)), IIf(i > 9,, buf->(FieldPut(i, x))) }, 4)
     pers->(DbUnlock())
   ELSEIF !Empty(buf->PG) .AND. !dbf->(DbSeek(buf->PG))
     AEval({ 4, 5, 6, 7 }, {|x| aRec[x] := buf->(FieldGet(x)) })
   ELSE
     RETURN
   ENDIF

   IF info->(DbSeek(cSeek))
     lLocked := info->(RLock())
   ELSEIF info->(FLock())
     lLocked := .T.
     info->(DbAppend())
   ENDIF

   IF lLocked
     AEval({1, 2, 3, 4, 5, 6, 7}, {|x| info->(FieldPut(x, aRec[x])) })
     IF INTERFACE_ALLOWNOTIFICATIONS
       info->IND := Val(::index:getData())
       info->ADDRESS := PadR(::street:GetData(), ::street:bufferLength)
       info->HOUSE := PadR(::house:GetData(), ::house:bufferLength)
       info->CORPUS := PadR(::building:GetData(), ::building:bufferLength)
       info->FLAT := PadR(::flat:GetData(), ::flat:bufferLength)
     ENDIF
     info->FILIAL := PadR(StrTran(Str(::bank:GetData(), 4) + "/" + Str(::desk:GetData(), 4), " ", "0"), 10)
     info->NOLIC := PadR(::account:GetData(), ::account:bufferLength)
     info->DATE := Date()
     info->USER := ::mainWnd:user[1]
     info->(DbUnlock())
   ENDIF

   Scatter ( ::editControls )
   ::SetEditableControls()

RETURN

METHOD Persons:OnRemoveBtnClicked()

   IF Empty(buf->PERSONID) .OR. ConfirmBox(self, " ,    ?",;
                                           "", XBPMB_YESNO, XBPMB_QUESTION) <> XBPMB_RET_YES
     RETURN
   ENDIF

   IF info->(DbSeek(Str(buf->PERSONID, 6) + Str(buf->PENSID, 6) + Str(buf->PG, 6) +;
                    Str(buf->RELATION, 2) + buf->FAMILY + buf->NAME + buf->NAME2)) .AND.;
      info->(FLock())
     info->(DbDelete())
     info->(DbUnlock())
   ENDIF

   IF pers->(DbSeek(buf->PERSONID,, "persid")) .AND. pers->(FLock())
     pers->(DbDelete())
     pers->(DbUnlock())
   ENDIF

   buf->(DbDelete())
   buf->(DbPack())
   PostAppEvent(xbeP_Activate,,, ::btnNext)

RETURN


* Include program code for the implementation-level class of the form
//#include "_CIVPENS.PRG"

//EOF
/////