///////////////////////////////////////////////////////////////////////////////
//
//  Class code created by the Xbase++ FormDesigner
//    Creation date: 11.02.2008 Creation time: 16:02:25
//
//  Contents  :
//    This file contains the basic structure for the utilization-level of
//    a form. It may (and should) be modified.
//
///////////////////////////////////////////////////////////////////////////////

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "frdbrtn.ch"

#define MAXOFFSETVALUE        999

******************************************************************************
* This class is derived from the implementation-level class of the form.
* Instance variables are declared in the _NewForm class.
******************************************************************************
CLASS PrinterConfig FROM _PrinterConfig
   EXPORTED:
     VAR owner
     VAR forms
     VAR orient
     VAR offset

   EXPORTED:
      METHOD init
      METHOD create
      METHOD OnDoneBtnClicked
      METHOD OnPrinterSelected
      METHOD OnTest
ENDCLASS

******************************************************************************
* Initialize form
******************************************************************************
METHOD PrinterConfig:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   LOCAL onKeyPressed, evalIfDataChanged, replaceNullValue, getIncValue
   LOCAL tmp

   ::owner := oOwner
   ::forms := { { 1, {}, {} }, { 1, {}, {} } }
   ::orient := { 1, 1 }
   ::offset := { { 0, 0 }, { 0, 0 } }

   * Execute method of the super class
   ::_PrinterConfig:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::printer1:itemSelected := {|mp1, mp2, obj| ::OnPrinterSelected(::printer1, ::form1, ::forms[1]) }
   ::printer2:itemSelected := {|mp1, mp2, obj| ::OnPrinterSelected(::printer2, ::form2, ::forms[2]) }
   ::form1:itemSelected := {|mp1, mp2, obj| ::forms[1][1] := ::forms[1][2][AScan(::forms[1][3], ::form1:XbpSLE:getData())] }
   ::form2:itemSelected := {|mp1, mp2, obj| ::forms[2][1] := ::forms[2][2][AScan(::forms[1][3], ::form2:XbpSLE:getData())] }
   ::orient1:itemSelected := {|mp1, mp2, obj| ::orient[1] := 1, AEval(obj:getData(), {|sel| ::orient[1] := sel }) }
   ::orient2:itemSelected := {|mp1, mp2, obj| ::orient[2] := 1, AEval(obj:getData(), {|sel| ::orient[2] := sel }) }

   ::offsetx1:killInputFocus := {|mp1, mp2, obj| ::offset[1][1] := Val(obj:getData()) }
   ::offsety1:killInputFocus := {|mp1, mp2, obj| ::offset[1][2] := Val(obj:getData()) }
   ::offsetx2:killInputFocus := {|mp1, mp2, obj| ::offset[2][1] := Val(obj:getData()) }
   ::offsety2:killInputFocus := {|mp1, mp2, obj| ::offset[2][2] := Val(obj:getData()) }

   getIncValue := {|sle, inc| tmp := { Val(sle:getData()) + inc, sle:queryMarked() } ,;
                              IIf(tmp[1] > MAXOFFSETVALUE, tmp[1] := MAXOFFSETVALUE,;
                              IIf(tmp[1] < -MAXOFFSETVALUE, tmp[1] := -MAXOFFSETVALUE,)),;
                              sle:setData(AllTrim(Str(tmp[1]))),;
                              sle:setMarked(tmp[2]) }

   ::offsetx1:keyBoard := ::offsety1:keyBoard := ;
   ::offsetx2:keyBoard := ::offsety2:keyBoard := ;
                          {|key, mp2, obj| mp2 := 0,;
                                           IIf(xbeK_TAB == key,,;
                                           IIf(xbeK_ENTER == key, PostAppEvent(xbeP_Keyboard, xbeK_TAB,, xbp),;
                                           IIf(xbeK_UP == key, mp2 := 1,;
                                           IIf(xbeK_DOWN == key, mp2 := -1,;
                                           IIf(xbeK_PGUP == key, mp2 := 10,;
                                           IIf(xbeK_PGDN == key, mp2 := -10,;
                                           ValidateString(obj, {|c, val| IsDigit(c) .OR. ("-" == c .AND. RAt(c, val[1]) == 1) }))))))),;
                                           Eval(getIncValue, obj, mp2) }
//mp2 := { obj:getData(), obj:queryMarked()},;

   ::test1:activate := {|mp1, mp2, obj| mp1 := Array(Len(g_aRegDbStruct)),;
                                        mp1[REGFIELD_S] := "*", mp1[REGFIELD_N] := 123456, mp1[REGFIELD_SUMM] := 11247.12, mp1[REGFIELD_DATE] := Date(),;
                                        PrintCalc(self,;
                                                  ::printer1:XbpSLE:getData(),;
                                                  ::orient[1], ::forms[1][1],;
                                                  { ::offset[1][1], ::offset[1][2] },;
                                                  mp1,;
                                                  { {"", 1234.67 }, { "", 123.45 }, { "", 6789 }, { "", 1000 }, { "", 2000 }, { "", 100 } },;
                                                  { "____________________ -", "______________", "_________" },;
                                                  { "    " + SYS_LITERA + "-******" + " ****" + " .",;
                                                    "",;
                                                    "     ",;
                                                    "  (/): **/**",;
                                                    " : ______",;
                                                    " : _____" },;
                                                  ::owner:user[3]) }
   ::test2:activate := {|mp1, mp2, obj| mp1 := Array(Len(g_aRegDbStruct)),;
                                        mp1[REGFIELD_S] := "*", mp1[REGFIELD_N] := 123456,;
                                        mp1[REGFIELD_PG] := 654321, mp1[REGFIELD_FAMILY] := "", mp1[REGFIELD_NAME] := "", mp1[REGFIELD_NAME2] := "",;
                                        mp1[REGFIELD_MODE] := 1, mp1[REGFIELD_SUMM] := 11247.12,;
                                        mp1[REGFIELD_DISTRICT] := 0, mp1[REGFIELD_DATE] := Date(),;
                                        PrintBlank(self,;
                                                   ::printer2:XbpSLE:getData(),;
                                                   ::orient[2], ::forms[2][1],;
                                                   { ::offset[2][1], ::offset[2][2] },;
                                                   mp1,;
                                                   ::owner:user[3],;
                                                   "  1234 ()") }

   ::test31:activate := {|mp1, mp2, obj| ::OnTest(.T.) }
   ::test32:activate := {|mp1, mp2, obj| ::OnTest(.F.) }

   ::btnDone:activate := {|mp1, mp2, obj| ::OnDoneBtnClicked() }
   ::btnExit:activate := {|mp1, mp2, obj| PostAppEvent(xbeP_Close,,, self) }

RETURN self

METHOD PrinterConfig:OnTest(lOEM)
   LOCAL mp1

   mp1 := Array(Len(g_aRegDbStruct))
   mp1[REGFIELD_S] := "*"
   mp1[REGFIELD_N] := 123456
   mp1[REGFIELD_PG] := 654321
   mp1[REGFIELD_FAMILY] := ""
   mp1[REGFIELD_NAME] := ""
   mp1[REGFIELD_NAME2] := ""
   mp1[REGFIELD_MODE] := 0
   mp1[REGFIELD_SUMM] := 11247.12
   mp1[REGFIELD_DISTRICT] := 1
   mp1[REGFIELD_BANK] := "1879/4321"
   mp1[REGFIELD_ACCOUNT] := "12345678901234567890"
   mp1[REGFIELD_DATE] := Date()
   PrintNotification(self,;
                     ::printer1:XbpSLE:getData(),;
                     ::orient[1], ::forms[1][1],;
                     { ::offset[1][1], ::offset[1][2] },;
                     mp1,;
                     ::owner:user[3],;
                     GetBank(mp1[REGFIELD_DISTRICT], mp1[REGFIELD_BANK], mp1[REGFIELD_MODE], ::owner:districts, ::owner:banks, ::owner:banks2districts))
/*
   IF lOEM
     SET CHARSET TO OEM
   ELSE
     SET CHARSET TO ansi
   ENDIF

   mp1 := Array(Len(g_aRegDbStruct))
   mp1[REGFIELD_S] := "*"
   mp1[REGFIELD_N] := 123456
   mp1[REGFIELD_PG] := 654321
   mp1[REGFIELD_FAMILY] := ConvToOemCP("")
   mp1[REGFIELD_NAME] := ConvToAnsiCP("")
   mp1[REGFIELD_NAME2] := ""
   mp1[REGFIELD_MODE] := 1
   mp1[REGFIELD_SUMM] := 11247.12
   mp1[REGFIELD_DISTRICT] := 0
   mp1[REGFIELD_DATE] := Date()
   PrintBlank(self,;
              ::printer2:XbpSLE:getData(),;
              ::orient[2], ::forms[2][1],;
              { ::offset[2][1], ::offset[2][2] },;
              mp1,;
              ::owner:user[3],;
              "  1234 ()")

   SET CHARSET TO OEM
*/
RETURN

******************************************************************************
* Request system resources
******************************************************************************
METHOD PrinterConfig:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
    LOCAL oPrinter := XbpPrinter():New(), prnList := oPrinter:list()

   * Execute method of the super class
   ::_PrinterConfig:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

    aPos := AppDesktop():currentSize()
    aSize := ::currentSize()
    ::setPos({ (aPos[1] - aSize[1]) / 2, (aPos[2] - aSize[2]) / 2 },.T.)

        AEval(prnList, {|x| ::printer1:addItem(x), ::printer2:addItem(x) })

    ::printer1:setData({ AScan(prnList, ::owner:printers[1][1]:devName) })
    ::printer2:setData({ AScan(prnList, ::owner:printers[2][1]:devName) })
    ::orient[1] := ::owner:printers[1][2]
    ::orient[2] := ::owner:printers[2][2]
    ::forms[1][1] := ::owner:printers[1][3]
    ::forms[2][1] := ::owner:printers[2][3]
    ::offset[1][1] := ::owner:printers[1][4]
    ::offset[1][2] := ::owner:printers[1][5]
    ::offset[2][1] := ::owner:printers[2][4]
    ::offset[2][2] := ::owner:printers[2][5]
    ::OnPrinterSelected(::printer1, ::form1, ::forms[1])
    ::OnPrinterSelected(::printer2, ::form2, ::forms[2])

    AEval({ ::orient1, ::orient2 }, {|combo,i| FillComboBoxFromArray({ "", "" }, combo),;
                                               combo:setData({ ::orient[i] }) })

    ::offsetx1:setData(AllTrim(Str(::offset[1][1])))
    ::offsety1:setData(AllTrim(Str(::offset[1][2])))
    ::offsetx2:setData(AllTrim(Str(::offset[2][1])))
    ::offsety2:setData(AllTrim(Str(::offset[2][2])))

   IF ::owner:accessLevel < 3
     ::btnDone:disable()
   ENDIF

RETURN self

METHOD PrinterConfig:OnPrinterSelected(printerCombo, formCombo, formsArray)
   LOCAL oPrinter := XbpPrinter():New():Create(printerCombo:XbpSLE:getData()), nIndex

   formCombo:clear()
   formsArray[2] := {}
   formsArray[3] := {}
   AEval(oPrinter:forms(), {|x| formCombo:addItem(x[2]), AAdd(formsArray[2], x[1]), AAdd(formsArray[3], x[2]) })
   nIndex := AScan(formsArray[2], formsArray[1])
   formCombo:setData({ IIf(Empty(nIndex), 1, nIndex) })

RETURN

METHOD PrinterConfig:OnDoneBtnClicked()
   LOCAL nID

   //AEval(::owner:printers, {|x| IIf(x[1] <> NIL, x[1]:destroy(),)})
   AEval({::printer1, ::printer2}, {|x,i| ::owner:printers[i][1] := XbpPrinter():New():Create(x:XbpSLE:getData()),;
                                          ::owner:printers[i][2] := ::orient[i],;
                                          ::owner:printers[i][3] := ::forms[i][1],;
                                          ::owner:printers[i][4] := ::offset[i][1],;
                                          ::owner:printers[i][5] := ::offset[i][2] })

   PostAppEvent(xbeP_Close,,, self)

RETURN

//EOF
/////