//////////////////////////////////////////////////////////////////////
//
//  Copyright:
//        Your Copyright goes here., (c) 2000. All rights reserved.
//
//  Contents:
//        This is a standard console mode exe.
//
//////////////////////////////////////////////////////////////////////

#include "Common.ch"

/* This is our main procedure
 */
PROCEDURE Main(cPatchID)
   LOCAL logStruct := {;
                       { "RECNO", "N", 10, 0 },;
                       { "FIELDNO", "N", 3, 0 },;
                       { "ERROR", "C", 40, 0 };
                     }
   LOCAL bankStruct, infoStruct, oldStruct, newStruct
   LOCAL ranks := { {}, {} }, index

   SET COLLATION TO SYSTEM
   SET DATE TO GERMAN
   SET DELETED ON
   SET EXACT ON
   SET SMARTFILTER ON
   SET CHARSET TO OEM

   DbCreate("PATCHLOG.DBF", logStruct)
   USE "PATCHLOG.DBF" ALIAS log NEW SHARED

   DO CASE
   CASE "el_reestr" == cPatchID
     IF FExists("DBF\FAREREG.DBF")
       newStruct := {;
                      { "TIPBL", "N", 1, 0},;
                      { "S", "C", 6, 0},;
                      { "N", "N", 10, 0},;
                      { "PERSONID", "N", 6, 0},;
                      { "PENSID", "N", 6, 0},;
                      { "PG", "N", 6, 0},;
                      { "RELATION", "N", 2, 0},;
                      { "FAMILY", "C", 20, 0},;
                      { "NAME", "C", 15, 0},;
                      { "NAME2", "C", 15, 0},;
                      { "BIRTH", "D", 8, 0},;
                      { "STATUS", "N", 2, 0},;
                      { "YEAR", "N", 4, 0},;
                      { "MODE", "N", 1, 0},;
                      { "CODE", "N", 5, 1},;
                      { "SUMM", "N", 12, 2},;
                      { "DISTRICT", "N", 2, 0},;
                      { "BANK", "C", 10, 0},;
                      { "ACCOUNT", "C", 20, 0},;
                      { "NOTE", "N", 1, 0 },;
                      { "DATE", "D", 8, 0},;
                      { "USER", "N", 4, 0};
                     }

       FRename("DBF\FAREREG.DBF", "DBF\FAREREG.OLD")

       DbCreate(("DBF\FAREREG.DBF"), newStruct)
       USE "DBF\FAREREG.DBF" ALIAS reg NEW EXCLUSIVE

       reg->(DbImport("DBF\FAREREG.OLD"))
       reg->(DbGoTop())
       DO WHILE !reg->(Eof())
         IF !Empty(reg->S) .AND. !Empty(reg->N)
           reg->TIPBL := 1
         ELSE
           reg->TIPBL := 0
           log->(DbAppend())
           log->RECNO := reg->(RecNo())
           log->FIELDNO := 1
           log->ERROR = "EMPTY S+N"
         ENDIF
         reg->(DbSkip())
       ENDDO

      OrdCreateEx("DBF\FREGFAM.NTX", "(Str(PG, 6) + Str(PENSID, 6) + Str(YEAR, 4))",, .T.)

       reg->(DbCloseArea())
     ENDIF
     IF FExists("DBF\PAYPARAM.DBF")
       newStruct := {;
                      { "TIPBL", "N", 1, 0},;
                      { "S", "C", 6, 0},;
                      { "N", "N", 10, 0},;
                      { "NAME", "C", 10, 0},;
                      { "TYPE", "C", 1, 0},;
                      { "SIZE", "N", 5, 2},;
                      { "VALUE", "C", 20, 0};
                     }

       FRename("DBF\PAYPARAM.DBF", "DBF\PAYPARAM.OLD")

       DbCreate(("DBF\PAYPARAM.DBF"), newStruct)
       USE "DBF\PAYPARAM.DBF" ALIAS params NEW EXCLUSIVE

       params->(DbImport("DBF\PAYPARAM.OLD"))
       params->(DbGoTop())
       DO WHILE !params->(Eof())
         IF !Empty(params->S) .AND. !Empty(params->N)
           params->TIPBL := 1
           IF params->NAME = "EXTRA_ORIG"
             params->VALUE := "1" + params->VALUE
             params->SIZE := params->SIZE + 1
           ENDIF
         ELSE
           params->TIPBL := 0
           log->(DbAppend())
           log->RECNO := reg->(RecNo())
           log->FIELDNO := 1
           log->ERROR = "EMPTY S+N"
         ENDIF
         params->(DbSkip())
       ENDDO

      OrdCreateEx("DBF\PAYPARAM.NTX", "(Str(TIPBL, 1) + S + Str(N, 10))",, .T.)

       params->(DbCloseArea())
     ENDIF
   CASE "rank_codes" == cPatchID
      IF FExists("DBF\CIVPENS.DBF")
       newStruct := {;
                      { "ID", "N", 6, 0},;
                      { "FAMILY", "C", 20, 0},;
                      { "NAME", "C", 15, 0},;
                      { "NAME2", "C", 15, 0},;
                      { "BORN", "D", 8, 0},;
                      { "STATUS", "N", 2, 0},;
                      { "RN", "N", 2, 0},;
                      { "RANG", "N", 4, 1},;
                      { "VYEAR", "N", 2, 0},;
                      { "VKAL", "N", 2, 0},;
                      { "WRK", "N", 1, 0},;
                      { "STUWOL", "C", 5, 0},;
                      { "DATE", "D", 8, 0},;
                      { "USER", "N", 4, 0};
                     }

       USE "GLOSSARY\GLOS_B.DBF" ALIAS rank NEW SHARED

       rank->(DbGoTop())
       DO WHILE !rank->(Eof())
         IF !Empty(rank->DBRANG)
           AAdd(ranks[1], rank->DBRANG)
           AAdd(ranks[2], rank->KOD)
         ENDIF
         rank->(DbSkip())
       ENDDO
       rank->(DbCloseArea())

       FRename("DBF\CIVPENS.DBF", "DBF\CIVPENS.OLD")

       USE "DBF\CIVPENS.OLD" ALIAS old NEW SHARED

       DbCreate(("DBF\CIVPENS.DBF"), newStruct)
       USE "DBF\CIVPENS.DBF" ALIAS civ NEW SHARED

       oldStruct := old->(DbStruct())
       old->(DbGoTop())
       DO WHILE !old->(Eof())
         civ->(DbAppend())
         AEval(oldStruct, {|x,i| civ->(FieldPut(i, old->(FieldGet(i)))) }, 1, 7)
         index = IIf(Empty(old->ZVAN) .OR. old->ZVAN > Len(ranks[1]), 0, ranks[2][old->ZVAN])
         IF index < 1
           log->(DbAppend())
           log->RECNO = old->(RecNo())
           log->FIELDNO = 8
           log->ERROR = " "
         ELSE
           civ->RANG = index
         ENDIF
         AEval(oldStruct, {|x,i| civ->(FieldPut(i, old->(FieldGet(i)))) }, 9, 6)

         old->(DbSkip())
       ENDDO

      OrdCreateEx("DBF\CPENSID.NTX", "(ID)", "cpensid", .T.)
      OrdCreateEx("DBF\CPENSFIO.NTX", "(FAMILY + NAME + NAME2)", "cpensfio", .T.)

       old->(DbCloseArea())
       civ->(DbCloseArea())
     ENDIF
   CASE "1" == cPatchID
     IF !FExists("DBF\CIVINFO.DBF") .AND. FExists("DBF\CIVACNT.DBF")
       infoStruct := {;
                       { "PERSONID", "N", 6, 0},;
                       { "PENSID", "N", 6, 0},;
                       { "PG", "N", 6, 0},;
                       { "RELATION", "N", 2, 0},;
                       { "FAMILY", "C", 20, 0},;
                       { "NAME", "C", 15, 0},;
                       { "NAME2", "C", 15, 0},;
                       { "IND", "N", 6, 0},;
                       { "ADDRESS", "C", 40, 0},;
                       { "HOUSE", "C", 7, 0},;
                       { "CORPUS", "C", 4, 0},;
                       { "FLAT", "C", 4, 0},;
                       { "TH", "N", 7, 0},;
                       { "TW", "N", 7, 0},;
                       { "TM", "C", 11, 0},;
                       { "FILIAL", "C", 10, 0},;
                       { "NOLIC", "C", 20, 0},;
                       { "DATE", "D", 8, 0},;
                       { "USER", "N", 4, 0};
                     }

       USE "DBF\CIVACNT.DBF" ALIAS bank NEW SHARED
       OrdCreateEx("DBF\CIVACNT.NTX", "(Str(PERSONID, 6) + Str(PENSID, 6) + Str(PG, 6) + Str(RELATION, 2) + FAMILY + NAME + NAME2)")
       SET INDEX TO "DBF\CIVACNT.NTX"

       DbCreate(("DBF\CIVINFO.DBF"), infoStruct)
       USE "DBF\CIVINFO.DBF" ALIAS info NEW SHARED

       bankStruct := bank->(DbStruct())
       bank->(DbGoTop())
       DO WHILE !bank->(Eof())
         info->(DbAppend())
         AEval(bankStruct, {|x,i| info->(FieldPut(i, bank->(FieldGet(i)))) }, 1, 7)
         AEval(bankStruct, {|x,i| info->(FieldPut(i + 8, bank->(FieldGet(i)))) }, 8, 4)

         bank->(DbSkip())
       ENDDO

       OrdCreateEx("DBF\CIVINFO.NTX", "(Str(PERSONID, 6) + Str(PENSID, 6) + Str(PG, 6) + Str(RELATION, 2) + FAMILY + NAME + NAME2)",, .T.)

       bank->(DbCloseArea())
       info->(DbCloseArea())
     ENDIF
   ENDCASE

   log->(DbCloseArea())
   /* $TODO: place your application code here */
RETURN