#include "Common.ch"
#include "frdbrtn.ch"

PROCEDURE FrdbInitStructures()

   PUBLIC g_aBufDbStruct := {;
                              { "PERSONID", "N", 10, 0},;
                              { "PENSID", "N", 6, 0},;
                              { "PG", "N", 6, 0},;
                              { "RELATION", "N", 2, 0},;
                              { "FAMILY", "C", 20, 0},;
                              { "NAME", "C", 15, 0},;
                              { "NAME2", "C", 15, 0},;
                              { "BIRTH", "D", 8, 0},;
                              { "STATUS", "N", 2, 0},;
                              { "PAID", "L", 1, 0},;
                              { "FOUND", "L", 1, 0},;
                              { "PAY", "L", 1, 0},;
                              { "NOTE", "N", 2, 0};
                            }

   PUBLIC g_aGUIDStrgDbStruct := {;
                                   { "ID", "N", 6, 0},;
                                   { "NAME", "C", 20, 0},;
                                   { "VALUE", "N", 20, 0},;
                                   { "STRING", "C", 40, 0};
                                 }
   PUBLIC g_aRegDbStruct := {;
                              { "TIPBL", "N", 1, 0},;
                              { "S", "C", 6, 0},;
                              { "N", "N", 10, 0},;
                              { "PERSONID", "N", 6, 0},;
                              { "PENSID", "N", 6, 0},;
                              { "PG", "N", 6, 0},;
                              { "RELATION", "N", 2, 0},;
                              { "FAMILY", "C", 20, 0},;
                              { "NAME", "C", 15, 0},;
                              { "NAME2", "C", 15, 0},;
                              { "BIRTH", "D", 8, 0},;
                              { "STATUS", "N", 2, 0},;
                              { "YEAR", "N", 4, 0},;
                              { "MODE", "N", 1, 0},;
                              { "CODE", "N", 5, 1},;
                              { "SUMM", "N", 12, 2},;
                              { "DISTRICT", "N", 2, 0},;
                              { "BANK", "C", 10, 0},;
                              { "ACCOUNT", "C", 20, 0},;
                              { "NOTE", "N", 1, 0 },;
                              { "DATE", "D", 8, 0},;
                              { "USER", "N", 4, 0};
                            }

   PUBLIC g_aPersDbStruct := {;
                            { "ID", "N", 10, 0},;
                            { "PENSID", "N", 6, 0},;
                            { "PG", "N", 6, 0},;
                            { "RELATION", "N", 2, 0},;
                            { "FAMILY", "C", 20, 0},;
                            { "NAME", "C", 15, 0},;
                            { "NAME2", "C", 15, 0},;
                            { "BIRTH", "D", 8, 0},;
                            { "STATUS", "N", 2, 0},;
                            { "DATE", "D", 8, 0},;
                            { "USER", "N", 4, 0};
                          }

   PUBLIC g_aCivDbStruct := {;
                           { "ID", "N", 6, 0},;
                           { "FAMILY", "C", 20, 0},;
                           { "NAME", "C", 15, 0},;
                           { "NAME2", "C", 15, 0},;
                           { "BORN", "D", 8, 0},;
                           { "STATUS", "N", 2, 0},;
                           { "RN", "N", 2, 0},;
                           { "RANG", "N", 4, 1},;
                           { "VYEAR", "N", 2, 0},;
                           { "VKAL", "N", 2, 0},;
                           { "WRK", "N", 1, 0},;
                           { "STUWOL", "C", 5, 0},;
                           { "DATE", "D", 8, 0},;
                           { "USER", "N", 4, 0};
                         }

   PUBLIC g_aInfoDbStruct := {;
                            { "PERSONID", "N", 6, 0},;
                            { "PENSID", "N", 6, 0},;
                            { "PG", "N", 6, 0},;
                            { "RELATION", "N", 2, 0},;
                            { "FAMILY", "C", 20, 0},;
                            { "NAME", "C", 15, 0},;
                            { "NAME2", "C", 15, 0},;
                            { "IND", "N", 6, 0},;
                            { "ADDRESS", "C", 40, 0},;
                            { "HOUSE", "C", 7, 0},;
                            { "CORPUS", "C", 4, 0},;
                            { "FLAT", "C", 4, 0},;
                            { "TH", "N", 7, 0},;
                            { "TW", "N", 7, 0},;
                            { "TM", "C", 11, 0},;
                            { "FILIAL", "C", 10, 0},;
                            { "NOLIC", "C", 20, 0},;
                            { "DATE", "D", 8, 0},;
                            { "USER", "N", 4, 0};
                           }

   PUBLIC g_aParamsDbStruct := {;
                              { "TIPBL", "N", 1, 0},;
                              { "S", "C", 6, 0},;
                              { "N", "N", 10, 0},;
                              { "NAME", "C", 10, 0},;
                              { "TYPE", "C", 1, 0},;
                              { "SIZE", "N", 5, 2},;
                              { "VALUE", "C", 20, 0};
                            }

   PUBLIC g_cSeries := ""
   PUBLIC g_nNumber := 0

RETURN

FUNCTION FrdbCheckPayParams(nBlank, cSer, nNumber, aParams, aActions)
   LOCAL aResult := {}
   LOCAL cSeek := Str(nBlank, 1) + cSer + Str(nNumber, 10), nIndex, nActionCount := IIf(Empty(aActions), 0, Len(aActions))

//   cSeek := reg->S + Str(reg->N, 10)
   IF params->(DbSeek(cSeek))
     DO WHILE !params->(Eof()) .AND. Str(params->TIPBL, 1) + params->S + Str(params->N, 10) == cSeek
       nIndex := AScan(aParams, params->NAME)
       IF nIndex > 0 .AND. !(nIndex $ aResult)
         AAdd(aResult, nIndex)
         IIf(nIndex > nActionCount .OR. Empty(aActions[nIndex]),, Eval(aActions[nIndex]))
       ENDIF
       params->(DbSkip())
     ENDDO
   ENDIF

RETURN aResult

FUNCTION FrdbGetInfo(aRecord)
   LOCAL aResult := { 0, "", "", "", "", 0, 0, "", "    /     ", ""}
   LOCAL cSeek := Str(aRecord[REGFIELD_PERSONID], 6) + Str(aRecord[REGFIELD_PENSID], 6) + Str(aRecord[REGFIELD_PG], 6) + Str(aRecord[REGFIELD_RELATION], 2) +;
                  aRecord[REGFIELD_FAMILY] + aRecord[REGFIELD_NAME] + aRecord[REGFIELD_NAME2]

   IF !Empty(aRecord[REGFIELD_PG]) .AND. dbf->(DbSeek(aRecord[REGFIELD_PG]))
     aResult := { dbf->IND, AllTrim(dbf->ADDRESS), AllTrim(dbf->HOUSE), AllTrim(dbf->CORPUS), AllTrim(dbf->FLAT),;
                  dbf->TH, dbf->TW, dbf->TM,;
                  dbf->FILIAL, dbf->NOLIC }
   ELSEIF info->(DbSeek(cSeek))
     aResult := { info->IND, AllTrim(info->ADDRESS), AllTrim(info->HOUSE), AllTrim(info->CORPUS), AllTrim(info->FLAT),;
                  info->TH, info->TW, info->TM,;
                  info->FILIAL, info->NOLIC }
   ENDIF

RETURN aResult

FUNCTION FrdbGenerateSeriesAndNumber(cSeries, nNumber)
   LOCAL cID

   cSeries := ""
   nNumber := 0
/*
   IF !id->(DbSeek("ELREGISTRYPAYMENT"))
     RETURN .F.
   ENDIF

   FOR i := 1 TO 3
     IF id->(RLock())
       EXIT
     ELSEIF i == 3
       RETURN .F.
     ENDIF
     Sleep(100 * i)
   NEXT

   id->VALUE := id->VALUE + 1
   cID := Str(id->VALUE, 13)

   cSeries := g_cSeries := Left(cID, 6)
   nNumber := g_nNumber := Char2Var(Right(cID, 7), "N")

   id->(DbUnlock())
*/
RETURN .T.