#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "XBPDEV.CH"
#include "frdbrtn.ch"

PROCEDURE PrintBlank(oWnd, cPrinterName, nOrient, nForm, aOffset, aRecord, cUser, cBank)
   LOCAL oPrinter, oPS, aSize, aPos, aFonts := {}
   LOCAL cPG, cFIO, cComment, cSumm, cSummCent, cSummProp, nIndex, nOffset
   LOCAL aBankLines := { "", "" }, aSummLines := { "", "" }

   oPrinter := XbpPrinter():New():Create(cPrinterName)
   // Create a new presentation space
   oPS   := XbpPresSpace():new()
   // Size of printable region on paper
   oPrinter:setOrientation(nOrient)
   oPrinter:setFormSize(nForm)
   aSize := oPrinter:paperSize()
   aSize := { aSize[5] - aSize[3], aSize[6] - aSize[4]  }

   oPS:create( oPrinter, aSize, GRA_PU_LOMETRIC )
   AEval({40, 45, 50, 55, 65, 80 }, {|x, i| AAdd(aFonts, XbpFont():new()),;
                                i := Len(aFonts),;
                                aFonts[i]:familyName := "Arial Narrow",;
                                aFonts[i]:height := x,;
                                aFonts[i]:create() })

   AAdd(aFonts, XbpFont():new())
   i := Len(aFonts)
   aFonts[i]:familyName := "Microsoft Sans Serif"
   aFonts[i]:width := 17
   aFonts[i]:height := 65
   aFonts[i]:bold := .F.
   aFonts[i]:italic := .T.
   aFonts[i]:create()

   AEval({ { 600 / 50,  40 }, { 1100 / 50, 80 } }, {|x, i| AAdd(aFonts, XbpFont():new()),;
                             i := Len(aFonts),;
                             aFonts[i]:familyName := "Arial Narrow",;
                             aFonts[i]:width := x[1],;
                             aFonts[i]:height := x[2],;
                             aFonts[i]:bold := .F.,;
                             aFonts[i]:create() })

   nIndex := At(" (", cBank)
   IF nIndex > 0
     aBankLines[1] := Left(cBank, nIndex - 1)
     aBankLines[2] := SubStr(cBank, nIndex + 1)
   ELSE
     aBankLines[1] := cBank
   ENDIF
   cPG := IIf(Empty(aRecord[REGFIELD_PG]), "", SYS_LITERA + "-" + AllTrim(Str(aRecord[REGFIELD_PG])))
   cFIO := MergeFIO(aRecord[REGFIELD_FAMILY], aRecord[REGFIELD_NAME], aRecord[REGFIELD_NAME2], "")

   cComment := { "   ..  ", "  " }[aRecord[REGFIELD_MODE] + 1]
   cSumm := AllTrim(Str(Int(aRecord[REGFIELD_SUMM])))
   cSummCent := Right(Str(aRecord[REGFIELD_SUMM], 12, 2), 2)
   cSummProp := NumberInWords(Int(aRecord[REGFIELD_SUMM])) + " . " + cSummCent + " ."
   nIndex := At("", cSummProp)
   IF aRecord[REGFIELD_SUMM] > 999999.99
   ELSEIF nIndex > 0
     nIndex := At(" ", cSummProp, nIndex)
     IF nIndex > 0
       aSummLines[1] := Left(cSummProp, nIndex - 1)
       aSummLines[2] := SubStr(cSummProp, nIndex)
     ELSE
       aSummLines[1] := cSummProp
     ENDIF
   ELSE
     aSummLines[1] := cSummProp
   ENDIF

   nOffset := aOffset[1]
   aSize[2] += aOffset[2]

   oPrinter:startDoc()
   GraSetFont(oPS, aFonts[1])
   GraStringAt(oPS, { nOffset + 1300, aSize[2]-300 }, STR_VK )
   GraStringAt(oPS, { nOffset + 1300, aSize[2]-740 }, aBankLines[1])
   GraStringAt(oPS, { nOffset + 1300, aSize[2]-790 }, aBankLines[2])
   GraStringAt(oPS, { nOffset + 1430, aSize[2]-1025 }, Upper(RTrim(PEV_PARAMS[2])))
   GraStringAt(oPS, { nOffset + 1450, aSize[2]-1125 }, aSummLines[1])
   GraStringAt(oPS, { nOffset + 1370, aSize[2]-1195 }, aSummLines[2])
   GraSetFont(oPS, aFonts[2])
   GraStringAt(oPS, { nOffset + 300, aSize[2]-300 }, STR_VK )
   GraStringAt(oPS, { nOffset + 950, aSize[2]-800 }, STR_CENTR )
   IIf(Len(cFIO) > 30,, GraStringAt(oPS, { nOffset + 1450, aSize[2]-965 }, cFIO))
   GraSetFont(oPS, aFonts[3])
   GraStringAt(oPS, { nOffset + 30, aSize[2]-730 }, cBank)
   GraStringAt(oPS, { nOffset + 40, aSize[2]-1240 }, Str(Day(aRecord[REGFIELD_DATE]), 2) )
   GraStringAt(oPS, { nOffset + 200, aSize[2]-1240 }, MakeMonth(aRecord[REGFIELD_DATE]) )
   GraStringAt(oPS, { nOffset + 400, aSize[2]-1240 }, Str(Year(aRecord[REGFIELD_DATE]), 4) )
   GraSetFont(oPS, aFonts[4])
   GraStringAt(oPS, { nOffset + 1350, aSize[2]-160 }, ". " + cUser )
   GraStringAt(oPS, { nOffset + 500, aSize[2]-670 }, cPG)
   GraStringAt(oPS, { nOffset + 1790, aSize[2]-700 }, cPG)
   GraStringAt(oPS, { nOffset + 700, aSize[2]-800 }, PEV_PARAMS[7])
   GraStringAt(oPS, { nOffset + 1640, aSize[2]-820 }, STR_CENTR )
   GraStringAt(oPS, { nOffset + 120, aSize[2]-1020 }, Upper(RTrim(PEV_PARAMS[2])))
   GraStringAt(oPS, { nOffset + 120, aSize[2]-1060 }, cComment)
   GraSetFont(oPS, aFonts[5])
   GraStringAt(oPS, { nOffset + 460, aSize[2]-610 }, cSumm )
   GraStringAt(oPS, { nOffset + 750, aSize[2]-610 }, cSummCent )
   GraStringAt(oPS, { nOffset + 1530, aSize[2]-640 }, cSumm )
   GraStringAt(oPS, { nOffset + 1820, aSize[2]-640 }, cSummCent )
   GraSetFont(oPS, aFonts[6])
   IIf(Len(cFIO) > 30,, GraStringAt(oPS, { nOffset + 150, aSize[2]-950 }, cFIO))
   GraSetFont(oPS, aFonts[7])
   GraStringAt(oPS, { nOffset + 170, aSize[2]-1110 }, aSummLines[1])
   GraStringAt(oPS, { nOffset + 70, aSize[2]-1180 }, aSummLines[2])
   GraSetFont(oPS, aFonts[8])
   IIf(Len(cFIO) > 30, GraStringAt(oPS, { nOffset + 1450, aSize[2]-980 }, cFIO),)
   GraSetFont(oPS, aFonts[9])
   IIf(Len(cFIO) > 30, GraStringAt(oPS, { nOffset + 150, aSize[2]-950 }, cFIO),)
   oPrinter:endDoc()

   IF 0 == aRecord[REGFIELD_MODE] .AND. TurnOverPage(oWnd, oPrinter)
     cBank := IIf(SubStr(aRecord[REGFIELD_BANK], 6, 4) == "0000", cBank := Left(aRecord[REGFIELD_BANK], 4), aRecord[REGFIELD_BANK])
     oPrinter:startDoc()
     GraSetFont(oPS, aFonts[1])
     GraStringAt(oPS, { nOffset + 50, aSize[2]-330 }, "  ")
     GraStringAt(oPS, { nOffset + 50, aSize[2]-380 }, "    " + cBank)
     GraStringAt(oPS, { nOffset + 50, aSize[2]-430 }, "   " + aRecord[REGFIELD_ACCOUNT])
     GraStringAt(oPS, { nOffset + 50, aSize[2]-530 }, ".  ")
     GraStringAt(oPS, { nOffset + 50, aSize[2]-630 }, "")
     GraSetFont(oPS, aFonts[2])
     GraStringAt(oPS, { nOffset + 900, aSize[2]-140 }, "  ")
     GraStringAt(oPS, { nOffset + 900, aSize[2]-210 }, "    " + cBank)
     GraStringAt(oPS, { nOffset + 900, aSize[2]-280 }, "   " + aRecord[REGFIELD_ACCOUNT])

     oPrinter:endDoc()
   ENDIF

   AEval(aFonts, {|x| x:destroy() })
   oPS:destroy()
   oPrinter:destroy()

RETURN

PROCEDURE PrintCalc(oWnd, cPrinterName, nOrient, nForm, aOffset, aRecord, aParams, aNotes, aInfo, cUser)
   LOCAL oPrinter, oPS, aSize, aPos, oFont, aAttr
   LOCAL cSumm, nIndex, nOffset := 0, nTemp, lineNo, paramPos

   oPrinter := XbpPrinter():New():Create(cPrinterName)
   // Create a new presentation space
   oPS   := XbpPresSpace():new()
   // Size of printable region on paper
   oPrinter:setOrientation(nOrient)
   oPrinter:setFormSize(nForm)
   aSize := oPrinter:paperSize()
   aSize := { aSize[5] - aSize[3], aSize[6] - aSize[4]  }

   oPS:create( oPrinter, aSize, GRA_PU_LOMETRIC )

   oFont := XbpFont():new()
   oFont:familyName := "Times New Roman"
   oFont:height := 50
   oFont:create()

   cSumm := AllTrim(Str(aRecord[REGFIELD_SUMM], 12, 2))

   aAttr := Array(GRA_AL_COUNT)
   aAttr[GRA_AL_WIDTH] := GRA_LINEWIDTH_THICK

   aSize[2] += aOffset[2]

   oPrinter:startDoc()
   GraSetFont(oPS, oFont)
   //     
   AEval(aNotes, {|str, i| GraStringAt(oPS, { aOffset[1] + 1400, aSize[2]-110-60*(i-1) }, str) })
   // 
   GraStringAt(oPS, { aOffset[1] + 1000, aSize[2]-230 }, "" )
   IF aRecord[REGFIELD_TIPBL] == 1
     GraStringAt(oPS, { aOffset[1] + 400, aSize[2]-370 }, "  " + AllTrim(aRecord[REGFIELD_S]) + "  " +;
                                                          AllTrim(Str(aRecord[REGFIELD_N])) +;
                                                          "      " )
   ELSE
     GraStringAt(oPS, { aOffset[1] + 400, aSize[2]-370 }, "   .       " )
   ENDIF
   GraStringAt(oPS, { aOffset[1] + 300, aSize[2]-430 }, "      (  -")
   GraStringAt(oPS, { aOffset[1] + 300, aSize[2]-490 }, "  ,    )")
   nOffset := 550
   //   
   AEval(aInfo, {|str, i| GraStringAt(oPS, { aOffset[1] + 300, aSize[2]-nOffset }, str), nOffset += 60 })
   nOffset += 80
   nTemp := nOffset - 40
   GraSetAttrLine(oPS, aAttr)
   GraLine(oPS, { aOffset[1] + 300, aSize[2]-nTemp }, { aSize[1] - 100, aSize[2]-nTemp })
   GraStringAt(oPS, { aOffset[1] + 330, aSize[2]-(nOffset + 25) }, " /")
   GraStringAt(oPS, { aOffset[1] + 555, aSize[2]-nOffset }, "")
   GraStringAt(oPS, { aOffset[1] + 490, aSize[2]-(nOffset + 40) }, "")
   GraStringAt(oPS, { aOffset[1] + 1100, aSize[2]-(nOffset + 25) }, "")
   GraStringAt(oPS, { aOffset[1] + 1650, aSize[2]-(nOffset + 25) }, "")
   GraLine(oPS, { aOffset[1] + 300, aSize[2]-(nOffset + 60) }, { aSize[1] - 100, aSize[2]-(nOffset + 60) })
   FOR paramPos := 1 TO Len(aParams)
     nOffset += 70
     GraStringAt(oPS, { aOffset[1] + 380, aSize[2]-(nOffset + 40) }, AllTrim(Str(paramPos)))
     GraStringAt(oPS, { aOffset[1] + 560, aSize[2]-(nOffset + 40) }, {"/", "", "", ".", "", ""}[At(aParams[paramPos][1], "")])
     GraStringAt(oPS, { aOffset[1] + 730, aSize[2]-(nOffset + 40) }, AllTrim(Str(aParams[paramPos][2], 9, 2)) + " .")
     GraLine(oPS, { aOffset[1] + 300, aSize[2]-(nOffset + 60) }, { aSize[1] - 100, aSize[2]-(nOffset + 60) })
   NEXT
   nOffset += 70
   GraStringAt(oPS, { aOffset[1] + 320, aSize[2]-(nOffset + 40) }, "")
   GraStringAt(oPS, { aOffset[1] + 730, aSize[2]-(nOffset + 40) }, cSumm + " .")
   GraLine(oPS, { aOffset[1] + 300, aSize[2]-(nOffset + 60) }, { aSize[1] - 100, aSize[2]-(nOffset + 60) })
   GraLine(oPS, { aOffset[1] + 300, aSize[2]-nTemp }, { aOffset[1] + 300, aSize[2]-(nOffset + 60) })
   GraLine(oPS, { aOffset[1] + 480, aSize[2]-nTemp }, { aOffset[1] + 480, aSize[2]-(nOffset + 60) })
   GraLine(oPS, { aOffset[1] + 700, aSize[2]-nTemp }, { aOffset[1] + 700, aSize[2]-(nOffset + 60) })
   GraLine(oPS, { aOffset[1] + 1640, aSize[2]-nTemp }, { aOffset[1] + 1640, aSize[2]-(nOffset + 60) })
   GraLine(oPS, { aSize[1] - 100, aSize[2]-nTemp }, { aSize[1] - 100, aSize[2]-(nOffset + 60) })
   GraStringAt(oPS, { aOffset[1] + 400, aSize[2]-(nOffset + 200) }, " __________________ / " + cUser + " /")
   GraStringAt(oPS, { aOffset[1] + 400, aSize[2]-(nOffset + 260) }, "() " + IIf(Empty(LIST_STR11),;
                                                                                         "__________________",;
                                                                                         LIST_STR11))
   GraStringAt(oPS, { aOffset[1] + 400, aSize[2]-(nOffset + 380) }, MakeDate(aRecord[REGFIELD_DATE]))

   oPrinter:endDoc()

   // Housekeeping
   oFont:destroy()
   oPS:destroy()
   oPrinter:destroy()

RETURN

PROCEDURE PrintNotification(oWnd, cPrinterName, nOrient, nForm, aOffset, aRecord, cUser, cBank, aAddress)
   LOCAL oPrinter, oPS, aSize, aPos, oFont
   LOCAL cFIO, cSumm, cAction, aTmp

   oPrinter := XbpPrinter():New():Create(cPrinterName)
   // Create a new presentation space
   oPS   := XbpPresSpace():new()
   // Size of printable region on paper
   oPrinter:setOrientation(nOrient)
   oPrinter:setFormSize(nForm)
   aSize := oPrinter:paperSize()
   aSize := { aSize[5] - aSize[3], aSize[6] - aSize[4]  }

   oPS:create( oPrinter, aSize, GRA_PU_LOMETRIC )

   oFont := XbpFont():new()
   oFont:familyName := "Times New Roman"
   oFont:height := 50
   oFont:create()

   cFIO := MergeFIO(aRecord[REGFIELD_FAMILY], aRecord[REGFIELD_NAME], aRecord[REGFIELD_NAME2], "")
   cBank := StrTran(cBank, "", "    ")

   cSumm := AllTrim(Str(aRecord[REGFIELD_SUMM], 12, 2))
   cAction := { "      " + aRecord[REGFIELD_ACCOUNT], "  " }[aRecord[REGFIELD_MODE] + 1]

   aSize[2] += aOffset[2]

   oPrinter:startDoc()
   GraSetFont(oPS, oFont)
   GraStringAt(oPS, { aOffset[1] + 300, aSize[2]-250 }, STR_VK )
   GraStringAt(oPS, { aOffset[1] + 500, aSize[2]-350 }, STR_OUTGOINGNUMBER )
   GraStringAt(oPS, { aOffset[1] + 520, aSize[2]-400 }, MakeDate(Date()) )
   GraStringAt(oPS, { aOffset[1] + 450, aSize[2]-450 }, STR_S1 )
   GraStringAt(oPS, { aOffset[1] + 380, aSize[2]-500 }, STR_S2 )

   GraStringAt(oPS, { aOffset[1] + 1280, aSize[2]-250 }, ". " + Left(cFIO, At(" ", cFIO)) )
   GraStringAt(oPS, { aOffset[1] + 1280, aSize[2]-300 }, SubStr(cFIO, At(" ", cFIO) + 1) )
   GraStringAt(oPS, { aOffset[1] + 1150, aSize[2]-350 }, ": " + IIf(Empty(aAddress[1]),"", Str(aAddress[1],6) + " ") + aAddress[2] )
   GraStringAt(oPS, { aOffset[1] + 1280, aSize[2]-400 }, IIf(Empty(aAddress[3]), "", ". " + aAddress[3] + " ") +;
                                                         IIf(Empty(aAddress[4]), "", ". " + aAddress[4] + " ") +;
                                                         IIf(Empty(aAddress[5]), "", ". " + aAddress[5]) )

   GraStringAt(oPS, { aOffset[1] + 900, aSize[2]-650 }, "          " )
   IF aRecord[REGFIELD_TIPBL] == 1
     GraStringAt(oPS, { aOffset[1] + 650, aSize[2]-700 }, "     " )
   ENDIF

   GraStringAt(oPS, { aOffset[1] + 400, aSize[2]-800 }, ",    " + RTrim(PEV_PARAMS[2]) + "   " +;
                                                        cSumm + " ." )
   IF aRecord[REGFIELD_TIPBL] == 1
     GraStringAt(oPS, { aOffset[1] + 400, aSize[2]-850 }, "     . " +;
                                                          AllTrim(aRecord[REGFIELD_S]) + "  " + AllTrim(Str(aRecord[REGFIELD_N])) +;
                                                          "      " )
   ELSE
     GraStringAt(oPS, { aOffset[1] + 400, aSize[2]-850 }, "     .   " )
   ENDIF
   GraStringAt(oPS, { aOffset[1] + 300, aSize[2]-900 }, cBank + ".")
   GraStringAt(oPS, { aOffset[1] + 400, aSize[2]-950 }, "  " + cAction + ".")

   IF aRecord[REGFIELD_MODE] <> 1
     GraStringAt(oPS, { aOffset[1] + 300, aSize[2]-1000 }, "         ")
     GraStringAt(oPS, { aOffset[1] + 300, aSize[2]-1050 }, "       .")
     aSize[2] -= 100
   ENDIF

   AEval({LIST_STR1, LIST_STR2, "", LIST_STR3},;
         {|x,i| aTmp := GraQueryTextBox(oPS, x),;
                GraStringAt(oPS, { aOffset[1] + (aSize[1] - aTmp[3][1] + aTmp[1][1]) / 2, aSize[2]-1000-i*50 }, x) })

   GraStringAt(oPS, { aOffset[1] + 300, aSize[2]-1300 }, ". " + cUser)

   oPrinter:endDoc()

   // Housekeeping
   oFont:destroy()
   oPS:destroy()
   oPrinter:destroy()

RETURN