#include "Common.ch"
#include "frdbrtn.ch"

FUNCTION GetRelatives(nPG, nRel)
   LOCAL aResult := {}, lAdd, nDbPos

   nDbPos := dep->(RecNo())
   IF dep->(DbSeek(nPG))
     DO WHILE dep->PG = nPG
       IF NIL == nRel .OR. dep->A == nRel
         AAdd(aResult, { dep->A, dep->B, dep->C, dep->D, dep->E })
       ENDIF
       dep->(DbSkip())
     ENDDO
   ENDIF
   dep->(DbGoTo(nDbPos))

   nDbPos := rpd->(RecNo())
   IF rpd->(DbSeek(nPG))
     DO WHILE rpd->PG = nPG
       IF !Empty(rpd->GCONAME) .AND. (NIL == nRel .OR. rpd->RODST == nRel)
         lAdd := .T.
         AEval(aResult, {|x, i| IIf(x[1] == rpd->RODST .AND. x[2] == rpd->GCONAME .AND. x[3] == rpd->GNAME .AND. x[4] == rpd->GFNAME, lAdd := .F.,)})
         IIf(lAdd, AAdd(aResult, { rpd->RODST, rpd->GCONAME, rpd->GNAME, rpd->GFNAME, NIL }),)
       ENDIF
       rpd->(DbSkip())
     ENDDO
   ENDIF
   rpd->(DbGoTo(nDbPos))

RETURN aResult

FUNCTION MakeRelativeDesc(aRel)
RETURN Str(aRel[1], 2) + aRel[2] + aRel[3] + aRel[4] + IIf(Empty(aRel[5]), Space(10), DtoC(aRel[5]))

FUNCTION GetRelative(aRelatives, nRel, aExcludingList)
   LOCAL aResult, index

   FOR index := 1 TO Len(aRelatives)
     aResult := aRelatives[index]
     IF nRel == aResult[1] .AND. AScan(aExcludingList, MakeRelativeDesc(aResult)) == 0
       RETURN aResult
     ENDIF
   NEXT

RETURN {}

FUNCTION FindRelative(nPG, nRel)
   LOCAL aResult := {}, lAdd, nDbPos

   nDbPos := dep->(RecNo())
   IF dep->(DbSeek(nPG))
     DO WHILE dep->PG = nPG
       IF dep->A == nRel
         AAdd(aResult, { dep->B, dep->C, dep->D, dep->E })
       ENDIF
       dep->(DbSkip())
     ENDDO
   ENDIF
   dep->(DbGoTo(nDbPos))

   nDbPos := rpd->(RecNo())
   IF rpd->(DbSeek(nPG))
     DO WHILE rpd->PG = nPG
       IF !Empty(rpd->GCONAME) .AND. rpd->RODST == nRel
         lAdd := .T.
         AEval(aResult, {|x, i| IIf(x[1] == rpd->GCONAME .AND. x[2] == rpd->GNAME .AND. x[3] == rpd->GFNAME, lAdd := .F.,)})
         IIf(lAdd, AAdd(aResult, { rpd->GCONAME, rpd->GNAME, rpd->GFNAME, NIL }),)
       ENDIF
       rpd->(DbSkip())
     ENDDO
   ENDIF
   rpd->(DbGoTo(nDbPos))

RETURN aResult

FUNCTION CalcPensProc(nPensionType, nServiceTime, nInvGroup, nInvType, nDeathType)
   LOCAL nResult := 0

   DO CASE
   CASE nPensionType = 1
     nResult := Min(0.85, 0.50 + 0.03 * (nServiceTime - 20))
   CASE nPensionType = 2
     IF (nInvGroup = 0 .OR. nInvGroup = 1) .AND. nInvType = 0
       nResult := 0.85
     ELSEIF (nInvGroup = 0 .OR. nInvGroup = 1) .AND. nInvType = 1
       nResult := 0.75
     ELSEIF nInvGroup = 2 .AND. nInvType = 0
       nResult := 0.50
     ELSE
       nResult := 0.30
     ENDIF
   CASE nPensionType = 3
     nResult := IIf(nDeathType = 0, 0.30, 0.40)
   ENDCASE

RETURN nResult

FUNCTION CalcPension(nPostSalary, nRankSalary, nPNVL, nAllowance, nMROT, nPercent, nRK, nFactor)
   LOCAL nResult := 0
   LOCAL nTemp1, nLimit := 10 * nMROT

   nTemp := (nPostSalary * (1.0 + nFactor) + nRankSalary) * (1.00 + nPNVL) + nAllowance

   nResult := IIf(nMROT > 0 .AND. nTemp > nLimit, (nTemp + nLimit) / 2, nTemp) * nPercent * nRK

RETURN nResult

FUNCTION GetBank(nDistrict, cBankAndDesk, nPayMode, aDistricts, aBanks, aBanks2Districts)
   LOCAL cBank := IIf(cBankAndDesk <> NIL, Left(cBankAndDesk, 4), "")
   LOCAL cResult := IIf(Empty(cBank), "", " " + cBank)
   LOCAL nBankIndex, nIndex

   nBankIndex := AScan(aBanks2Districts[1], cBank)
   IF nBankIndex > 0
     cResult := aBanks[aBanks2Districts[2][nBankIndex][1]]
     nIndex := At("(", cResult)
     IIf(nIndex > 2, cResult := Left(cResult, nIndex - 2),)
   ENDIF

   IF nPayMode <> 0
     IIf(nDistrict <> NIL .AND. aBanks[nDistrict + 1] <> NIL, cResult := aBanks[nDistrict + 1],)
   ELSEIF nBankIndex > 0
     nIndex := AScan(aBanks2Districts[2][nBankIndex], nDistrict + 1)
     IIf(nIndex > 0, cResult := aBanks[aBanks2Districts[2][nBankIndex][nIndex]],)
   ENDIF

RETURN cResult