// make sure to link the correct libraries
#pragma Library( "XppUI2.LIB" )
#pragma Library( "Adac20b.lib" )

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "frdbrtn.ch"

STATIC g_oCreepingLineWnd

PROCEDURE ValidateSelection(combo, skipEmpty)
        AEval(combo:getData(), {|i| IIf(Empty(combo:getItem(i)),;
                  combo:setData(IIf(skipEmpty, { IIf(1 == i, i + 1, i - 1) }, {})),) })
RETURN

FUNCTION ValidateString(sle, validator, replacement)
   LOCAL tmp := { sle:getData(), sle:queryMarked() }, chr, str

   AAdd(tmp, SubStr(tmp[1], tmp[2][1] - 1))
   chr := Left(tmp[3], 1)
   IF Empty(chr) .OR. Eval(validator, chr, tmp)
     IF replacement <> NIL
       str := tmp[1]
       AEval(replacement, {|x| str := StrTran(str, x[1], x[2]) })
       sle:setData(str)
       AEval(tmp[2], {|x| x += Len(str) - Len(tmp[1]) },,, .T.)
       sle:setMarked(tmp[2])
     ENDIF
     RETURN chr
   ENDIF

   sle:setData(Left(tmp[1], tmp[2][1] - 2) + SubStr(tmp[3], 2))
   sle:setMarked({tmp[2][1] - 1, tmp[2][2] - 1})
RETURN chr

PROCEDURE FillComboBoxFromArray(array, combo, fmt)

   combo:clear()
   AEval(array, {|str, i| combo:addItem(IIf(Empty(str), "", IIf(fmt != NIL, Eval(fmt, str, i), str))) })

RETURN

PROCEDURE FillComboBoxFromListBox(source, dest)
   LOCAL itemPos

   dest:clear()
   FOR itemPos := 1 TO source:numItems()
     dest:addItem(source:getItem(itemPos))
   NEXT

RETURN

PROCEDURE ShowNotification(dlg, pos, msg, time)

        LOCAL oMsg, aSize, aTemp

        aTemp := SetTimerEvent(0)
        IF aTemp[2] != NIL
                Eval(aTemp[2])
        ENDIF

        oMsg := XbpStatic():new(dlg:drawingArea,,,,,.F.)
        oMsg:options := XBPSTATIC_TEXT_WORDBREAK
        oMsg:caption := msg
        oMsg:autoSize := .T.
//        oMsg:setColorBG(XBPSYSCLR_WINDOW)
        oMsg:setColorBG(GRA_CLR_RED)
        oMsg:setColorFG(GRA_CLR_YELLOW)
        oMsg:lbClick := {|mp1, mp2, obj| obj:hide(), obj:destroy() }
        oMsg:create()

        aSize := oMsg:currentSize()
        oMsg:setPos({ pos[1], pos[2] - aSize[2] })

        SetTimerEvent(IIf(time != NIL, time, 400), {|| Eval(IIf(oMsg:isVisible(),;
                                 {|| oMsg:hide(), oMsg:destroy(), SetTimerEvent(0) }, {|| oMsg:show() })) })

RETURN

FUNCTION ShowCreepingLine(text)
        STATIC oMsg
        LOCAL aPos[2], aSize, nHeight := 70, nWidth := 420

        // Get size of desktop window
        // to center the application window
        aSize := AppDesktop():currentSize()
        aPos := { Int((aSize[1] - nWidth) / 2), Int((aSize[2] - nHeight) / 2) }

        IF g_oCreepingLineWnd != NIL
                SetTimerEvent(0)
                oMsg:setCaption(text)
        ELSE
                // Create application window
                g_oCreepingLineWnd := XbpDialog():new()
                g_oCreepingLineWnd:titleBar := .F.
        g_oCreepingLineWnd:alwaysOnTop := .T.
                g_oCreepingLineWnd:create(,, aPos, { nWidth, nHeight }, { { XBP_PP_COMPOUNDNAME, "8.MS Sans Serif" } }, .F.)

                oMsg := XbpStatic():new(g_oCreepingLineWnd:drawingArea,, { 10, 20 }, { nWidth - 20, 20 })
                oMsg:options := XBPSTATIC_TEXT_CENTER + XBPSTATIC_TEXT_VCENTER
                oMsg:caption := text
                oMsg:create()
        ENDIF

        // Display application window and set focus to it
        g_oCreepingLineWnd:show()

        SetTimerEvent(15, {|| Eval({|s| oMsg:setCaption(Right(s, Len(s) - 1) + Left(s, 1))}, oMsg:caption) })

RETURN g_oCreepingLineWnd

PROCEDURE HideCreepingLine()

        IF g_oCreepingLineWnd != NIL
                SetTimerEvent(0)
//        g_oCreepingLineWnd:modalResult := XBP_MRESULT_OK
                g_oCreepingLineWnd:hide()
        ENDIF

RETURN

FUNCTION SetXbpData(map, db, recno, item, result)
   LOCAL nPos := AScan(map[1], item), oXbp, bSet, bGet
   LOCAL cFieldData, cFieldPos, fieldValue, tempValue

   IF(nPos <= 0)
     RETURN .F.
   ENDIF

   oXbp := map[2][nPos]
   bSet := map[3][nPos]
   bGet := map[4][nPos]

   &(db + "->(DbGoTo(" + AllTrim(Str(recno)) + "))")
   cFieldData := db + "->" + item
   cFieldPos := db + '->(FieldPos("' + item + '"))'

   fieldValue := NIL
   IF &(cFieldPos) > 0
     fieldValue := &(cFieldData)
     tempValue := IIf(Empty(bSet), fieldValue, Eval(bSet, fieldValue))
     IIf(Empty(tempValue),, oXbp:setData(tempValue))
//   ELSE
//     oXbp:setColorFG(GRA_CLR_RED)
   ENDIF
   AAdd(result, fieldValue)

RETURN .T.